(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    694200,      17657]
NotebookOptionsPosition[    693074,      17629]
NotebookOutlinePosition[    693489,      17646]
CellTagsIndexPosition[    693446,      17643]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData["Quit"], "Input",
 CellChangeTimes->{{3.7780936291334476`*^9, 3.77809362978728*^9}},
 CellLabel->"In[4]:=",ExpressionUUID->"6d29c30a-8e23-49f2-89fa-23b59cb62cdf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"<<", "LieART`"}]], "Input",
 CellLabel->"In[1]:=",ExpressionUUID->"03d160bc-e790-44fd-9405-ff4c8bdf35a3"],

Cell[CellGroupData[{

Cell[BoxData[
 FormBox["\<\"LieART 1.1.5\"\>", TraditionalForm]], "Print",
 CellChangeTimes->{
  3.778093177389621*^9, {3.778093674456998*^9, 3.778093687202697*^9}, {
   3.77810095118239*^9, 3.7781009606774807`*^9}, 3.778101301432281*^9, 
   3.778175029065654*^9},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"d4c2939d-01fd-4da2-9615-817f73f9e859"],

Cell[BoxData[
 FormBox["\<\"last revised 7 August 2014\"\>", TraditionalForm]], "Print",
 CellChangeTimes->{
  3.778093177389621*^9, {3.778093674456998*^9, 3.778093687202697*^9}, {
   3.77810095118239*^9, 3.7781009606774807`*^9}, 3.778101301432281*^9, 
   3.77817502907561*^9},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"15bb44f9-b9f7-4e39-9f53-2a5edd4d067e"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Clear", "[", "Loop", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Clear", "[", "Three", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Clear", "[", "S", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Clear", "[", "CoSpinor", "]"}]}], "Input",
 CellChangeTimes->{{3.778091470010878*^9, 3.778091493427906*^9}},
 CellLabel->"In[2]:=",ExpressionUUID->"3f21a487-5bb4-4d94-92a1-88347adf60c6"],

Cell[CellGroupData[{

Cell["Run below : ", "Subsection",
 CellChangeTimes->{{3.778093583031706*^9, 3.778093624273761*^9}, {
  3.7780936570928097`*^9, 3.7780936593987217`*^9}, {3.7780937308788843`*^9, 
  3.778093732230048*^9}, {3.77810096578522*^9, 
  3.7781009669995832`*^9}},ExpressionUUID->"67e42ef8-af73-4eff-96a3-\
3ca683b0c331"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"wgt", "[", 
   RowBox[{
    RowBox[{"{", "x__", "}"}], ",", "Type_"}], "]"}], ":=", 
  RowBox[{"WeightSystem", "[", 
   RowBox[{
    RowBox[{"Irrep", "[", "Type", "]"}], "[", "x", "]"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"WS", "[", 
   RowBox[{"Alg_", ",", "rep_"}], "]"}], ":=", 
  RowBox[{"If", " ", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "rep", "]"}], "\[NotEqual]", "0"}], ",", 
    RowBox[{"wgt", "[", 
     RowBox[{"rep", ",", 
      RowBox[{"AlgebraClass", "[", "Alg", "]"}]}], "]"}], ",", 
    RowBox[{"WeightSystem", "[", 
     RowBox[{
      RowBox[{"Irrep", "[", "Alg", "]"}], "[", "rep", "]"}], "]"}]}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"\[Phi]", "[", "n_", "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    SubscriptBox["\[Phi]", "i"], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"v", "[", "x__", "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"x", "[", 
     RowBox[{"[", "i", "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", 
      RowBox[{"Length", "[", "x", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vec", "[", "alg_", "]"}], ":=", 
  RowBox[{"2", 
   RowBox[{"Sum", "[", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Phi]", "[", 
         RowBox[{"Length", "[", 
          RowBox[{"OrthogonalSimpleRoots", "[", "alg", "]"}], "]"}], "]"}], 
        ".", 
        RowBox[{"v", "[", 
         RowBox[{
          RowBox[{"PositiveRoots", "[", "alg", "]"}], "[", 
          RowBox[{"[", "j", "]"}], "]"}], "]"}]}], ")"}], "3"], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", 
       RowBox[{"Length", "[", 
        RowBox[{"PositiveRoots", "[", "alg", "]"}], "]"}]}], "}"}]}], 
    "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{"hyp", "[", 
   RowBox[{"Alg_", ",", "rep_"}], "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     SubscriptBox["s", "j"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Phi]", "[", 
         RowBox[{"Length", "[", 
          RowBox[{"OrthogonalSimpleRoots", "[", "Alg", "]"}], "]"}], "]"}], 
        ".", 
        RowBox[{"v", "[", 
         RowBox[{
          RowBox[{"WS", "[", 
           RowBox[{"Alg", ",", "rep"}], "]"}], "[", 
          RowBox[{"[", "j", "]"}], "]"}], "]"}]}], ")"}], "3"]}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "1", ",", 
      RowBox[{"Length", "[", 
       RowBox[{"WS", "[", 
        RowBox[{"Alg", ",", "rep"}], "]"}], "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Fp1", "[", 
   RowBox[{"alg_", ",", "mat_"}], "]"}], ":=", 
  RowBox[{
   FractionBox["1", "12"], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"vec", "[", "alg", "]"}], "-", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"mat", "[", 
           RowBox[{"[", "l", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], 
         RowBox[{"hyp", "[", 
          RowBox[{"alg", ",", 
           RowBox[{
            RowBox[{"mat", "[", 
             RowBox[{"[", "l", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{"s", "\[Rule]", 
          RowBox[{"s", "[", "l", "]"}]}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"l", ",", "1", ",", 
         RowBox[{"Length", "[", "mat", "]"}]}], "}"}]}], "]"}]}], 
    ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Phi]2", "[", 
   RowBox[{"n_", ",", "j_"}], "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    SubscriptBox["\[Phi]", 
     RowBox[{"i", "\[InvisibleComma]", "j"}]], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Vec", "[", 
   RowBox[{"alg_", ",", "l_"}], "]"}], ":=", 
  RowBox[{"2", 
   RowBox[{"Sum", "[", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Phi]2", "[", 
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"OrthogonalSimpleRoots", "[", "alg", "]"}], "]"}], ",", 
          "l"}], "]"}], ".", 
        RowBox[{"v", "[", 
         RowBox[{
          RowBox[{"PositiveRoots", "[", "alg", "]"}], "[", 
          RowBox[{"[", "j", "]"}], "]"}], "]"}]}], ")"}], "3"], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", 
       RowBox[{"Length", "[", 
        RowBox[{"PositiveRoots", "[", "alg", "]"}], "]"}]}], "}"}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Hyp1", "[", 
   RowBox[{"Alg_", ",", "rep_", ",", "l_"}], "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     SubscriptBox["s", 
      RowBox[{"j", ",", "l"}]], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[Phi]2", "[", 
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"OrthogonalSimpleRoots", "[", "Alg", "]"}], "]"}], ",", 
          "l"}], "]"}], ".", 
        RowBox[{"v", "[", 
         RowBox[{
          RowBox[{"WS", "[", 
           RowBox[{"Alg", ",", "rep"}], "]"}], "[", 
          RowBox[{"[", "j", "]"}], "]"}], "]"}]}], ")"}], "3"]}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "1", ",", 
      RowBox[{"Length", "[", 
       RowBox[{"WS", "[", 
        RowBox[{"Alg", ",", "rep"}], "]"}], "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Hyp2", "[", 
   RowBox[{"Alg1_", ",", "rep1_", ",", "Alg2_", ",", "rep2_"}], "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       SubscriptBox["s", 
        RowBox[{"j", ",", "i"}]], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Phi]2", "[", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"OrthogonalSimpleRoots", "[", "Alg1", "]"}], "]"}], 
              ",", "1"}], "]"}], ".", 
            RowBox[{"v", "[", 
             RowBox[{
              RowBox[{"WS", "[", 
               RowBox[{"Alg1", ",", "rep1"}], "]"}], "[", 
              RowBox[{"[", "j", "]"}], "]"}], "]"}]}], ")"}], 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]",
           "\[IndentingNewLine]", "+", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Phi]2", "[", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"OrthogonalSimpleRoots", "[", "Alg2", "]"}], "]"}], 
              ",", "2"}], "]"}], ".", 
            RowBox[{"v", "[", 
             RowBox[{
              RowBox[{"WS", "[", 
               RowBox[{"Alg2", ",", "rep2"}], "]"}], "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}]}], ")"}]}], ")"}], "3"]}],
       ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", 
        RowBox[{"Length", "[", 
         RowBox[{"WS", "[", 
          RowBox[{"Alg1", ",", "rep1"}], "]"}], "]"}]}], "}"}]}], "]"}], ",", 
    
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", 
      RowBox[{"Length", "[", 
       RowBox[{"WS", "[", 
        RowBox[{"Alg2", ",", "rep2"}], "]"}], "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Fp2", "[", 
   RowBox[{"alg1_", ",", "mat1_", ",", "alg2_", ",", "mat2_", ",", "mat3_"}], 
   "]"}], ":=", 
  RowBox[{
   FractionBox["1", "12"], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Vec", "[", 
      RowBox[{"alg1", ",", "1"}], "]"}], "+", 
     RowBox[{"Vec", "[", 
      RowBox[{"alg2", ",", "2"}], "]"}], "-", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"mat1", "[", 
           RowBox[{"[", "l", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], 
         RowBox[{"Hyp1", "[", 
          RowBox[{"alg1", ",", 
           RowBox[{
            RowBox[{"mat1", "[", 
             RowBox[{"[", "l", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", "1"}], "]"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{"s", "\[Rule]", 
          RowBox[{"s", "[", "l", "]"}]}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"l", ",", "1", ",", 
         RowBox[{"Length", "[", "mat1", "]"}]}], "}"}]}], "]"}], "-", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"mat2", "[", 
           RowBox[{"[", "l", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], 
         RowBox[{"Hyp1", "[", 
          RowBox[{"alg2", ",", 
           RowBox[{
            RowBox[{"mat2", "[", 
             RowBox[{"[", "l", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", "2"}], "]"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{"s", "\[Rule]", 
          RowBox[{"s", "[", "l", "]"}]}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"l", ",", "1", ",", 
         RowBox[{"Length", "[", "mat2", "]"}]}], "}"}]}], "]"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", "-", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"mat3", "[", 
           RowBox[{"[", "l", "]"}], "]"}], "[", 
          RowBox[{"[", "3", "]"}], "]"}], "\[IndentingNewLine]", 
         RowBox[{"Hyp2", "[", 
          RowBox[{"alg1", ",", 
           RowBox[{
            RowBox[{"mat3", "[", 
             RowBox[{"[", "l", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", "alg2", ",", 
           RowBox[{
            RowBox[{"mat3", "[", 
             RowBox[{"[", "l", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{"s", "\[Rule]", 
          RowBox[{"b", "[", "l", "]"}]}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"l", ",", "1", ",", 
         RowBox[{"Length", "[", "mat3", "]"}]}], "}"}]}], "]"}]}], 
    ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Fpzero", "[", 
   RowBox[{"alg2_", ",", "mat2_", ",", "p_"}], "]"}], ":=", 
  RowBox[{
   FractionBox["1", "12"], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Vec", "[", 
      RowBox[{"alg2", ",", "p"}], "]"}], "-", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"mat2", "[", 
           RowBox[{"[", "l", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], 
         RowBox[{"Hyp1", "[", 
          RowBox[{"alg2", ",", 
           RowBox[{
            RowBox[{"mat2", "[", 
             RowBox[{"[", "l", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", "p"}], "]"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{"s", "\[Rule]", 
          RowBox[{"s", "[", "l", "]"}]}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"l", ",", "1", ",", 
         RowBox[{"Length", "[", "mat2", "]"}]}], "}"}]}], "]"}]}], 
    ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M", "[", "A_", "]"}], ":=", 
  RowBox[{"Inverse", "[", 
   RowBox[{"MetricTensor", "[", "A", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FKK", "[", 
   RowBox[{"\[CapitalOmega]_", ",", "A_"}], "]"}], ":=", 
  RowBox[{
   FractionBox["1", "2"], "\[CapitalOmega]", " ", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        SubscriptBox["\[Phi]", "0"], "*", 
        SubscriptBox["\[Phi]", "i"], "*", 
        SubscriptBox["\[Phi]", "j"], 
        RowBox[{
         RowBox[{
          RowBox[{"M", "[", "A", "]"}], "[", 
          RowBox[{"[", "i", "]"}], "]"}], "[", 
         RowBox[{"[", "j", "]"}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "1", ",", 
         RowBox[{"Rank", "[", "A", "]"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Rank", "[", "A", "]"}]}], "}"}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FKK2", "[", 
   RowBox[{"\[CapitalOmega]_", ",", "A_", ",", "B_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"\[CapitalOmega]", " ", "[", 
         RowBox[{"[", "a", "]"}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{
            SubscriptBox["\[Phi]", 
             RowBox[{"0", "\[InvisibleComma]", "a"}]], "*", 
            SubscriptBox["\[Phi]", 
             RowBox[{"i", "\[InvisibleComma]", "1"}]], "*", 
            SubscriptBox["\[Phi]", 
             RowBox[{"j", "\[InvisibleComma]", "1"}]], 
            RowBox[{
             RowBox[{
              RowBox[{"M", "[", "A", "]"}], "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", 
             RowBox[{"[", "j", "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "1", ",", 
             RowBox[{"Rank", "[", "A", "]"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Rank", "[", "A", "]"}]}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"a", ",", "1", ",", 
        RowBox[{"Length", "[", "\[CapitalOmega]", "]"}]}], "}"}]}], "]"}]}], 
   "+", 
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"\[CapitalOmega]", " ", "[", 
         RowBox[{"[", "a", "]"}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}], 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{
            SubscriptBox["\[Phi]", 
             RowBox[{"0", "\[InvisibleComma]", "a"}]], "*", 
            SubscriptBox["\[Phi]", 
             RowBox[{"i", "\[InvisibleComma]", "2"}]], "*", 
            SubscriptBox["\[Phi]", 
             RowBox[{"j", "\[InvisibleComma]", "2"}]], 
            RowBox[{
             RowBox[{
              RowBox[{"M", "[", "B", "]"}], "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", 
             RowBox[{"[", "j", "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "1", ",", 
             RowBox[{"Rank", "[", "B", "]"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Rank", "[", "B", "]"}]}], "}"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"a", ",", "1", ",", 
        RowBox[{"Length", "[", "\[CapitalOmega]", "]"}]}], "}"}]}], 
     "]"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FKKzero", "[", 
   RowBox[{"\[CapitalOmega]_", ",", "B_", ",", "l_"}], "]"}], ":=", 
  RowBox[{
   FractionBox["1", "2"], 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalOmega]", " ", "[", 
        RowBox[{"[", "a", "]"}], "]"}], "[", 
       RowBox[{"[", "l", "]"}], "]"}], 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{"Sum", "[", 
         RowBox[{
          RowBox[{
           SubscriptBox["\[Phi]", 
            RowBox[{"0", "\[InvisibleComma]", "a"}]], "*", 
           SubscriptBox["\[Phi]", 
            RowBox[{"i", "\[InvisibleComma]", "l"}]], "*", 
           SubscriptBox["\[Phi]", 
            RowBox[{"j", "\[InvisibleComma]", "l"}]], 
           RowBox[{
            RowBox[{
             RowBox[{"M", "[", "B", "]"}], "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", 
            RowBox[{"[", "j", "]"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "1", ",", 
            RowBox[{"Rank", "[", "B", "]"}]}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Rank", "[", "B", "]"}]}], "}"}]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "1", ",", 
       RowBox[{"Length", "[", "\[CapitalOmega]", "]"}]}], "}"}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{"k_", ",", "alg_", ",", "mat_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"FKK", "[", 
    RowBox[{"k", ",", "alg"}], "]"}], "+", 
   RowBox[{"Fp1", "[", 
    RowBox[{"alg", ",", "mat"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fzero", "[", 
   RowBox[{"\[CapitalOmega]_", ",", "alg2_", ",", "rep2_", ",", "l_"}], "]"}],
   ":=", 
  RowBox[{
   RowBox[{"FKKzero", "[", 
    RowBox[{"\[CapitalOmega]", ",", "alg2", ",", "l"}], "]"}], "+", 
   RowBox[{"Fpzero", "[", 
    RowBox[{"alg2", ",", "rep2", ",", "l"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f2", "[", 
   RowBox[{
   "\[CapitalOmega]_", ",", "alg1_", ",", "rep1_", ",", "alg2_", ",", "rep2_",
     ",", "birep_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"FKK2", "[", 
    RowBox[{"\[CapitalOmega]", ",", "alg1", ",", "alg2"}], "]"}], "+", 
   RowBox[{"Fp2", "[", 
    RowBox[{"alg1", ",", "rep1", ",", "alg2", ",", "rep2", ",", "birep"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Shift", "[", 
   RowBox[{"Type_", ",", "Alg_"}], "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{"TrueQ", "[", 
     RowBox[{"Type", "\[Equal]", "U"}], "]"}], ",", 
    RowBox[{"ShiftsU", "[", "Alg", "]"}], ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{"Type", "\[Equal]", "T2"}], "]"}], ",", 
    RowBox[{"ShiftsT2", "[", "Alg", "]"}], ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{"Type", "\[Equal]", "T3"}], "]"}], ",", 
    RowBox[{"ShiftsT3", "[", "Alg", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ShiftsU", "[", "Alg_", "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
      RowBox[{"AlgebraClass", "[", "A2", "]"}]}], "]"}], ",", 
    RowBox[{"Table", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"Rank", "[", "Alg", "]"}]}], "}"}]}], "]"}], ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
      RowBox[{"AlgebraClass", "[", "B2", "]"}]}], "]"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"Table", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{
            RowBox[{"Rank", "[", "Alg", "]"}], "-", "2"}]}], "}"}]}], "]"}], 
       ",", "1"}], "}"}], "]"}], ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
      RowBox[{"AlgebraClass", "[", "C3", "]"}]}], "]"}], ",", 
    RowBox[{"Table", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"Rank", "[", "Alg", "]"}]}], "}"}]}], "]"}], ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
      RowBox[{"AlgebraClass", "[", "D3", "]"}]}], "]"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"Table", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{
            RowBox[{"Rank", "[", "Alg", "]"}], "-", "3"}]}], "}"}]}], "]"}], 
       ",", "1", ",", "1"}], "}"}], "]"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E6", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3", ",", "2", ",", "1", ",", "2"}], "}"}], 
    ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E7", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "7"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
     "2", ",", "3", ",", "4", ",", "3", ",", "2", ",", "1", ",", "2"}], "}"}],
     ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E8", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "8"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
     "2", ",", "4", ",", "6", ",", "5", ",", "4", ",", "3", ",", "2", ",", 
      "3"}], "}"}], ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
      RowBox[{"AlgebraClass", "[", "G2", "]"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", "F4"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "3", ",", "2", ",", "1"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ShiftsT2", "[", "Alg_", "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
      RowBox[{"AlgebraClass", "[", "A2", "]"}]}], "]"}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"EvenQ", "[", 
       RowBox[{"Rank", "[", "Alg", "]"}], "]"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{"2", ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          FractionBox[
           RowBox[{"Rank", "[", "Alg", "]"}], "2"]}], "}"}]}], "]"}], ",", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"Table", "[", 
           RowBox[{"2", ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              FractionBox[
               RowBox[{
                RowBox[{"Rank", "[", "Alg", "]"}], " "}], "2"]}], "}"}]}], 
           "]"}]}], "}"}], ",", "1"}], "]"}]}], "]"}], ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
      RowBox[{"AlgebraClass", "[", "B2", "]"}]}], "]"}], ",", "0", ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
      RowBox[{"AlgebraClass", "[", "C3", "]"}]}], "]"}], ",", "0", ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
      RowBox[{"AlgebraClass", "[", "D3", "]"}]}], "]"}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{"2", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{
            RowBox[{"Rank", "[", "Alg", "]"}], "-", "2"}]}], "}"}]}], "]"}], 
       ",", "1"}], "}"}], "]"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E6", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "4", ",", "3", ",", "2"}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E7", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "7"}]}], ",", "0", ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E8", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "8"}]}], ",", "0", ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
      RowBox[{"AlgebraClass", "[", "G2", "]"}]}], "]"}], ",", "0", ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", "F4"}], "]"}], ",", 
    "0"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ShiftsT3", "[", "Alg_", "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
      RowBox[{"AlgebraClass", "[", "A2", "]"}]}], "]"}], ",", "0", ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
      RowBox[{"AlgebraClass", "[", "B2", "]"}]}], "]"}], ",", "0", ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
      RowBox[{"AlgebraClass", "[", "C3", "]"}]}], "]"}], ",", "0", ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
      RowBox[{"AlgebraClass", "[", "D3", "]"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E6", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", "0", ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E7", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "7"}]}], ",", "0", ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E8", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "8"}]}], ",", "0", ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
      RowBox[{"AlgebraClass", "[", "G2", "]"}]}], "]"}], ",", "0", ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", "F4"}], "]"}], ",", 
    "0"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"graph1K", "[", 
   RowBox[{"polynomial_", ",", "numvars_", ",", "variable_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"poly", "=", "polynomial"}], ",", 
      RowBox[{"rank", "=", "numvars"}], ",", 
      RowBox[{"var", "=", "variable"}], ",", "spsarray", ",", "polyvals", ",",
       "pos", ",", "hom", ",", "numblwup", ",", "Aedgedat", ",", "Ledgedat", 
      ",", "Redgedat", ",", "trips", ",", "gL", ",", "gR", ",", "trigraph", 
      ",", "i"}], "}"}], ",", 
    RowBox[{
     RowBox[{"spsarray", "=", 
      RowBox[{
       RowBox[{"CoefficientArrays", "[", 
        RowBox[{"poly", ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           SubscriptBox["var", "i"], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", 
             RowBox[{"rank", "-", "1"}]}], "}"}]}], "]"}]}], "]"}], "[", 
       RowBox[{"[", "4", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"pos", "=", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"spsarray", "[", "\"\<NonzeroPositions\>\"", "]"}], "-", 
        "1"}], ")"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"polyvals", "=", 
      RowBox[{"spsarray", "[", "\"\<NonzeroValues\>\"", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"hom", "=", 
      RowBox[{"ConstantArray", "[", 
       RowBox[{"0", ",", "rank"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Aedgedat", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Ledgedat", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Redgedat", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"trips", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "pos", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"DeleteDuplicates", "[", 
            RowBox[{"pos", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "===", "1"}], ",", 
         
         RowBox[{
          RowBox[{"hom", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{
              RowBox[{"DeleteDuplicates", "[", 
               RowBox[{"pos", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], "+", "1"}], "]"}], "]"}], "=", 
          RowBox[{"polyvals", "[", 
           RowBox[{"[", "i", "]"}], "]"}]}]}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"numblwup", "=", 
      RowBox[{"8", "-", "hom"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "pos", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"DeleteDuplicates", "[", 
            RowBox[{"pos", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "===", "2"}], ",", 
         
         RowBox[{"Aedgedat", "=", 
          RowBox[{"Append", "[", 
           RowBox[{"Aedgedat", ",", 
            RowBox[{"UndirectedEdge", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"DeleteDuplicates", "[", 
                RowBox[{"pos", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{
               RowBox[{"DeleteDuplicates", "[", 
                RowBox[{"pos", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], "]"}]}]}], "]"}]}], 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "pos", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"DeleteDuplicates", "[", 
             RowBox[{"pos", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "===", "2"}], "&&", 
          RowBox[{
           RowBox[{
            RowBox[{"pos", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], ">", 
           RowBox[{
            RowBox[{"pos", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}]}]}], ",", 
         RowBox[{"Ledgedat", "=", 
          RowBox[{"Append", "[", 
           RowBox[{"Ledgedat", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"UndirectedEdge", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"DeleteDuplicates", "[", 
                  RowBox[{"pos", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"DeleteDuplicates", "[", 
                  RowBox[{"pos", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
              RowBox[{
               RowBox[{
                FractionBox["1", "3"], 
                RowBox[{"polyvals", "[", 
                 RowBox[{"[", "i", "]"}], "]"}]}], "//", "Simplify"}]}], 
             "}"}]}], "]"}]}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "pos", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"DeleteDuplicates", "[", 
             RowBox[{"pos", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "===", "2"}], "&&", 
          RowBox[{
           RowBox[{
            RowBox[{"pos", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], "<", 
           RowBox[{
            RowBox[{"pos", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", 
            RowBox[{"[", "3", "]"}], "]"}]}]}], ",", 
         RowBox[{"Redgedat", "=", 
          RowBox[{"Append", "[", 
           RowBox[{"Redgedat", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"UndirectedEdge", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"DeleteDuplicates", "[", 
                  RowBox[{"pos", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"DeleteDuplicates", "[", 
                  RowBox[{"pos", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
              RowBox[{
               RowBox[{
                FractionBox["1", "3"], 
                RowBox[{"polyvals", "[", 
                 RowBox[{"[", "i", "]"}], "]"}]}], "//", "Simplify"}]}], 
             "}"}]}], "]"}]}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "pos", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"DeleteDuplicates", "[", 
            RowBox[{"pos", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "===", "3"}], ",", 
         
         RowBox[{"trips", "=", 
          RowBox[{"Append", "[", 
           RowBox[{"trips", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"pos", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "+", "1"}], ",", 
              RowBox[{
               FractionBox[
                RowBox[{"polyvals", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "6"], "//", "Simplify"}]}], 
             "}"}]}], "]"}]}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"gL", "=", 
      RowBox[{"Graph", "[", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"i", "\[TwoWayRule]", "i"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "0", ",", 
              RowBox[{"rank", "-", "1"}]}], "}"}]}], "]"}], ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"DeleteDuplicates", "[", "Aedgedat", "]"}], "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "[", 
               RowBox[{"DeleteDuplicates", "[", "Aedgedat", "]"}], "]"}]}], 
             "}"}]}], "]"}]}], "]"}], ",", 
        RowBox[{"EdgeStyle", "\[Rule]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"i", "\[TwoWayRule]", "i"}], "\[Rule]", "White"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", 
             RowBox[{"rank", "-", "1"}]}], "}"}]}], "]"}]}], ",", 
        RowBox[{"EdgeLabels", "\[Rule]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Ledgedat", "[", 
              RowBox[{"[", "j", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
            RowBox[{"Placed", "[", 
             RowBox[{
              RowBox[{"Framed", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Ledgedat", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], ",", "12", ",", "Blue", 
                  ",", "Bold"}], "]"}], ",", 
                RowBox[{"Background", "\[Rule]", "LightYellow"}], ",", 
                RowBox[{"FrameStyle", "\[Rule]", "Pink"}]}], "]"}], ",", 
              ".2"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "1", ",", 
             RowBox[{"Length", "[", "Ledgedat", "]"}]}], "}"}]}], "]"}]}], 
        ",", 
        RowBox[{"VertexSize", "\[Rule]", ".25"}], ",", 
        RowBox[{"VertexShape", "\[Rule]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"i", "\[Rule]", 
            RowBox[{"Style", "[", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"ToString", "[", "i", "]"}], 
               RowBox[{"TraditionalForm", "[", 
                RowBox[{"numblwup", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]], ",", "20", 
              ",", "Red"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", 
             RowBox[{"rank", "-", "1"}]}], "}"}]}], "]"}]}], ",", 
        RowBox[{"PerformanceGoal", "\[Rule]", "\"\<Quality\>\""}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"gR", "=", 
      RowBox[{"Graph", "[", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"i", "\[TwoWayRule]", "i"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "0", ",", 
              RowBox[{"rank", "-", "1"}]}], "}"}]}], "]"}], ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"DeleteDuplicates", "[", "Aedgedat", "]"}], "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "[", 
               RowBox[{"DeleteDuplicates", "[", "Aedgedat", "]"}], "]"}]}], 
             "}"}]}], "]"}]}], "]"}], ",", 
        RowBox[{"EdgeStyle", "\[Rule]", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"i", "\[TwoWayRule]", "i"}], "\[Rule]", "White"}], ",", 
             
             RowBox[{"{", 
              RowBox[{"i", ",", "0", ",", 
               RowBox[{"rank", "-", "1"}]}], "}"}]}], "]"}], ",", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"Redgedat", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", "Gray"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", 
               RowBox[{"Length", "[", "Redgedat", "]"}]}], "}"}]}], "]"}]}], 
          "]"}]}], ",", 
        RowBox[{"EdgeLabels", "\[Rule]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Redgedat", "[", 
              RowBox[{"[", "j", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
            RowBox[{"Placed", "[", 
             RowBox[{
              RowBox[{"Framed", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Redgedat", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], ",", "12", ",", "Blue", 
                  ",", "Bold"}], "]"}], ",", 
                RowBox[{"Background", "\[Rule]", "LightYellow"}], ",", 
                RowBox[{"FrameStyle", "\[Rule]", "Pink"}]}], "]"}], ",", 
              ".8"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "1", ",", 
             RowBox[{"Length", "[", "Redgedat", "]"}]}], "}"}]}], "]"}]}], 
        ",", 
        RowBox[{"VertexSize", "\[Rule]", ".25"}], ",", 
        RowBox[{"VertexShape", "\[Rule]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"i", "\[Rule]", 
            RowBox[{"Style", "[", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"ToString", "[", "i", "]"}], 
               RowBox[{"TraditionalForm", "[", 
                RowBox[{"numblwup", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]], ",", "20", 
              ",", "Red"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", 
             RowBox[{"rank", "-", "1"}]}], "}"}]}], "]"}]}], ",", 
        RowBox[{"PerformanceGoal", "\[Rule]", "\"\<Quality\>\""}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "trips", "]"}], ">", "0"}], ",", 
       RowBox[{"trigraph", "=", 
        RowBox[{"Graph", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{"i", ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "[", "trips", "]"}]}], "}"}]}], "]"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"VertexCoordinates", "\[Rule]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Sum", "[", 
              RowBox[{
               FractionBox[
                RowBox[{
                 RowBox[{"GraphEmbedding", "[", "gL", "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"trips", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "3"], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", "3"}], "}"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "1", ",", 
               RowBox[{"Length", "[", "trips", "]"}]}], "}"}]}], "]"}]}], ",", 
          RowBox[{"VertexSize", "\[Rule]", "0.55"}], ",", 
          RowBox[{"VertexShape", "\[Rule]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"j", "\[Rule]", 
              RowBox[{"Framed", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"trips", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], ",", "15", ",", "Bold", 
                  ",", "Purple"}], "]"}], ",", 
                RowBox[{"FrameStyle", "\[Rule]", "Purple"}], ",", 
                RowBox[{"Background", "\[Rule]", "LightPurple"}]}], "]"}]}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "1", ",", 
               RowBox[{"Length", "[", "trips", "]"}]}], "}"}]}], "]"}]}]}], 
         "]"}]}], ",", 
       RowBox[{"trigraph", "=", 
        RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Return", "[", 
      RowBox[{"Show", "[", 
       RowBox[{"{", 
        RowBox[{"gL", ",", "gR", ",", "trigraph"}], "}"}], "]"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"graph2K", "[", 
   RowBox[{"polynomial_", ",", "numvars_", ",", "variable_", ",", "rank1_"}], 
   "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"poly", "=", "polynomial"}], ",", 
      RowBox[{"rank", "=", "numvars"}], ",", 
      RowBox[{"var", "=", "variable"}], ",", "spsarray", ",", "polyvals", ",",
       "pos", ",", "hom", ",", "numblwup", ",", "Aedgedat", ",", "Ledgedat", 
      ",", "Redgedat", ",", "trips", ",", "gL", ",", "gR", ",", "trigraph", 
      ",", "i"}], "}"}], ",", 
    RowBox[{
     RowBox[{"spsarray", "=", 
      RowBox[{
       RowBox[{"CoefficientArrays", "[", 
        RowBox[{"poly", ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           SubscriptBox["var", "i"], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", 
             RowBox[{"rank", "-", "1"}]}], "}"}]}], "]"}]}], "]"}], "[", 
       RowBox[{"[", "4", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"pos", "=", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"spsarray", "[", "\"\<NonzeroPositions\>\"", "]"}], "-", 
        "1"}], ")"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"polyvals", "=", 
      RowBox[{"spsarray", "[", "\"\<NonzeroValues\>\"", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"hom", "=", 
      RowBox[{"ConstantArray", "[", 
       RowBox[{"0", ",", "rank"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Aedgedat", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Ledgedat", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Redgedat", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"trips", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "pos", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"DeleteDuplicates", "[", 
            RowBox[{"pos", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "===", "1"}], ",", 
         
         RowBox[{
          RowBox[{"hom", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{
              RowBox[{"DeleteDuplicates", "[", 
               RowBox[{"pos", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], "+", "1"}], "]"}], "]"}], "=", 
          RowBox[{"polyvals", "[", 
           RowBox[{"[", "i", "]"}], "]"}]}]}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"numblwup", "=", 
      RowBox[{"8", "-", "hom"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "pos", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"DeleteDuplicates", "[", 
            RowBox[{"pos", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "===", "2"}], ",", 
         
         RowBox[{"Aedgedat", "=", 
          RowBox[{"Append", "[", 
           RowBox[{"Aedgedat", ",", 
            RowBox[{"UndirectedEdge", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"DeleteDuplicates", "[", 
                RowBox[{"pos", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{
               RowBox[{"DeleteDuplicates", "[", 
                RowBox[{"pos", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], "]"}]}]}], "]"}]}], 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "pos", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"DeleteDuplicates", "[", 
             RowBox[{"pos", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "===", "2"}], "&&", 
          RowBox[{
           RowBox[{
            RowBox[{"pos", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], ">", 
           RowBox[{
            RowBox[{"pos", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}]}]}], ",", 
         RowBox[{"Ledgedat", "=", 
          RowBox[{"Append", "[", 
           RowBox[{"Ledgedat", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"UndirectedEdge", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"DeleteDuplicates", "[", 
                  RowBox[{"pos", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"DeleteDuplicates", "[", 
                  RowBox[{"pos", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
              RowBox[{
               RowBox[{
                FractionBox["1", "3"], 
                RowBox[{"polyvals", "[", 
                 RowBox[{"[", "i", "]"}], "]"}]}], "//", "Simplify"}]}], 
             "}"}]}], "]"}]}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "pos", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"DeleteDuplicates", "[", 
             RowBox[{"pos", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "===", "2"}], "&&", 
          RowBox[{
           RowBox[{
            RowBox[{"pos", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], "<", 
           RowBox[{
            RowBox[{"pos", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", 
            RowBox[{"[", "3", "]"}], "]"}]}]}], ",", 
         RowBox[{"Redgedat", "=", 
          RowBox[{"Append", "[", 
           RowBox[{"Redgedat", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"UndirectedEdge", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"DeleteDuplicates", "[", 
                  RowBox[{"pos", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"DeleteDuplicates", "[", 
                  RowBox[{"pos", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
              RowBox[{
               RowBox[{
                FractionBox["1", "3"], 
                RowBox[{"polyvals", "[", 
                 RowBox[{"[", "i", "]"}], "]"}]}], "//", "Simplify"}]}], 
             "}"}]}], "]"}]}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "pos", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"DeleteDuplicates", "[", 
            RowBox[{"pos", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "===", "3"}], ",", 
         
         RowBox[{"trips", "=", 
          RowBox[{"Append", "[", 
           RowBox[{"trips", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"pos", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "+", "1"}], ",", 
              RowBox[{
               FractionBox[
                RowBox[{"polyvals", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "6"], "//", "Simplify"}]}], 
             "}"}]}], "]"}]}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"gL", "=", 
      RowBox[{"Graph", "[", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"i", "\[TwoWayRule]", "i"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "0", ",", 
              RowBox[{"rank", "-", "1"}]}], "}"}]}], "]"}], ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"DeleteDuplicates", "[", "Aedgedat", "]"}], "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "[", 
               RowBox[{"DeleteDuplicates", "[", "Aedgedat", "]"}], "]"}]}], 
             "}"}]}], "]"}]}], "]"}], ",", 
        RowBox[{"EdgeStyle", "\[Rule]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"i", "\[TwoWayRule]", "i"}], "\[Rule]", "White"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", 
             RowBox[{"rank", "-", "1"}]}], "}"}]}], "]"}]}], ",", 
        RowBox[{"EdgeLabels", "\[Rule]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Ledgedat", "[", 
              RowBox[{"[", "j", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
            RowBox[{"Placed", "[", 
             RowBox[{
              RowBox[{"Framed", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Ledgedat", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], ",", "12", ",", "Blue", 
                  ",", "Bold"}], "]"}], ",", 
                RowBox[{"Background", "\[Rule]", "LightYellow"}], ",", 
                RowBox[{"FrameStyle", "\[Rule]", "Pink"}]}], "]"}], ",", 
              ".2"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "1", ",", 
             RowBox[{"Length", "[", "Ledgedat", "]"}]}], "}"}]}], "]"}]}], 
        ",", 
        RowBox[{"VertexSize", "\[Rule]", ".25"}], ",", 
        RowBox[{"VertexShape", "\[Rule]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"i", "\[Rule]", 
            RowBox[{"Style", "[", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"ToString", "[", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"i", "<", 
                   RowBox[{"rank1", "+", "1"}]}], ",", "i", ",", 
                  RowBox[{"i", "-", "rank1", "-", "1"}]}], "]"}], "]"}], 
               RowBox[{"TraditionalForm", "[", 
                RowBox[{"numblwup", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]], ",", "22", 
              ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"i", ">", "rank1"}], ",", "Red", ",", 
                RowBox[{"Darker", "[", "Green", "]"}]}], "]"}]}], "]"}]}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", 
             RowBox[{"rank", "-", "1"}]}], "}"}]}], "]"}]}], ",", 
        RowBox[{"PerformanceGoal", "\[Rule]", "\"\<Quality\>\""}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"gR", "=", 
      RowBox[{"Graph", "[", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"i", "\[TwoWayRule]", "i"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "0", ",", 
              RowBox[{"rank", "-", "1"}]}], "}"}]}], "]"}], ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"DeleteDuplicates", "[", "Aedgedat", "]"}], "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "[", 
               RowBox[{"DeleteDuplicates", "[", "Aedgedat", "]"}], "]"}]}], 
             "}"}]}], "]"}]}], "]"}], ",", 
        RowBox[{"EdgeStyle", "\[Rule]", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"i", "\[TwoWayRule]", "i"}], "\[Rule]", "White"}], ",", 
             
             RowBox[{"{", 
              RowBox[{"i", ",", "0", ",", 
               RowBox[{"rank", "-", "1"}]}], "}"}]}], "]"}], ",", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"Redgedat", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", "Gray"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", 
               RowBox[{"Length", "[", "Redgedat", "]"}]}], "}"}]}], "]"}]}], 
          "]"}]}], ",", 
        RowBox[{"EdgeLabels", "\[Rule]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Redgedat", "[", 
              RowBox[{"[", "j", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", 
            RowBox[{"Placed", "[", 
             RowBox[{
              RowBox[{"Framed", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Redgedat", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], ",", "12", ",", "Blue", 
                  ",", "Bold"}], "]"}], ",", 
                RowBox[{"Background", "\[Rule]", "LightYellow"}], ",", 
                RowBox[{"FrameStyle", "\[Rule]", "Pink"}]}], "]"}], ",", 
              ".8"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "1", ",", 
             RowBox[{"Length", "[", "Redgedat", "]"}]}], "}"}]}], "]"}]}], 
        ",", 
        RowBox[{"VertexSize", "\[Rule]", ".25"}], ",", 
        RowBox[{"VertexShape", "\[Rule]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"i", "\[Rule]", 
            RowBox[{"Style", "[", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"ToString", "[", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"i", "<", 
                   RowBox[{"rank1", "+", "1"}]}], ",", "i", ",", 
                  RowBox[{"i", "-", "rank1", "-", "1"}]}], "]"}], "]"}], 
               RowBox[{"TraditionalForm", "[", 
                RowBox[{"numblwup", "[", 
                 RowBox[{"[", 
                  RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]], ",", "22", 
              ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"i", ">", "rank1"}], ",", "Red", ",", 
                RowBox[{"Darker", "[", "Green", "]"}]}], "]"}]}], "]"}]}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", 
             RowBox[{"rank", "-", "1"}]}], "}"}]}], "]"}]}], ",", 
        RowBox[{"PerformanceGoal", "\[Rule]", "\"\<Quality\>\""}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "trips", "]"}], ">", "0"}], ",", 
       RowBox[{"trigraph", "=", 
        RowBox[{"Graph", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{"i", ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "[", "trips", "]"}]}], "}"}]}], "]"}], ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"VertexCoordinates", "\[Rule]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Sum", "[", 
              RowBox[{
               FractionBox[
                RowBox[{
                 RowBox[{"GraphEmbedding", "[", "gL", "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"trips", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "3"], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", "3"}], "}"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "1", ",", 
               RowBox[{"Length", "[", "trips", "]"}]}], "}"}]}], "]"}]}], ",", 
          RowBox[{"VertexSize", "\[Rule]", "0.55"}], ",", 
          RowBox[{"VertexShape", "\[Rule]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"j", "\[Rule]", 
              RowBox[{"Framed", "[", 
               RowBox[{
                RowBox[{"Style", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"trips", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], ",", "15", ",", "Bold", 
                  ",", "Purple"}], "]"}], ",", 
                RowBox[{"FrameStyle", "\[Rule]", "Purple"}], ",", 
                RowBox[{"Background", "\[Rule]", "LightPurple"}]}], "]"}]}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "1", ",", 
               RowBox[{"Length", "[", "trips", "]"}]}], "}"}]}], "]"}]}]}], 
         "]"}]}], ",", 
       RowBox[{"trigraph", "=", 
        RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Return", "[", 
      RowBox[{"Show", "[", 
       RowBox[{"{", 
        RowBox[{"gL", ",", "gR", ",", "trigraph"}], "}"}], "]"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TwistedAlgebra", "[", 
   RowBox[{"Type_", ",", "Alg_"}], "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
       RowBox[{"AlgebraClass", "[", "A2", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], ">", "2"}]}], ",", 
    RowBox[{
     RowBox[{"Algebra", "[", "C", "]"}], "[", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"EvenQ", "[", 
        RowBox[{"Rank", "[", "Alg", "]"}], "]"}], ",", 
       FractionBox[
        RowBox[{"Rank", "[", "Alg", "]"}], "2"], ",", 
       FractionBox[
        RowBox[{
         RowBox[{"Rank", "[", "Alg", "]"}], "+", "1"}], "2"]}], "]"}], "]"}], 
    ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
       RowBox[{"AlgebraClass", "[", "A2", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "2"}]}], ",", "A1", ",", 
    
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
       RowBox[{"AlgebraClass", "[", "D3", "]"}]}], "]"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{"Type", "\[Equal]", "T2"}], "]"}]}], ",", 
    RowBox[{
     RowBox[{"Algebra", "[", "B", "]"}], "[", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "-", "1"}], "]"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
       RowBox[{"AlgebraClass", "[", "D4", "]"}]}], "]"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{"Type", "\[Equal]", "T3"}], "]"}]}], ",", "G2", ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
      RowBox[{"AlgebraClass", "[", "E6", "]"}]}], "]"}], ",", "F4"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AT", "[", 
   RowBox[{"Type_", ",", "Alg_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"TrueQ", "[", 
     RowBox[{"Type", "\[Equal]", "U"}], "]"}], ",", "Alg", ",", 
    RowBox[{"TwistedAlgebra", "[", 
     RowBox[{"Type", ",", "Alg"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ck", "[", 
   RowBox[{"Type_", ",", "Alg_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"TrueQ", "[", 
     RowBox[{"Type", "=!=", "U"}], "]"}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{"Type", "==", "T2"}], "]"}], "&&", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
           RowBox[{"AlgebraClass", "[", "A2", "]"}]}], "]"}], "\[Or]", 
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
           RowBox[{"AlgebraClass", "[", "D3", "]"}]}], "]"}], "\[Or]", 
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
           RowBox[{"AlgebraClass", "[", "E6", "]"}]}], "]"}]}], ")"}]}], ",", 
      "1", ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{"Type", "==", "T3"}], "]"}], "&&", 
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", 
           RowBox[{"AlgebraClass", "[", "D4", "]"}]}], "]"}], "&&", 
         RowBox[{
          RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", "1", 
        ",", "0"}], "]"}], ",", "0"}], "]"}], ",", "1"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prepotential6d", "[", "A_", "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "A", "]"}], ">", "3"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"A", "[", 
        RowBox[{"[", "4", "]"}], "]"}], "\[Equal]", "0"}], "]"}]}], ",", 
    RowBox[{
     RowBox[{"fzero", "[", 
      RowBox[{
       RowBox[{"A", "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       RowBox[{"AT", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"A", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"A", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ",", 
       RowBox[{"A", "[", 
        RowBox[{"[", "5", "]"}], "]"}], ",", "1"}], "]"}], "/.", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        SubscriptBox["\[Phi]", 
         RowBox[{"i", ",", "1"}]], "\[Rule]", 
        RowBox[{
         SubscriptBox["\[Phi]", 
          RowBox[{"i", ",", "1"}]], "-", 
         RowBox[{
          RowBox[{
           RowBox[{"Shift", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"A", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], " ", ",", 
             RowBox[{
              RowBox[{"A", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], " ", "]"}], "[", 
           RowBox[{"[", "i", "]"}], "]"}], 
          SubscriptBox["\[Phi]", 
           RowBox[{"0", ",", "1"}]]}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"Rank", "[", 
          RowBox[{"AT", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"A", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"A", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}]}], "}"}]}], 
      "]"}]}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"TrueQ", "[", 
       RowBox[{
        RowBox[{"A", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], "]"}], ",", 
      RowBox[{
       RowBox[{"fzero", "[", 
        RowBox[{
         RowBox[{"A", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"AT", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"A", "[", 
             RowBox[{"[", "4", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], ",", 
           RowBox[{
            RowBox[{"A", "[", 
             RowBox[{"[", "4", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"A", "[", 
          RowBox[{"[", "5", "]"}], "]"}], ",", "2"}], "]"}], "/.", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          SubscriptBox["\[Phi]", 
           RowBox[{"i", ",", "2"}]], "\[Rule]", 
          RowBox[{
           SubscriptBox["\[Phi]", 
            RowBox[{"i", ",", "2"}]], "-", 
           RowBox[{
            RowBox[{
             RowBox[{"Shift", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"A", "[", 
                 RowBox[{"[", "4", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], " ", ",", 
               RowBox[{
                RowBox[{"A", "[", 
                 RowBox[{"[", "4", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], " ", "]"}], "[", 
             RowBox[{"[", "i", "]"}], "]"}], 
            SubscriptBox["\[Phi]", 
             RowBox[{"0", ",", "2"}]]}]}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Rank", "[", 
            RowBox[{"AT", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"A", "[", 
                RowBox[{"[", "4", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", 
              RowBox[{
               RowBox[{"A", "[", 
                RowBox[{"[", "4", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}]}], "}"}]}], 
        "]"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Ck", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"A", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], ",", 
           RowBox[{
            RowBox[{"A", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "\[Equal]", "1"}], "  ", 
        ",", "\[IndentingNewLine]", 
        RowBox[{"Which", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "A", "]"}], "\[Equal]", "3"}], ",", 
          RowBox[{
           RowBox[{"f", "[", 
            RowBox[{
             RowBox[{"A", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"AT", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"A", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"A", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ",", 
             RowBox[{"A", "[", 
              RowBox[{"[", "3", "]"}], "]"}]}], "]"}], "/.", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              SubscriptBox["\[Phi]", "i"], "\[Rule]", 
              RowBox[{
               SubscriptBox["\[Phi]", "i"], "-", 
               RowBox[{
                RowBox[{
                 RowBox[{"Shift", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"A", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], " ", ",", 
                   RowBox[{
                    RowBox[{"A", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], " ", "]"}], "[", 
                 RowBox[{"[", "i", "]"}], "]"}], 
                SubscriptBox["\[Phi]", "0"]}]}]}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", 
               RowBox[{"Rank", "[", 
                RowBox[{"AT", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"A", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"A", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}]}], "}"}]}], 
            "]"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Length", "[", "A", "]"}], "\[Equal]", "6"}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Ck", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"A", "[", 
                 RowBox[{"[", "4", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"A", "[", 
                 RowBox[{"[", "4", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "\[Equal]", "1"}], 
            "  ", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"f2", "[", 
               RowBox[{
                RowBox[{"A", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"AT", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"A", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"A", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ",", 
                RowBox[{"A", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], ",", 
                RowBox[{"AT", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"A", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"A", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ",", 
                RowBox[{"A", "[", 
                 RowBox[{"[", "5", "]"}], "]"}], ",", 
                RowBox[{"A", "[", 
                 RowBox[{"[", "6", "]"}], "]"}]}], "]"}], "/.", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 SubscriptBox["\[Phi]", 
                  RowBox[{"i", ",", "1"}]], "\[Rule]", 
                 RowBox[{
                  SubscriptBox["\[Phi]", 
                   RowBox[{"i", ",", "1"}]], "-", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Shift", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"A", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], " ", ",", 
                    RowBox[{
                    RowBox[{"A", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], " ", "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], 
                   SubscriptBox["\[Phi]", 
                    RowBox[{"0", ",", "1"}]]}]}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "1", ",", 
                  RowBox[{"Rank", "[", 
                   RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"A", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"A", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}]}], "}"}]}],
                "]"}]}], "/.", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{
                SubscriptBox["\[Phi]", 
                 RowBox[{"i", ",", "2"}]], "\[Rule]", 
                RowBox[{
                 SubscriptBox["\[Phi]", 
                  RowBox[{"i", ",", "2"}]], "-", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Shift", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"A", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], " ", ",", 
                    RowBox[{
                    RowBox[{"A", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], " ", "]"}], "[", 
                   RowBox[{"[", "i", "]"}], "]"}], 
                  SubscriptBox["\[Phi]", 
                   RowBox[{"0", ",", "2"}]]}]}]}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"Rank", "[", 
                  RowBox[{"AT", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"A", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"A", "[", 
                    RowBox[{"[", "4", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}]}], "}"}]}],
               "]"}]}], ",", 
            RowBox[{
            "Print", "[", "\"\<This Algebra does not have this twist\>\"", 
             "]"}]}], "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "A", "]"}], "\[NotEqual]", "3"}], "&&", 
           RowBox[{
            RowBox[{"Length", "[", "A", "]"}], "\[NotEqual]", "6"}]}], ",", 
          RowBox[{
          "Print", "[", "\"\<Not in the correct form, check instructions\>\"",
            "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{
        "Print", "[", "\"\<This Algebra does not have this twist\>\"", 
         "]"}]}], "]"}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RankFromPrepotential", "[", "P_", "]"}], ":=", 
  RowBox[{"Count", "[", 
   RowBox[{
    RowBox[{"DeleteCases", "[", 
     RowBox[{
      RowBox[{"ToExpression", "[", 
       RowBox[{"StringDelete", "[", 
        RowBox[{
         RowBox[{"StringDelete", "[", 
          RowBox[{
           RowBox[{"StringDelete", "[", 
            RowBox[{
             RowBox[{"StringDelete", "[", 
              RowBox[{
               RowBox[{"StringSplit", "[", 
                RowBox[{"ToString", "[", 
                 RowBox[{"Variables", "[", "P", "]"}], "]"}], "]"}], ",", 
               "\"\<}\>\""}], "]"}], ",", "\"\<{\>\""}], "]"}], ",", 
           "\"\<,\>\""}], "]"}], ",", "DigitCharacter"}], "]"}], "]"}], ",", 
      "Null"}], "]"}], ",", "\[Phi]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Rank2FromPrepotential", "[", "P_", "]"}], ":=", 
  RowBox[{"Max", "[", 
   RowBox[{"1", ",", 
    RowBox[{"Count", "[", 
     RowBox[{
      RowBox[{"DeleteCases", "[", 
       RowBox[{
        RowBox[{"ToExpression", "[", 
         RowBox[{"StringDelete", "[", 
          RowBox[{
           RowBox[{"StringDelete", "[", 
            RowBox[{
             RowBox[{"StringDelete", "[", 
              RowBox[{
               RowBox[{"StringDelete", "[", 
                RowBox[{
                 RowBox[{"StringSplit", "[", 
                  RowBox[{"ToString", "[", 
                   RowBox[{"Variables", "[", "  ", 
                    RowBox[{"P", "/.", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{
                    SubscriptBox["\[Phi]", 
                    RowBox[{"j", ",", "1"}]], "\[Rule]", "0"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"j", ",", "0", ",", 
                    RowBox[{"RankFromPrepotential", "[", "P", "]"}]}], 
                    "}"}]}], "]"}]}], "           ", "]"}], "]"}], "]"}], 
                 ",", "\"\<}\>\""}], "]"}], ",", "\"\<{\>\""}], "]"}], ",", 
             "\"\<,\>\""}], "]"}], ",", "DigitCharacter"}], "]"}], "]"}], ",",
         "Null"}], "]"}], ",", "\[Phi]"}], "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Rep", "[", 
   RowBox[{"n_", ",", "m_"}], "]"}], ":=", 
  RowBox[{"Flatten", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        SubscriptBox["\[Phi]", 
         RowBox[{"i", ",", "j"}]], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"j", "\[Equal]", "1"}], ",", "n", ",", "m"}], "]"}]}], 
         "}"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "2"}], "}"}]}], "]"}], ",", "1"}], 
   "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Repl", "[", 
   RowBox[{"n_", ",", "m_"}], "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Rep", "[", 
       RowBox[{"n", ",", "m"}], "]"}], "[", 
      RowBox[{"[", 
       RowBox[{"i", "+", "1"}], "]"}], "]"}], "\[Rule]", 
     SubscriptBox["\[Phi]", "i"]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "0", ",", 
      RowBox[{
       RowBox[{"Length", "[", 
        RowBox[{"Rep", "[", 
         RowBox[{"n", ",", "m"}], "]"}], "]"}], "-", "1"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Graph1K", "[", "P_", "]"}], ":=", 
  RowBox[{"graph1K", "[", 
   RowBox[{
    RowBox[{"Expand", "[", "P", "]"}], ",", 
    RowBox[{"RankFromPrepotential", "[", "P", "]"}], ",", "\[Phi]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Graph2K", "[", "P_", "]"}], ":=", 
  RowBox[{"graph2K", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Expand", "[", "P", "]"}], "/.", 
     RowBox[{"Repl", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"RankFromPrepotential", "[", "P", "]"}], "-", 
        RowBox[{"Rank2FromPrepotential", "[", "P", "]"}], "-", "1"}], ",", 
       RowBox[{
        RowBox[{"Rank2FromPrepotential", "[", "P", "]"}], "-", "1"}]}], 
      "]"}]}], ",", 
    RowBox[{"RankFromPrepotential", "[", "P", "]"}], ",", "\[Phi]", ",", 
    RowBox[{
     RowBox[{"RankFromPrepotential", "[", "P", "]"}], "-", 
     RowBox[{"Rank2FromPrepotential", "[", "P", "]"}], "-", "1"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Curve1", "[", "Alg_", "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
      RowBox[{"AlgebraClass", "[", "C", "]"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"2", " ", 
        RowBox[{"Rank", "[", "Alg", "]"}]}], ",", 
       RowBox[{"8", "+", " ", 
        RowBox[{"2", " ", 
         RowBox[{"Rank", "[", "Alg", "]"}]}]}]}], "}"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "A", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "1"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"2", ",", "10"}], "}"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "A", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "2"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"3", ",", "12"}], "}"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "A", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "5"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"6", ",", "14"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"15", ",", "1"}], "}"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "A", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[NotEqual]", "1"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[NotEqual]", "2"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[NotEqual]", "5"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"Rank", "[", "Alg", "]"}], "+", "1"}], ",", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg", "]"}], "+", "1", "+", "8"}]}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         FractionBox["1", "2"], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Rank", "[", "Alg", "]"}], "+", "1"}], ")"}], 
         RowBox[{"Rank", "[", "Alg", "]"}]}], ",", "1"}], "}"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "B", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "3"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"7", ",", "2"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"8", ",", "6"}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", "3"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "3"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", "3"}], 
       "}"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "B", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"9", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"16", ",", "3"}], "}"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "5"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"10", ",", "5"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
        "3"}], "}"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "B", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "5"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"11", ",", "6"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"32", ",", 
        FractionBox["3", "2"]}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"12", ",", "7"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
         "}"}], ",", 
        FractionBox["3", "2"]}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "G2", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "2"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"7", ",", "7"}], "}"}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "F4", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "4"}], "}"}],
      "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E6", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
        "}"}], ",", "5"}], "}"}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E7", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "7"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
        "}"}], ",", 
       FractionBox["7", "2"]}], "}"}], "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Curve2", "[", "Alg_", "]"}], ":=", 
  RowBox[{"Which", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
      RowBox[{"AlgebraClass", "[", "A", "]"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"Rank", "[", "Alg", "]"}], "+", "1"}], ",", 
       RowBox[{"2", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Rank", "[", "Alg", "]"}], "+", "1"}], ")"}]}]}], "}"}], 
     "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "B", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "3"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"7", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"8", ",", "4"}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", "2"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "2"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", "2"}], 
       "}"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "B", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"9", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"16", ",", "2"}], "}"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "5"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"10", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
        "2"}], "}"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "B", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "5"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"11", ",", "5"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"32", ",", "1"}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"12", ",", "6"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
         "}"}], ",", "1"}], "}"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "B", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"13", ",", "7"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"64", ",", 
        FractionBox["1", "2"]}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "G2", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "2"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"7", ",", "4"}], "}"}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "F4", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "3"}], "}"}],
      "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E6", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
        "}"}], ",", "4"}], "}"}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E7", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "7"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
        "}"}], ",", "3"}], "}"}], "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Curve3", "[", "Alg_", "]"}], ":=", 
  RowBox[{"Which", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "A", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "2"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"3", ",", "0"}], "}"}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "B", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "3"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"8", ",", "2"}], "}"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", "1"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "1"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", "1"}], 
       "}"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "B", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"9", ",", "2"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"16", ",", "1"}], "}"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "5"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"10", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
        "1"}], "}"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "B", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "5"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"11", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"32", ",", 
        FractionBox["1", "2"]}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"12", ",", "5"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
         "}"}], ",", 
        FractionBox["1", "2"]}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "G2", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "2"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"7", ",", "1"}], "}"}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "F4", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "2"}], "}"}],
      "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E6", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
        "}"}], ",", "3"}], "}"}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E7", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "7"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
        "}"}], ",", 
       FractionBox["5", "2"]}], "}"}], "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Curve4", "[", "Alg_", "]"}], ":=", 
  RowBox[{"Which", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", "0"}], "}"}],
      "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "B", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"9", ",", "1"}], "}"}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "5"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"10", ",", "2"}], "}"}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "B", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "5"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"11", ",", "3"}], "}"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"12", ",", "4"}], "}"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "B", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"13", ",", "5"}], "}"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[GreaterEqual]", "7"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"2", " ", 
        RowBox[{"Rank", "[", "Alg", "]"}]}], ",", 
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Rank", "[", "Alg", "]"}]}], "-", "8"}]}], "}"}], "}"}], ",",
     "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "B", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[GreaterEqual]", "7"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Rank", "[", "Alg", "]"}]}], "+", "1"}], ",", 
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Rank", "[", "Alg", "]"}]}], "+", "1", "-", "8"}]}], "}"}], 
     "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "F4", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "1"}], "}"}],
      "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E6", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
        "}"}], ",", "2"}], "}"}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E7", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "7"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
        "}"}], ",", "2"}], "}"}], "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Curve5", "[", "Alg_", "]"}], ":=", 
  RowBox[{"Which", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "F4", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"26", ",", "0"}], "}"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E6", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
        "}"}], ",", "1"}], "}"}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E7", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "7"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
        "}"}], ",", 
       FractionBox["3", "2"]}], "}"}], "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Curve6", "[", "Alg_", "]"}], ":=", 
  RowBox[{"Which", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E6", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"27", ",", "0"}], "}"}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E7", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "7"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
        "}"}], ",", "1"}], "}"}], "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Curve7", "[", "Alg_", "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E7", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "7"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
        "}"}], ",", 
       FractionBox["1", "2"]}], "}"}], "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Curve8", "[", "Alg_", "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E7", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "7"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
        "}"}], ",", "0"}], "}"}], "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Curve12", "[", "Alg_", "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E8", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "8"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
         "0"}], "}"}], ",", "0"}], "}"}], "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Matter", "[", 
   RowBox[{"curve_", ",", "Alg_"}], "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{"curve", "==", "1"}], ",", 
    RowBox[{"Curve1", "[", "Alg", "]"}], ",", "\[IndentingNewLine]", 
    RowBox[{"curve", "==", "2"}], ",", 
    RowBox[{"Curve2", "[", "Alg", "]"}], ",", 
    RowBox[{"curve", "==", "3"}], ",", 
    RowBox[{"Curve3", "[", "Alg", "]"}], ",", 
    RowBox[{"curve", "==", "4"}], ",", 
    RowBox[{"Curve4", "[", "Alg", "]"}], ",", 
    RowBox[{"curve", "==", "5"}], ",", 
    RowBox[{"Curve5", "[", "Alg", "]"}], ",", 
    RowBox[{"curve", "==", "6"}], ",", 
    RowBox[{"Curve6", "[", "Alg", "]"}], ",", 
    RowBox[{"curve", "==", "7"}], ",", 
    RowBox[{"Curve7", "[", "Alg", "]"}], ",", 
    RowBox[{"curve", "==", "8"}], ",", 
    RowBox[{"Curve8", "[", "Alg", "]"}], ",", 
    RowBox[{"curve", "==", "12"}], ",", 
    RowBox[{"Curve12", "[", "Alg", "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"MatterFrozen", "[", "Alg_", "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Rank", "[", "Alg", "]"}], "+", "1"}], "\[GreaterEqual]", 
      "7"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "A"}], "]"}]}], 
    ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"Rank", "[", "Alg", "]"}], "+", "1"}], ",", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg", "]"}], "-", "7"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         FractionBox["1", "2"], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Rank", "[", "Alg", "]"}], "+", "1"}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Rank", "[", "Alg", "]"}], "+", "2"}], ")"}]}], ",", "1"}],
        "}"}]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MatterLoop", "[", "Alg_", "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "A"}], "]"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"Rank", "[", "Alg", "]"}], "+", "1"}], ",", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg", "]"}], "+", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         FractionBox["1", "2"], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Rank", "[", "Alg", "]"}], "+", "1"}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Rank", "[", "Alg", "]"}], "+", "2"}], ")"}]}], ",", "1"}],
        "}"}]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CurveT1", "[", "Alg_", "]"}], ":=", 
  RowBox[{"Which", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "A", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "2"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"2", " ", 
        RowBox[{"Rank", "[", 
         RowBox[{"TwistedAlgebra", "[", 
          RowBox[{"T2", ",", "A2"}], "]"}], "]"}]}], ",", "6"}], "}"}], "}"}],
     ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "A", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "3"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"2", 
         RowBox[{"Rank", "[", 
          RowBox[{"TwistedAlgebra", "[", 
           RowBox[{"T2", ",", "A3"}], "]"}], "]"}]}], ",", "6"}], "}"}], ",", 
      
      RowBox[{"{", 
       RowBox[{"5", ",", "1"}], "}"}]}], "}"}], " ", ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "3"}], "}"}]}], "}"}],
     ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "5"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"9", ",", "5"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"16", ",", "3"}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"11", ",", "7"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"32", ",", 
        FractionBox["3", "2"]}], "}"}]}], "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CurveT2", "[", "Alg_", "]"}], ":=", 
  RowBox[{"Which", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
      RowBox[{"AlgebraClass", "[", "A", "]"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{"2", 
        RowBox[{"Rank", "[", 
         RowBox[{"TwistedAlgebra", "[", 
          RowBox[{"T2", ",", "Alg"}], "]"}], "]"}]}], ",", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg", "]"}], "+", "1"}]}], "}"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", "2"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "2"}], "}"}]}], "}"}],
     ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "5"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", "4"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "1"}], 
       "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E6", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "2"}], "}"}],
      "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CurveT3", "[", "Alg_", "]"}], ":=", 
  RowBox[{"Which", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "A", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "2"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0"}], "}"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "1"}], "}"}]}], 
     "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CurveT4", "[", "Alg_", "]"}], ":=", 
  RowBox[{"Which", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"7", ",", "0"}], "}"}], "}"}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "5"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"9", ",", "2"}], "}"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"11", ",", "4"}], "}"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[GreaterEqual]", "7"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"Rank", "[", 
          RowBox[{"TwistedAlgebra", "[", 
           RowBox[{"T2", ",", "Alg"}], "]"}], "]"}]}], "+", "1"}], ",", 
       RowBox[{
        RowBox[{"2", 
         RowBox[{"Rank", "[", "Alg", "]"}]}], "-", "8"}]}], "}"}], "}"}], ",",
     "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E6", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "1"}], "}"}],
      "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CurveT6", "[", "Alg_", "]"}], ":=", 
  RowBox[{"Which", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "E6", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", "0"}], "}"}],
      "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "]"}]}], "\n", 
 RowBox[{
  RowBox[{"MatterT2", "[", 
   RowBox[{"curve_", ",", "Alg_"}], "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{"curve", "==", "1"}], ",", 
    RowBox[{"CurveT1", "[", "Alg", "]"}], ",", "\[IndentingNewLine]", 
    RowBox[{"curve", "==", "2"}], ",", 
    RowBox[{"CurveT2", "[", "Alg", "]"}], ",", 
    RowBox[{"curve", "==", "3"}], ",", 
    RowBox[{"CurveT3", "[", "Alg", "]"}], ",", 
    RowBox[{"curve", "==", "4"}], ",", 
    RowBox[{"CurveT4", "[", "Alg", "]"}], ",", 
    RowBox[{"curve", "==", "6"}], ",", 
    RowBox[{"CurveT6", "[", "Alg", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MatterT3", "[", 
   RowBox[{"curve_", ",", "Alg_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "D"}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"Which", "[", 
     RowBox[{
      RowBox[{"curve", "==", "1"}], ",", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"7", ",", "3"}], "}"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"curve", "==", "2"}], ",", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"7", ",", "2"}], "}"}], "}"}], ",", 
      RowBox[{"curve", "==", "3"}], ",", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"7", ",", "1"}], "}"}], "}"}], ",", 
      RowBox[{"curve", "==", "4"}], ",", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"7", ",", "0"}], "}"}], "}"}]}], "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TotalMatter", "[", 
   RowBox[{"curve_", ",", "Alg_", ",", "T_"}], "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{"T", "\[Equal]", "U"}], "]"}]}], ",", 
    RowBox[{"Matter", "[", 
     RowBox[{"curve", ",", "Alg"}], "]"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{"T", "\[Equal]", "T2"}], "]"}]}], ",", 
    RowBox[{"MatterT2", "[", 
     RowBox[{"curve", ",", "Alg"}], "]"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], "&&", " ", 
     RowBox[{"TrueQ", "[", 
      RowBox[{"T", "\[Equal]", "T3"}], "]"}]}], ",", 
    RowBox[{"MatterT3", "[", 
     RowBox[{"curve", ",", "Alg"}], "]"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "2"}], "&&", " ", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "==", "U"}], "]"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Frozen"}], "]"}]}], ",", 
    
    RowBox[{"MatterFrozen", "[", "Alg", "]"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "2"}], "&&", " ", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "==", "U"}], "]"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Loop"}], "]"}]}], ",", 
    RowBox[{"MatterLoop", "[", "Alg", "]"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "2"}], "&&", " ", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "==", "U"}], "]"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "CoSpinor"}], "]"}], "&&", 
     RowBox[{"curve", "\[LessEqual]", "2"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"12", ",", 
        RowBox[{"8", "-", "curve"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
         "}"}], ",", 
        RowBox[{
         FractionBox["1", "2"], 
         RowBox[{"(", 
          RowBox[{"3", "-", "curve"}], ")"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
         "}"}], ",", 
        FractionBox["1", "2"]}], "}"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "2"}], "&&", " ", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "T2"}], "]"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "CoSpinor"}], "]"}], "&&", 
     RowBox[{"curve", "\[Equal]", "2"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
        "6"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
        FractionBox["1", "2"]}], "}"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "2"}], "&&", " ", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "==", "U"}], "]"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Three"}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "5"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "A"}], "]"}]}], 
    ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"6", ",", "15"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"20", ",", 
        FractionBox["1", "2"]}], "}"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "2"}], "&&", " ", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "==", "U"}], "]"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Loop"}], "]"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "A"}], "]"}]}], 
    ",", 
    RowBox[{"Matter", "[", 
     RowBox[{"1", ",", "Alg"}], "]"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], "&&", " ", 
     RowBox[{"TrueQ", "[", 
      RowBox[{"T", "==", "U"}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "B"}], "]"}]}], 
    ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
         "}"}], ",", "7"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
         "}"}], ",", 
        FractionBox["1", "2"]}], "}"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FundamentalRepDim", "[", "Alg_", "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
      RowBox[{"AlgebraClass", "[", "A", "]"}]}], "]"}], ",", 
    RowBox[{
     RowBox[{"Rank", "[", "Alg", "]"}], "+", "1"}], ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
      RowBox[{"AlgebraClass", "[", "B", "]"}]}], "]"}], ",", 
    RowBox[{
     RowBox[{"2", " ", 
      RowBox[{"Rank", "[", "Alg", "]"}]}], "+", "1"}], ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
      RowBox[{"AlgebraClass", "[", "C", "]"}]}], "]"}], ",", 
    RowBox[{"2", " ", 
     RowBox[{"Rank", "[", "Alg", "]"}]}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "\[NotEqual]", "4"}]}], ",", 
    RowBox[{"2", " ", 
     RowBox[{"Rank", "[", "Alg", "]"}]}], ",", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg", "]"}], "==", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
      RowBox[{"AlgebraClass", "[", "G2", "]"}]}], "]"}], ",", "7", ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
      RowBox[{"AlgebraClass", "[", "F4", "]"}]}], "]"}], ",", "26", ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
      RowBox[{"AlgebraClass", "[", "E7", "]"}]}], "]"}], ",", "56", ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
      RowBox[{"AlgebraClass", "[", "E8", "]"}]}], "]"}], ",", "248", ",", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"AlgebraClass", "[", "Alg", "]"}], "==", 
      RowBox[{"AlgebraClass", "[", "E6", "]"}]}], "]"}], ",", "27"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Bifundamental", "[", 
   RowBox[{"Alg1_", ",", "T1_", ",", "Alg2_", ",", "T_", ",", "Lines_"}], 
   "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "A", "]"}]}], "]"}], "\[Or]", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "C", "]"}]}], "]"}]}], ",", 
    RowBox[{"Which", "[", 
     RowBox[{
      RowBox[{"TrueQ", "[", 
       RowBox[{
        RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "==", 
        RowBox[{"AlgebraClass", "[", "A", "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FundamentalRepDim", "[", 
          RowBox[{"AT", "[", 
           RowBox[{"T1", ",", "Alg1"}], "]"}], "]"}], ",", 
         RowBox[{"FundamentalRepDim", "[", 
          RowBox[{"AT", "[", 
           RowBox[{"T", ",", "Alg2"}], "]"}], "]"}], ",", "1"}], "     ", 
        "}"}], "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "==", 
           RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "\[Or]", 
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "==", 
           RowBox[{"AlgebraClass", "[", "B", "]"}]}], "]"}]}], ")"}], "&&", 
       RowBox[{"Lines", "\[Equal]", "1"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FundamentalRepDim", "[", 
          RowBox[{"AT", "[", 
           RowBox[{"T1", ",", "Alg1"}], "]"}], "]"}], ",", 
         RowBox[{"FundamentalRepDim", "[", 
          RowBox[{"AT", "[", 
           RowBox[{"T", ",", "Alg2"}], "]"}], "]"}], ",", 
         FractionBox["1", "2"]}], "}"}], "}"}], ",", 
      RowBox[{"TrueQ", "[", 
       RowBox[{
        RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "==", 
        RowBox[{"AlgebraClass", "[", "G2", "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FundamentalRepDim", "[", 
          RowBox[{"AT", "[", 
           RowBox[{"T1", ",", "Alg1"}], "]"}], "]"}], ",", "7", ",", 
         FractionBox["1", "2"]}], "     ", "}"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "==", 
           RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "\[Or]", 
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "==", 
           RowBox[{"AlgebraClass", "[", "B", "]"}]}], "]"}]}], ")"}], "&&", 
       RowBox[{"Lines", "\[Equal]", "2"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FundamentalRepDim", "[", 
          RowBox[{"AT", "[", 
           RowBox[{"T1", ",", "Alg1"}], "]"}], "]"}], ",", 
         RowBox[{"FundamentalRepDim", "[", 
          RowBox[{"AT", "[", 
           RowBox[{"T", ",", "Alg2"}], "]"}], "]"}], ",", "1"}], "}"}], 
       "}"}]}], "\[IndentingNewLine]", "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"BiSpinor", "[", 
   RowBox[{"Alg1_", ",", "T1_", ",", "Alg2_", ",", "T_"}], "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "B", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "3"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FundamentalRepDim", "[", 
        RowBox[{"AT", "[", 
         RowBox[{"T1", ",", "Alg1"}], "]"}], "]"}], ",", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{"0", ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{
               RowBox[{"Rank", "[", 
                RowBox[{"AT", "[", 
                 RowBox[{"T", ",", "Alg2"}], "]"}], "]"}], "-", "1"}]}], 
             "}"}]}], "]"}], ",", "1"}], "}"}], "]"}], ",", 
       FractionBox["1", "2"]}], "     ", "}"}], "}"}], ",", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "D", "]"}]}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "4"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FundamentalRepDim", "[", 
        RowBox[{"AT", "[", 
         RowBox[{"T1", ",", "Alg1"}], "]"}], "]"}], ",", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{"0", ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{
               RowBox[{"Rank", "[", 
                RowBox[{"AT", "[", 
                 RowBox[{"T", ",", "Alg2"}], "]"}], "]"}], "-", "1"}]}], 
             "}"}]}], "]"}], ",", "1"}], "}"}], "]"}], ",", 
       FractionBox["1", "2"]}], "     ", "}"}], "}"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TotalBi2", "[", 
   RowBox[{
   "Alg1_", ",", "T1_", ",", "k1_", ",", "Alg2_", ",", "T2_", ",", "Lines_"}],
    "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "D"}], "]"}],
        "&&", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "4"}]}], ")"}], 
     "\[Or]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "B"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "3"}]}], ")"}], "&&", 
      RowBox[{"Lines", "\[Equal]", "1"}]}]}], ",", 
    RowBox[{"Which", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "D"}], "]"}],
        "&&", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "4"}], "&&", 
       RowBox[{"k1", "\[Equal]", "1"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "T2", "]"}], ">", "0"}], "&&", 
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"T2", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "S"}], "]"}]}], ",", 
        RowBox[{"BiSpinor", "[", 
         RowBox[{"Alg1", ",", "T1", ",", "Alg2", ",", 
          RowBox[{"T2", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ",", 
        RowBox[{"Bifundamental", "[", 
         RowBox[{"Alg1", ",", "T1", ",", "Alg2", ",", "T2", ",", "Lines"}], 
         "]"}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "B"}], "]"}],
        "&&", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "3"}], "&&", 
       RowBox[{"k1", "\[Equal]", "1"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "T2", "]"}], ">", "0"}], "&&", 
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"T2", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "S"}], "]"}]}], ",", 
        RowBox[{"BiSpinor", "[", 
         RowBox[{"Alg1", ",", "T1", ",", "Alg2", ",", 
          RowBox[{"T2", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ",", 
        RowBox[{"Bifundamental", "[", 
         RowBox[{"Alg1", ",", "T1", ",", "Alg2", ",", "T2", ",", "Lines"}], 
         "]"}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "B"}], "]"}],
        "&&", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "3"}], "&&", 
       RowBox[{"k1", "\[Equal]", "2"}], "&&", 
       RowBox[{
        RowBox[{"Length", "[", "T2", "]"}], ">", "1"}]}], ",", 
      RowBox[{"BiSpinor", "[", 
       RowBox[{"Alg1", ",", "T1", ",", "Alg2", ",", 
        RowBox[{"T2", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
    RowBox[{"Bifundamental", "[", 
     RowBox[{"Alg1", ",", "T1", ",", "Alg2", ",", "T2", ",", "Lines"}], 
     "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"swap", "[", "a_", "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "a", "]"}], ">", "0"}], ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}], ",", 
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       RowBox[{
        RowBox[{"a", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TT", "[", "x_", "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "x", "]"}], ">", "0"}], ",", 
    RowBox[{"x", "[", 
     RowBox[{"[", "1", "]"}], "]"}], ",", "x"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TotalBi", "[", 
   RowBox[{
   "Alg1_", ",", "T1_", ",", "k1_", ",", "Alg2_", ",", "T2_", ",", "k2_", ",",
     "Lines_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "A", "]"}]}], "]"}], "\[Or]", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "==", 
       RowBox[{"AlgebraClass", "[", "C", "]"}]}], "]"}]}], ",", 
    RowBox[{"TotalBi2", "[", 
     RowBox[{
     "Alg1", ",", "T1", ",", "k1", ",", "Alg2", ",", "T2", ",", "Lines"}], 
     "]"}], ",", 
    RowBox[{"swap", "[", 
     RowBox[{"TotalBi2", "[", 
      RowBox[{
      "Alg2", ",", "T2", ",", "k2", ",", "Alg1", ",", "T1", ",", "Lines"}], 
      "]"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Whichrep", "[", 
   RowBox[{"Alg_", ",", "T_"}], "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], "\[Or]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[NotEqual]", "0"}], "&&", 
       RowBox[{"UnsameQ", "[", 
        RowBox[{
         RowBox[{"T", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", "S"}], "]"}]}], ")"}]}], ",", 
    RowBox[{"FundamentalRepDim", "[", 
     RowBox[{"AT", "[", 
      RowBox[{
       RowBox[{"TT", "[", "T", "]"}], ",", "Alg"}], "]"}], "]"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "T", "]"}], "\[NotEqual]", "0"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"T", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "==", "S"}], "]"}]}], ",", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{"0", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{
            RowBox[{"Rank", "[", 
             RowBox[{"AT", "[", 
              RowBox[{
               RowBox[{"TT", "[", "T", "]"}], ",", "Alg"}], "]"}], "]"}], "-",
             "1"}]}], "}"}]}], "]"}], ",", "1"}], "}"}], "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LM", "[", "T_", "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], ",", "T", ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"TrueQ", "[", 
       RowBox[{
        RowBox[{"T", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "S"}], "]"}], ",", 
      RowBox[{"T", "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", "T"}], "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LB", "[", "T_", "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], ",", "T", ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"TrueQ", "[", 
       RowBox[{
        RowBox[{"T", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "S"}], "]"}], ",", "T", 
      ",", 
      RowBox[{"T", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NM", "[", 
   RowBox[{"i_", ",", "T1_", ",", "T2_", ",", "Alg2_", ",", "k2_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"i", "\[Equal]", "1"}], ",", "T1", ",", "T2"}], "]"}], "]"}],
       "\[Equal]", "0"}], "\[Or]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", "1"}], ",", "T1", ",", "T2"}], "]"}], 
         "]"}], "\[NotEqual]", "0"}], "&&", 
       RowBox[{"UnsameQ", "[", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", "1"}], ",", 
           RowBox[{"T1", "[", 
            RowBox[{"[", "2", "]"}], "]"}], ",", 
           RowBox[{"T2", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", "S"}], "]"}]}], 
      ")"}]}], ",", "1", ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "B"}], 
          "]"}], "&&", 
         RowBox[{"k2", "\[Equal]", "3"}], "&&", 
         RowBox[{"i", "\[Equal]", "2"}]}], ")"}], "\[Or]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "B"}], 
          "]"}], "&&", 
         RowBox[{"k2", "\[Equal]", "3"}], "&&", 
         RowBox[{"i", "\[Equal]", "1"}]}], ")"}]}], ",", "1", ",", "2"}], 
     "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NM2", "[", 
   RowBox[{
   "i_", ",", "T1_", ",", "T2_", ",", "Alg1_", ",", "Alg2_", ",", "k1_", ",", 
    "k2_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"i", "\[Equal]", "1"}], ",", "T1", ",", "T2"}], "]"}], "]"}],
       "\[Equal]", "0"}], "\[Or]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", "1"}], ",", "T1", ",", "T2"}], "]"}], 
         "]"}], "\[NotEqual]", "0"}], "&&", 
       RowBox[{"UnsameQ", "[", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"i", "\[Equal]", "1"}], ",", 
           RowBox[{"T1", "[", 
            RowBox[{"[", "2", "]"}], "]"}], ",", 
           RowBox[{"T2", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", "S"}], "]"}]}], 
      ")"}]}], ",", "1", ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "B"}], 
          "]"}], "&&", 
         RowBox[{"k2", "\[Equal]", "3"}], "&&", 
         RowBox[{"i", "\[Equal]", "2"}]}], ")"}], "\[Or]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "B"}], 
          "]"}], "&&", 
         RowBox[{"k1", "\[Equal]", "3"}], "&&", 
         RowBox[{"i", "\[Equal]", "1"}]}], ")"}]}], ",", "1", ",", "2"}], 
     "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"swap3", "[", 
   RowBox[{"A_", ",", "j_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "A", "]"}], ">", "1"}], ",", 
    RowBox[{"ReplacePart", "[", 
     RowBox[{"A", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "\[Rule]", 
         RowBox[{"A", "[", 
          RowBox[{"[", "j", "]"}], "]"}]}], ",", 
        RowBox[{"2", "\[Rule]", 
         RowBox[{"A", "[", 
          RowBox[{"[", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"j", "\[Equal]", "1"}], ",", "2", ",", "1"}], "]"}], " ",
            "]"}], "]"}]}]}], "}"}]}], "]"}], ",", "A"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Gauging2", "[", 
   RowBox[{
   "Alg1_", ",", "T1_", ",", "k1_", ",", "Alg2_", ",", "T2_", ",", "k2_", ",",
     "Lines_", ",", "\[CapitalOmega]_"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{"T1", "\[Equal]", "U"}], "]"}], "\[Or]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "T1", "]"}], "\[Equal]", "2"}], "&&", 
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"T1", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "U"}], "]"}]}], 
         ")"}]}], ",", "1", ",", 
       FractionBox["1", "2"]}], "]"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "B"}], 
           "]"}], "&&", 
          RowBox[{
           RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "3"}], "&&", 
          RowBox[{"k1", "\[GreaterEqual]", "1"}], "&&", 
          RowBox[{"k1", "\[LessEqual]", "2"}], "&&", 
          RowBox[{"k2", "\[Equal]", "2"}], "&&", 
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "A"}], 
           "]"}], "&&", 
          RowBox[{
           RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "1"}]}], ",", "  ", 
         RowBox[{
          RowBox[{
           RowBox[{"TotalMatter", "[", 
            RowBox[{"k1", ",", "Alg1", ",", "U"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"TotalMatter", "[", 
            RowBox[{"k1", ",", "Alg1", ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"Length", "[", "T1", "]"}], "\[Equal]", "2"}], "&&", 
                
                RowBox[{"TrueQ", "[", 
                 RowBox[{
                  RowBox[{"T1", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Loop"}], 
                 "]"}]}], ",", "T1", ",", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"Length", "[", "T1", "]"}], "\[Equal]", "2"}], "&&", 
                  RowBox[{"TrueQ", "[", 
                   RowBox[{
                    RowBox[{"T1", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Three"}], 
                   "]"}]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"U", ",", "Three"}], "}"}], ",", "U"}], "]"}]}], 
              "]"}]}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], "]"}], " ", "+", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"\[CapitalOmega]", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "!=", 
           RowBox[{
            RowBox[{"\[CapitalOmega]", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], ",", 
          RowBox[{
           RowBox[{"\[CapitalOmega]", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}], ",", 
          RowBox[{"-", "1"}]}], "]"}], " ", 
        RowBox[{
         RowBox[{
          RowBox[{"TotalBi", "[", 
           RowBox[{"Alg1", ",", 
            RowBox[{"LB", "[", "T1", "]"}], ",", "k1", ",", "Alg2", ",", 
            RowBox[{"LB", "[", "T2", "]"}], ",", "k2", ",", "Lines"}], "]"}], 
          "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", "3", "]"}], "]"}], 
        RowBox[{"Which", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"Whichrep", "[", 
             RowBox[{"Alg2", ",", "T2"}], "]"}], "]"}], "==", "0"}], ",", 
          RowBox[{"Whichrep", "[", 
           RowBox[{"Alg2", ",", "T2"}], "]"}], ",", 
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"Whichrep", "[", 
             RowBox[{"Alg2", ",", "T2"}], "]"}], "]"}], ">", "0"}], ",", 
          "8"}], "]"}]}]}], ")"}]}], ",", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{"T2", "\[Equal]", "U"}], "]"}], "\[Or]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "T2", "]"}], "\[Equal]", "2"}], "&&", 
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"T2", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "U"}], "]"}]}], 
         ")"}]}], ",", "1", ",", 
       FractionBox["1", "2"]}], "]"}], 
     RowBox[{"(", "  ", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "B"}], 
           "]"}], "&&", 
          RowBox[{
           RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "3"}], "&&", 
          RowBox[{"k1", "\[Equal]", "2"}], "&&", 
          RowBox[{"k2", "<=", "2"}], "&&", 
          RowBox[{"k2", "\[GreaterEqual]", "1"}], "&&", 
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
           "]"}], "&&", 
          RowBox[{
           RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "1"}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"TotalMatter", "[", 
            RowBox[{"k2", ",", "Alg2", ",", "U"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"TotalMatter", "[", 
            RowBox[{"k2", ",", "Alg2", ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"Length", "[", "T2", "]"}], "\[Equal]", "2"}], "&&", 
                
                RowBox[{"TrueQ", "[", 
                 RowBox[{
                  RowBox[{"T2", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Loop"}], 
                 "]"}]}], ",", "T2", ",", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"Length", "[", "T2", "]"}], "\[Equal]", "2"}], "&&", 
                  RowBox[{"TrueQ", "[", 
                   RowBox[{
                    RowBox[{"T2", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Three"}], 
                   "]"}]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"U", ",", "Three"}], "}"}], ",", "U"}], "]"}]}], 
              "]"}]}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], " ", "]"}], "  ", "+", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"\[CapitalOmega]", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "!=", 
           RowBox[{
            RowBox[{"\[CapitalOmega]", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], ",", 
          RowBox[{
           RowBox[{"\[CapitalOmega]", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{"-", "1"}]}], "]"}], 
        RowBox[{
         RowBox[{
          RowBox[{"TotalBi", "[", 
           RowBox[{"Alg1", ",", 
            RowBox[{"LB", "[", "T1", "]"}], ",", "k1", ",", "Alg2", ",", 
            RowBox[{"LB", "[", "T2", "]"}], ",", "k2", ",", "Lines"}], "]"}], 
          "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", "3", "]"}], "]"}], 
        RowBox[{"Which", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"Whichrep", "[", 
             RowBox[{"Alg1", ",", "T1"}], "]"}], "]"}], "==", "0"}], ",", 
          RowBox[{"Whichrep", "[", 
           RowBox[{"Alg1", ",", "T1"}], "]"}], ",", 
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"Whichrep", "[", 
             RowBox[{"Alg1", ",", "T1"}], "]"}], "]"}], ">", "0"}], ",", 
          "8"}], "]"}]}]}], ")"}]}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MassGauging", "[", 
   RowBox[{
   "Alg1_", ",", "T1_", ",", "k1_", ",", "Alg2_", ",", "T_", ",", "k2_", ",", 
    "Lines_", ",", "\[CapitalOmega]_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "1"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "D"}], "]"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "4"}], "&&", 
     RowBox[{
      RowBox[{
       RowBox[{"\[CapitalOmega]", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
      RowBox[{"-", "2"}]}], "&&", 
     RowBox[{"3", "\[LessEqual]", "k2", "\[LessEqual]", "3"}], "&&", 
     RowBox[{"k1", "\[Equal]", "1"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{"T", "\[Equal]", "T2"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"2", ",", "6"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", 
          FractionBox["1", "2"]}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "0"}], "}"}], 
       "}"}]}], "}"}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "A"}], "]"}],
        "&&", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "1"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "D"}], "]"}],
        "&&", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "4"}], "&&", 
       RowBox[{
        RowBox[{
         RowBox[{"\[CapitalOmega]", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
        RowBox[{"-", "2"}]}], "&&", 
       RowBox[{"3", "\[LessEqual]", "k1", "\[LessEqual]", "3"}], "&&", 
       RowBox[{"k2", "\[Equal]", "1"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{"T1", "\[Equal]", "T2"}], "]"}]}], ",", 
      RowBox[{"{", "  ", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", "0"}], "}"}], " ", 
         "}"}], "   ", ",", " ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"2", ",", "6"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", 
            FractionBox["1", "2"]}], "}"}]}], "}"}]}], "}"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"\[CapitalOmega]", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "2"}], "&&", 
         RowBox[{
          RowBox[{
           RowBox[{"\[CapitalOmega]", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "2"}], "&&", 
         RowBox[{
          RowBox[{
           RowBox[{"\[CapitalOmega]", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "!=", 
          RowBox[{
           RowBox[{"\[CapitalOmega]", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "&&", 
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
          "]"}], "&&", 
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "A"}], 
          "]"}]}], ",", 
        RowBox[{"Table", "[", "      ", 
         RowBox[{
          RowBox[{"swap3", "[", " ", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Floor", "[", 
                RowBox[{
                 RowBox[{"Gauging2", "[", 
                  RowBox[{
                  "Alg1", ",", "T1", ",", "k1", ",", "Alg2", ",", "T", ",", 
                   "k2", ",", "Lines", ",", "\[CapitalOmega]"}], "]"}], "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "]"}], "\[Equal]", 
               RowBox[{
                RowBox[{"Gauging2", "[", 
                 RowBox[{
                 "Alg1", ",", "T1", ",", "k1", ",", "Alg2", ",", "T", ",", 
                  "k2", ",", "Lines", ",", "\[CapitalOmega]"}], "]"}], "[", 
                RowBox[{"[", "i", "]"}], "]"}]}], ",", 
              RowBox[{"Prepend", "[", 
               RowBox[{
                RowBox[{"Delete", "[", 
                 RowBox[{
                  RowBox[{"TotalMatter", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", "k1", ",", "k2"}], 
                    "]"}], ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", "Alg1", ",", 
                    "Alg2"}], "]"}], ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", 
                    RowBox[{"LM", "[", "T1", "]"}], ",", 
                    RowBox[{"LM", "[", "T", "]"}]}], "]"}]}], "]"}], ",", 
                  RowBox[{"NM", "[", 
                   RowBox[{"i", ",", "T1", ",", "T", ",", "Alg2", ",", "k2"}],
                    "]"}]}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Whichrep", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", "Alg1", ",", 
                    "Alg2"}], "]"}], ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", "T1", ",", "T"}], 
                    "]"}]}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"Gauging2", "[", 
                    RowBox[{
                    "Alg1", ",", "T1", ",", "k1", ",", "Alg2", ",", "T", ",", 
                    "k2", ",", "Lines", ",", "\[CapitalOmega]"}], "]"}], "[", 
                   
                   RowBox[{"[", "i", "]"}], "]"}]}], "}"}]}], "]"}], ",", 
              RowBox[{"Prepend", "[", 
               RowBox[{
                RowBox[{"Prepend", "[", 
                 RowBox[{
                  RowBox[{"Delete", "[", 
                   RowBox[{
                    RowBox[{"TotalMatter", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", "k1", ",", "k2"}], 
                    "]"}], ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", "Alg1", ",", 
                    "Alg2"}], "]"}], ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", 
                    RowBox[{"LM", "[", "T1", "]"}], ",", 
                    RowBox[{"LM", "[", "T", "]"}]}], "]"}]}], "]"}], ",", 
                    RowBox[{"NM", "[", 
                    RowBox[{
                    "i", ",", "T1", ",", "T", ",", "Alg2", ",", "k2"}], 
                    "]"}]}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Whichrep", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", "Alg1", ",", 
                    "Alg2"}], "]"}], ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", "T1", ",", "T"}], 
                    "]"}]}], "]"}], ",", 
                    RowBox[{"Floor", "[", 
                    RowBox[{
                    RowBox[{"Gauging2", "[", 
                    RowBox[{
                    "Alg1", ",", "T1", ",", "k1", ",", "Alg2", ",", "T", ",", 
                    "k2", ",", "Lines", ",", "\[CapitalOmega]"}], "]"}], "[", 
                    
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
                ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"FundamentalRepDim", "[", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", "T1", "]"}], ",", "Alg1"}], "]"}], ",", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", "T", "]"}], ",", "Alg2"}], "]"}]}], 
                    "]"}], "]"}], ",", 
                  FractionBox["1", "2"]}], "}"}]}], "]"}]}], "]"}], ",", 
            RowBox[{"NM", "[", 
             RowBox[{"i", ",", "T1", ",", "T", ",", "Alg2", ",", "k2"}], 
             "]"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", "2"}], "}"}]}], "]"}], ",", 
        RowBox[{"Table", "[", "      ", 
         RowBox[{
          RowBox[{"swap3", "[", " ", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Floor", "[", 
                RowBox[{
                 RowBox[{"Gauging2", "[", 
                  RowBox[{
                  "Alg1", ",", "T1", ",", "k1", ",", "Alg2", ",", "T", ",", 
                   "k2", ",", "Lines", ",", "\[CapitalOmega]"}], "]"}], "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "]"}], "\[Equal]", 
               RowBox[{
                RowBox[{"Gauging2", "[", 
                 RowBox[{
                 "Alg1", ",", "T1", ",", "k1", ",", "Alg2", ",", "T", ",", 
                  "k2", ",", "Lines", ",", "\[CapitalOmega]"}], "]"}], "[", 
                RowBox[{"[", "i", "]"}], "]"}]}], ",", 
              RowBox[{"Prepend", "[", 
               RowBox[{
                RowBox[{"Delete", "[", 
                 RowBox[{
                  RowBox[{"TotalMatter", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", "k1", ",", "k2"}], 
                    "]"}], ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", "Alg1", ",", 
                    "Alg2"}], "]"}], ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", 
                    RowBox[{"LM", "[", "T1", "]"}], ",", 
                    RowBox[{"LM", "[", "T", "]"}]}], "]"}]}], "]"}], ",", 
                  RowBox[{"NM2", "[", 
                   RowBox[{
                   "i", ",", "T1", ",", "T", ",", "Alg1", ",", "Alg2", ",", 
                    "k1", ",", "k2"}], "]"}]}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Whichrep", "[", 
                   RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", "Alg1", ",", 
                    "Alg2"}], "]"}], ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", "T1", ",", "T"}], 
                    "]"}]}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"Gauging2", "[", 
                    RowBox[{
                    "Alg1", ",", "T1", ",", "k1", ",", "Alg2", ",", "T", ",", 
                    "k2", ",", "Lines", ",", "\[CapitalOmega]"}], "]"}], "[", 
                   
                   RowBox[{"[", "i", "]"}], "]"}]}], "}"}]}], "]"}], ",", 
              RowBox[{"Prepend", "[", 
               RowBox[{
                RowBox[{"Prepend", "[", 
                 RowBox[{
                  RowBox[{"Delete", "[", 
                   RowBox[{
                    RowBox[{"TotalMatter", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", "k1", ",", "k2"}], 
                    "]"}], ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", "Alg1", ",", 
                    "Alg2"}], "]"}], ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", 
                    RowBox[{"LM", "[", "T1", "]"}], ",", 
                    RowBox[{"LM", "[", "T", "]"}]}], "]"}]}], "]"}], ",", 
                    RowBox[{"NM", "[", 
                    RowBox[{
                    "i", ",", "T1", ",", "T", ",", "Alg2", ",", "k2"}], 
                    "]"}]}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Whichrep", "[", 
                    RowBox[{
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", "Alg1", ",", 
                    "Alg2"}], "]"}], ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", "T1", ",", "T"}], 
                    "]"}]}], "]"}], ",", 
                    RowBox[{"Floor", "[", 
                    RowBox[{
                    RowBox[{"Gauging2", "[", 
                    RowBox[{
                    "Alg1", ",", "T1", ",", "k1", ",", "Alg2", ",", "T", ",", 
                    "k2", ",", "Lines", ",", "\[CapitalOmega]"}], "]"}], "[", 
                    
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
                ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"FundamentalRepDim", "[", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"i", "\[Equal]", "1"}], ",", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", "T1", "]"}], ",", "Alg1"}], "]"}], ",", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", "T", "]"}], ",", "Alg2"}], "]"}]}], 
                    "]"}], "]"}], ",", 
                  FractionBox["1", "2"]}], "}"}]}], "]"}]}], "]"}], ",", 
            RowBox[{"NM", "[", 
             RowBox[{"i", ",", "T1", ",", "T", ",", "Alg2", ",", "k2"}], 
             "]"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", "2"}], "}"}]}], "]"}]}], "]"}]}], 
     "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"irrep3", "[", 
   RowBox[{
    RowBox[{"{", "x__", "}"}], ",", "Type_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Irrep", "[", "Type", "]"}], "[", "x", 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"irrep2", "[", 
   RowBox[{"rep_", ",", "Alg_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "rep", "]"}], ">", "0"}], ",", 
    RowBox[{"irrep3", "[", 
     RowBox[{"rep", ",", 
      RowBox[{"AlgebraClass", "[", "Alg", "]"}]}], "]"}], ",", 
    RowBox[{
     RowBox[{"Irrep", "[", "Alg", "]"}], "[", "rep", "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Allowed6d1", "[", 
   RowBox[{"Alg_", ",", "T_", ",", "k_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"TT", "[", "T", "]"}], "\[Equal]", "U"}], "]"}], ",", 
    RowBox[{"Which", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "C"}], "]"}], 
       "&&", 
       RowBox[{"k", "\[Equal]", "1"}], "&&", 
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "A"}], "]"}], 
       "&&", 
       RowBox[{"k", "\[Equal]", "1"}], "&&", 
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[NotEqual]", "0"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "A"}], "]"}], 
       "&&", 
       RowBox[{"k", "\[Equal]", "1"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"T", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Frozen"}], "]"}], "&&", 
       RowBox[{
        RowBox[{
         RowBox[{"Rank", "[", "Alg", "]"}], "+", "1"}], "\[GreaterEqual]", 
        "8"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[NotEqual]", "0"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "A"}], "]"}], 
       "&&", 
       RowBox[{"k", "\[Equal]", "1"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"T", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Three"}], "]"}], "&&", 
       
       RowBox[{
        RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "5"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "A"}], "]"}], 
       "&&", 
       RowBox[{"k", "\[Equal]", "2"}], "&&", 
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "A"}], "]"}], 
       "&&", 
       RowBox[{"k", "\[Equal]", "3"}], "&&", 
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], "&&", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "2"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "B"}], 
          "]"}], "\[Or]", 
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "D"}], 
          "]"}]}], ")"}], "&&", 
       RowBox[{"k", "\[Equal]", "4"}], "&&", 
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], "&&", " ", 
       RowBox[{
        RowBox[{"Dim", "[", 
         RowBox[{"irrep2", "[", 
          RowBox[{
           RowBox[{"FundamentalRepDim", "[", "Alg", "]"}], ",", "Alg"}], 
          "]"}], "]"}], "\[GreaterEqual]", "8"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "D"}], "]"}], 
       "&&", 
       RowBox[{"1", "\[LessEqual]", "k", "\[LessEqual]", "3"}], "&&", 
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], "&&", " ", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "B"}], 
          "]"}], "\[Or]", 
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "D"}], 
          "]"}]}], ")"}], "&&", 
       RowBox[{"1", "\[LessEqual]", "k", "\[LessEqual]", "3"}], "&&", 
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], "&&", " ", 
       RowBox[{"12", "\[GreaterEqual]", 
        RowBox[{"Dim", "[", 
         RowBox[{"irrep2", "[", 
          RowBox[{
           RowBox[{"FundamentalRepDim", "[", "Alg", "]"}], ",", "Alg"}], 
          "]"}], "]"}], "\[GreaterEqual]", "7"}], "&&", 
       RowBox[{
        RowBox[{"Dim", "[", 
         RowBox[{"irrep2", "[", 
          RowBox[{
           RowBox[{"FundamentalRepDim", "[", "Alg", "]"}], ",", "Alg"}], 
          "]"}], "]"}], "\[NotEqual]", "8"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[NotEqual]", "0"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "D"}], "]"}], 
       "&&", 
       RowBox[{"1", "\[LessEqual]", "k", "\[LessEqual]", "2"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"T", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "CoSpinor"}], "]"}], "&&",
        " ", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "B"}], "]"}], 
       "&&", 
       RowBox[{"k", "\[Equal]", "2"}], "&&", 
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], "&&", " ", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "G2"}], "]"}],
        "&&", 
       RowBox[{"1", "\[LessEqual]", "k", "\[LessEqual]", "3"}], "&&", 
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "F4"}], "]"}],
        "&&", 
       RowBox[{"1", "\[LessEqual]", "k", "\[LessEqual]", "5"}], "&&", 
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[NotEqual]", "0"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "A"}], "]"}], 
       "&&", 
       RowBox[{"k", "\[Equal]", "1"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"T", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Loop"}], "]"}]}], ",", 
      
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "E6"}], "]"}],
        "&&", 
       RowBox[{"1", "\[LessEqual]", "k", "\[LessEqual]", "6"}], "&&", 
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "E7"}], "]"}],
        "&&", 
       RowBox[{"1", "\[LessEqual]", "k", "\[LessEqual]", "8"}], "&&", 
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "E8"}], "]"}],
        "&&", 
       RowBox[{"k", "\[Equal]", "12"}], "&&", 
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}]}], ",", 
      RowBox[{"{", "1", "}"}]}], "]"}], ",", 
    RowBox[{"Which", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{"T", "\[Equal]", "T2"}], "]"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "A"}], "]"}], 
       "&&", 
       RowBox[{"k", "\[Equal]", "1"}], "&&", 
       RowBox[{"3", "\[LessEqual]", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg", "]"}], "+", "1"}], "\[LessEqual]", 
        "4"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{"T", "\[Equal]", "T2"}], "]"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "A"}], "]"}], 
       "&&", 
       RowBox[{"k", "\[Equal]", "2"}], "&&", 
       RowBox[{"2", "\[LessEqual]", 
        RowBox[{"Rank", "[", "Alg", "]"}]}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{"T", "\[Equal]", "T2"}], "]"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "A"}], "]"}], 
       "&&", 
       RowBox[{"k", "\[Equal]", "3"}], "&&", 
       RowBox[{"2", "\[Equal]", 
        RowBox[{"Rank", "[", "Alg", "]"}]}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{"T", "\[Equal]", "T2"}], "]"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "D"}], "]"}], 
       "&&", 
       RowBox[{"k", "\[Equal]", "4"}], "&&", 
       RowBox[{"5", "\[LessEqual]", 
        RowBox[{"Rank", "[", "Alg", "]"}]}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{"T", "\[Equal]", "T2"}], "]"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "D"}], "]"}], 
       "&&", 
       RowBox[{"k", "\[Equal]", "2"}], "&&", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "5"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[NotEqual]", "0"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"T", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "T2"}], "]"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"T", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "CoSpinor"}], "]"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "D"}], "]"}], 
       "&&", 
       RowBox[{"k", "\[Equal]", "2"}], "&&", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "6"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{"T", "\[Equal]", "T2"}], "]"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "E6"}], "]"}],
        "&&", 
       RowBox[{"EvenQ", "[", "k", "]"}], "&&", 
       RowBox[{"2", "\[LessEqual]", "k", "\[LessEqual]", "6"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{"T", "\[Equal]", "T3"}], "]"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "D"}], "]"}], 
       "&&", 
       RowBox[{"1", "\[LessEqual]", "k", "\[LessEqual]", "4"}], "&&", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "T", "]"}], "\[Equal]", "0"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{"T", "\[Equal]", "T2"}], "]"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "D"}], "]"}], 
       "&&", 
       RowBox[{"1", "\[LessEqual]", "k", "\[LessEqual]", "4"}], "&&", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "4"}]}], ",", 
      RowBox[{"{", "1", "}"}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"weight", "[", "representation___", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"irrep", "=", "representation"}], ",", "rank", ",", "W", ",", 
       "S", ",", "sgn", ",", "dired", ",", "zWind", ",", "refl", ",", "const",
        ",", "fsgns", ",", "vec3", ",", "sgnov", ",", "ineq", ",", "oversign",
        ",", "truth", ",", "candsign", ",", "truelist", ",", "i", ",", "j", 
       ",", "k", ",", "l", ",", "grpos", ",", "truesign", ",", "dummysign", 
       ",", "indsign", ",", "constsign", ",", "zindex", ",", "fullineq", ",", 
       "diff", ",", "defsign", ",", "pos", ",", "neg", ",", "zero", ",", 
       "zerorep", ",", "max", ",", "wtgrph", ",", "tenslabel", ",", 
       "newlabel"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "convert", " ", "a", " ", "list", " ", "to", " ", "a", " ", "vector"}], 
      " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"vec3", "[", "x_", "]"}], ":=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"x", "[", 
          RowBox[{"[", "i", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "x", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "convert", " ", "irreps", " ", "into", " ", "lists", " ", "of", " ", 
        "vectors"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"j", "=", "1"}], ",", 
        RowBox[{"j", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "convert", " ", "weights", " ", "to", " ", "alpha", " ", "basis"}], 
         " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"W", "[", "j", "]"}], "=", 
          RowBox[{"Map", "[", 
           RowBox[{"vec3", ",", 
            RowBox[{
             RowBox[{"Map", "[", 
              RowBox[{"WeightSystem", ",", 
               RowBox[{
                RowBox[{"irrep", "[", 
                 RowBox[{"[", "j", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "//", "AlphaBasis"}],
             ",", "2"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"W", "[", "j", "]"}], "=", 
          RowBox[{"Map", "[", 
           RowBox[{"Flatten", ",", 
            RowBox[{"Tuples", "[", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"W", "[", "j", "]"}], "[", 
                RowBox[{"[", "i", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"Length", "[", 
                  RowBox[{"W", "[", "j", "]"}], "]"}]}], "}"}]}], "]"}], 
             "]"}]}], "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"max", "=", 
       RowBox[{"Max", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{
            RowBox[{"W", "[", "j", "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "1", ",", 
            RowBox[{"Length", "[", "irrep", "]"}]}], "}"}]}], "]"}], "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"j", "=", "1"}], ",", 
        RowBox[{"j", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{
             RowBox[{"W", "[", "j", "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "]"}], "<", "max"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"W", "[", "j", "]"}], "=", 
           RowBox[{"Map", "[", 
            RowBox[{"Flatten", ",", 
             RowBox[{"Tuples", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"W", "[", "j", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"ConstantArray", "[", 
                  RowBox[{"0", ",", 
                   RowBox[{"Length", "[", 
                    RowBox[{
                    RowBox[{"W", "[", "j", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], "}"}]}], 
               "}"}], "]"}]}], "]"}]}]}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "convert", " ", "weights", " ", "to", " ", "signs", " ", "of", " ", 
        "alpha", " ", "basis", " ", "coefficients"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", "=", "1"}], ",", 
        RowBox[{"i", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"i", "++"}], ",", 
        RowBox[{
         RowBox[{"S", "[", "i", "]"}], "=", 
         RowBox[{"Map", "[", 
          RowBox[{"Sign", ",", 
           RowBox[{"W", "[", "i", "]"}]}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"sgn", "[", "y_", "]"}], ":=", 
       RowBox[{
        RowBox[{"y", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", 
        RowBox[{"KroneckerDelta", "[", 
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"DeleteDuplicates", "[", 
            RowBox[{"DeleteCases", "[", 
             RowBox[{"y", ",", "0"}], "]"}], "]"}], "]"}], ",", "1"}], 
         "]"}]}]}], " ", ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"compute", " ", "sign", " ", "of", " ", "a", " ", "weight"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ineq", "[", "k", "]"}], "=", 
         RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", 
        RowBox[{
         RowBox[{"diff", "[", "k", "]"}], "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"W", "[", "k", "]"}], "[", 
              RowBox[{"[", "i", "]"}], "]"}], "-", 
             RowBox[{
              RowBox[{"W", "[", "k", "]"}], "[", 
              RowBox[{"[", "j", "]"}], "]"}]}], ")"}], " ", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "[", 
              RowBox[{"W", "[", "k", "]"}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "1", ",", 
             RowBox[{"Length", "[", 
              RowBox[{"W", "[", "k", "]"}], "]"}]}], "}"}]}], "]"}]}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "compute", " ", "a", " ", "list", " ", "of", " ", "inequalities", " ",
          "to", " ", "use", " ", "a", " ", "conditionns"}], ",", " ", 
        RowBox[{
         RowBox[{"sgn", "[", 
          RowBox[{
           RowBox[{"S", "[", "k", "]"}], "[", 
           RowBox[{"[", "j", "]"}], "]"}], "]"}], "===", "0"}], ","}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", 
           RowBox[{"Length", "[", 
            RowBox[{"W", "[", "k", "]"}], "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"j", "=", "1"}], ",", 
            RowBox[{"j", "\[LessEqual]", 
             RowBox[{"Length", "[", 
              RowBox[{"W", "[", "k", "]"}], "]"}]}], ",", 
            RowBox[{"j", "++"}], ",", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Sort", "[", 
                RowBox[{
                 RowBox[{"diff", "[", "k", "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "j"}], "]"}], "]"}], "]"}], "===", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"KroneckerDelta", "[", 
                  RowBox[{"i", ",", 
                   RowBox[{"Length", "[", 
                    RowBox[{
                    RowBox[{"W", "[", "k", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "1", ",", 
                   RowBox[{"Length", "[", 
                    RowBox[{
                    RowBox[{"W", "[", "k", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
               ",", 
              RowBox[{
               RowBox[{"ineq", "[", "k", "]"}], "=", 
               RowBox[{"Append", "[", 
                RowBox[{
                 RowBox[{"ineq", "[", "k", "]"}], ",", 
                 RowBox[{
                  SubscriptBox[
                   RowBox[{"s", "[", "k", "]"}], "i"], ">=", 
                  SubscriptBox[
                   RowBox[{"s", "[", "k", "]"}], "j"]}]}], "]"}]}]}], "]"}]}],
            "]"}]}], "]"}]}], "]"}], ";", " ", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"dired", "[", "k", "]"}], "=", 
          RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", 
            RowBox[{"Length", "[", 
             RowBox[{"W", "[", "k", "]"}], "]"}]}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{"For", "[", 
            RowBox[{
             RowBox[{"j", "=", "1"}], ",", 
             RowBox[{"j", "\[LessEqual]", 
              RowBox[{"Length", "[", 
               RowBox[{"W", "[", "k", "]"}], "]"}]}], ",", 
             RowBox[{"j", "++"}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Sort", "[", 
                 RowBox[{
                  RowBox[{"diff", "[", "k", "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "j"}], "]"}], "]"}], "]"}], "===", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"KroneckerDelta", "[", 
                   RowBox[{"i", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{
                    RowBox[{"W", "[", "k", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", "1", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{
                    RowBox[{"W", "[", "k", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
                ",", 
               RowBox[{
                RowBox[{"dired", "[", "k", "]"}], "=", 
                RowBox[{"Append", "[", 
                 RowBox[{
                  RowBox[{"dired", "[", "k", "]"}], ",", 
                  RowBox[{"DirectedEdge", "[", 
                   RowBox[{"i", ",", "j"}], "]"}]}], "]"}]}]}], "]"}]}], 
            "]"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ineq", "[", "k", "]"}], "=", 
         RowBox[{
          RowBox[{"ineq", "[", "k", "]"}], "/.", 
          RowBox[{"List", "\[Rule]", "And"}]}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"ineq", "[", "k", "]"}], "]"}], "===", "0"}], ",", 
          RowBox[{
           RowBox[{"ineq", "[", "k", "]"}], "=", "True"}]}], "]"}]}], "]"}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"zindex", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", "=", "1"}], ",", 
        RowBox[{"i", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"i", "++"}], ",", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"irrep", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], "===", "0"}], ",", 
          RowBox[{"zindex", "=", 
           RowBox[{"Append", "[", 
            RowBox[{"zindex", ",", "i"}], "]"}]}]}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"refl", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"constsign", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"const", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"pos", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"neg", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"zero", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"zerorep", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"l", "=", "1"}], ",", 
          RowBox[{"l", "\[LessEqual]", 
           RowBox[{"Length", "[", 
            RowBox[{"S", "[", 
             RowBox[{"zindex", "[", 
              RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], ",", 
          RowBox[{"l", "++"}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"Map", "[", 
               RowBox[{"sgn", ",", 
                RowBox[{"S", "[", 
                 RowBox[{"zindex", "[", 
                  RowBox[{"[", "k", "]"}], "]"}], "]"}]}], "]"}], "[", 
              RowBox[{"[", "l", "]"}], "]"}], "===", "1"}], ",", 
            RowBox[{"pos", "=", 
             RowBox[{"Append", "[", 
              RowBox[{"pos", ",", 
               RowBox[{
                SubscriptBox[
                 RowBox[{"s", "[", 
                  RowBox[{"zindex", "[", 
                   RowBox[{"[", "k", "]"}], "]"}], "]"}], "l"], "\[Rule]", 
                RowBox[{"Style", "[", "\"\<+\>\"", "]"}]}]}], "]"}]}]}], 
           "]"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"l", "=", "1"}], ",", 
          RowBox[{"l", "\[LessEqual]", 
           RowBox[{"Length", "[", 
            RowBox[{"S", "[", 
             RowBox[{"zindex", "[", 
              RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], ",", 
          RowBox[{"l", "++"}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"Map", "[", 
               RowBox[{"sgn", ",", 
                RowBox[{"S", "[", 
                 RowBox[{"zindex", "[", 
                  RowBox[{"[", "k", "]"}], "]"}], "]"}]}], "]"}], "[", 
              RowBox[{"[", "l", "]"}], "]"}], "===", 
             RowBox[{"-", "1"}]}], ",", 
            RowBox[{"neg", "=", 
             RowBox[{"Append", "[", 
              RowBox[{"neg", ",", 
               RowBox[{
                SubscriptBox[
                 RowBox[{"s", "[", 
                  RowBox[{"zindex", "[", 
                   RowBox[{"[", "k", "]"}], "]"}], "]"}], "l"], "\[Rule]", 
                RowBox[{"Style", "[", "\"\<-\>\"", "]"}]}]}], "]"}]}]}], 
           "]"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"l", "=", "1"}], ",", 
          RowBox[{"l", "\[LessEqual]", 
           RowBox[{"Length", "[", 
            RowBox[{"W", "[", 
             RowBox[{"zindex", "[", 
              RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], ",", 
          RowBox[{"l", "++"}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"W", "[", 
                RowBox[{"zindex", "[", 
                 RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
               RowBox[{"[", "l", "]"}], "]"}], ".", 
              RowBox[{
               RowBox[{"W", "[", 
                RowBox[{"zindex", "[", 
                 RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
               RowBox[{"[", "l", "]"}], "]"}]}], "===", "0"}], ",", 
            RowBox[{"zero", "=", 
             RowBox[{"Append", "[", 
              RowBox[{"zero", ",", 
               SubscriptBox[
                RowBox[{"s", "[", 
                 RowBox[{"zindex", "[", 
                  RowBox[{"[", "k", "]"}], "]"}], "]"}], "l"]}], "]"}]}]}], 
           "]"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"j", "=", "1"}], ",", 
        RowBox[{"j", "\[LessEqual]", 
         RowBox[{"Length", "[", "zero", "]"}]}], ",", 
        RowBox[{"j", "++"}], ",", 
        RowBox[{"zerorep", "=", 
         RowBox[{"Append", "[", 
          RowBox[{"zerorep", ",", 
           RowBox[{
            RowBox[{"zero", "[", 
             RowBox[{"[", "j", "]"}], "]"}], "\[Rule]", "0"}]}], "]"}]}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"defsign", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"pos", ",", "neg"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"const", "=", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Flatten", "[", "refl", "]"}], "//", "Reduce"}], ")"}], "/.", 
         RowBox[{"{", 
          RowBox[{"And", "\[Rule]", "List"}], "}"}]}], ")"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"fullineq", "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"ineq", "[", "k", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", "1", ",", 
              RowBox[{"Length", "[", "irrep", "]"}]}], "}"}]}], "]"}], "//", 
          "Flatten"}], ")"}], "/.", 
        RowBox[{"{", 
         RowBox[{"List", "\[Rule]", "And"}], "}"}]}]}], ";", " ", 
      "\[IndentingNewLine]", 
      RowBox[{"candsign", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"defsign", ",", "zerorep"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", 
          RowBox[{
           RowBox[{"irrep", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", 
        RowBox[{
         RowBox[{"tenslabel", "[", "k", "]"}], "=", 
         RowBox[{"Table", "[", 
          RowBox[{"i", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "[", 
              RowBox[{"WeightSystem", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"irrep", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], "}"}]}], 
          "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"newlabel", "=", 
       RowBox[{"Tuples", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"tenslabel", "[", "k", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", "1", ",", 
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"irrep", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"l", "=", "1"}], ",", 
          RowBox[{"l", "\[LessEqual]", 
           RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
          RowBox[{"l", "++"}], ",", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"i", "=", "1"}], ",", 
            RowBox[{"i", "\[LessEqual]", 
             RowBox[{"Length", "[", 
              RowBox[{"W", "[", 
               RowBox[{"zindex", "[", 
                RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], ",", 
            RowBox[{"i", "++"}], ",", 
            RowBox[{"For", "[", 
             RowBox[{
              RowBox[{"j", "=", "1"}], ",", 
              RowBox[{"j", "\[LessEqual]", 
               RowBox[{"Length", "[", 
                RowBox[{"W", "[", 
                 RowBox[{"zindex", "[", 
                  RowBox[{"[", "l", "]"}], "]"}], "]"}], "]"}]}], ",", 
              RowBox[{"j", "++"}], ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Map", "[", 
                    RowBox[{"Abs", ",", 
                    RowBox[{"Flatten", "[", 
                    RowBox[{"Minors", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}], "}"}], ",", "2"}], 
                    "]"}], "]"}]}], "]"}], "/.", 
                    RowBox[{"List", "\[Rule]", "Plus"}]}], ")"}], "===", 
                  "0"}], "&&", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "!=", 
                  RowBox[{
                   RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "j", "]"}], "]"}]}], "&&", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Map", "[", 
                    RowBox[{"Abs", ",", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], "/.", 
                    RowBox[{"List", "\[Rule]", "Plus"}]}], ")"}], "!=", "0"}],
                  "&&", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Map", "[", 
                    RowBox[{"Abs", ",", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}], "]"}], "/.", 
                    RowBox[{"List", "\[Rule]", "Plus"}]}], ")"}], "!=", 
                  "0"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"refl", "=", 
                   RowBox[{"Append", "[", 
                    RowBox[{"refl", ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    SubscriptBox["w", 
                    RowBox[{"newlabel", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]], "\[Equal]", 
                    RowBox[{"a", " ", 
                    SubscriptBox["w", 
                    RowBox[{"newlabel", "[", 
                    RowBox[{"[", "j", "]"}], "]"}]]}]}], "}"}], "/.", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Solve", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}]}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}], "]"}]}], ",", 
                  RowBox[{"constsign", "=", 
                   RowBox[{"Append", "[", 
                    RowBox[{"constsign", ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"s", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "i"], "\[Equal]", 
                    RowBox[{
                    RowBox[{"Sign", "[", "a", "]"}], 
                    SubscriptBox[
                    RowBox[{"s", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "j"]}]}], "}"}], "/.", 
                    RowBox[{
                    RowBox[{"Solve", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}]}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}]}], "]"}]}]}], "}"}]}], 
               "]"}]}], "]"}]}], "]"}]}], "]"}]}], "]"}], ";", " ", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"wtgrph", "[", "wtsgns___", "]"}], ":=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Graph", "[", 
          RowBox[{
           RowBox[{"dired", "[", "k", "]"}], ",", 
           RowBox[{"VertexSize", "\[Rule]", ".8"}], ",", 
           RowBox[{"VertexShape", "\[Rule]", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"i", "\[Rule]", 
               RowBox[{"Style", "[", 
                RowBox[{
                 SuperscriptBox[
                  SubscriptBox["w", 
                   RowBox[{"newlabel", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]], 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"s", "[", "k", "]"}], "i"], ",", "Red", ",", 
                    "Bold", ",", 
                    RowBox[{"FontSize", "\[Rule]", "14"}]}], "]"}], "/.", 
                    "wtsgns"}], "/.", 
                   RowBox[{"{", 
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"s", "[", "k", "]"}], "i_"], "\[Rule]", 
                    RowBox[{"Style", "[", "\"\<\>\"", "]"}]}], "}"}]}]], ",", 
                 "Blue", ",", "Bold", ",", "17"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"Length", "[", 
                 RowBox[{"W", "[", "k", "]"}], "]"}]}], "}"}]}], "]"}]}], ",", 
           RowBox[{"PerformanceGoal", "\[Rule]", "\"\<Quality\>\""}], ",", 
           RowBox[{"EdgeStyle", "\[Rule]", 
            RowBox[{"Darker", "[", "Green", "]"}]}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "Medium"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"k", ",", "1", ",", 
           RowBox[{"Length", "[", "irrep", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Return", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"wtgrph", "[", "candsign", "]"}], ",", "refl"}], "}"}], 
       "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"GeomKK", "[", "l_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "f", ",", "x", ",", "Mat2", ",", "zeros", ",", "Mat", ",", "Y", ",", "y",
       ",", "m", ",", "Pr"}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"f", "[", "1", "]"}], "=", 
      RowBox[{
       RowBox[{"f", "[", "2", "]"}], "=", "1"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"x", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"l", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
         
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{
            RowBox[{"l", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], "]"}], ">", "0"}], "&&", 
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"l", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Loop"}], "]"}]}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"l", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"l", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "}"}], ",", "l"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"Allowed6d1", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"x", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{
            RowBox[{"x", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], ",", 
           RowBox[{"x", "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}], "\[Equal]", "1"}],
        ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Mat2", "=", 
         RowBox[{"TotalMatter", "[", 
          RowBox[{
           RowBox[{"x", "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{
            RowBox[{"x", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{
            RowBox[{"x", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], " ", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"zeros", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"Mat2", "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], ",", 
               RowBox[{"{", "n", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "1", ",", 
               RowBox[{"Length", "[", "Mat2", "]"}]}], "}"}]}], "]"}], ",", 
           "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Mat", "=", 
         RowBox[{"Delete", "[", 
          RowBox[{"Mat2", ",", "zeros"}], "]"}]}], ";", "\[IndentingNewLine]",
         "\[IndentingNewLine]", 
        RowBox[{"Y", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"Length", "[", 
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "]"}], "==", "0"}], "&&", 
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], "]"}]}], 
             ")"}], "\[Or]", 
            RowBox[{
             RowBox[{"Length", "[", "Mat", "]"}], "\[Equal]", "0"}]}], ",", 
           "0", ",", 
           RowBox[{"Input", "[", 
            RowBox[{
             RowBox[{"Row", "[", 
              RowBox[{"{", 
               RowBox[{
               "\"\<Please Input the Signs for the weights of group\>\"", ",",
                 ",", 
                RowBox[{"Which", "[", 
                 RowBox[{
                  RowBox[{"TrueQ", "[", 
                   RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "==", "U"}], "]"}],
                   ",", 
                  RowBox[{"Style", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"FontColor", "\[Rule]", 
                    RowBox[{"Darker", "[", "Green", "]"}]}], ",", "Bold"}], 
                   "]"}], ",", 
                  RowBox[{"TrueQ", "[", 
                   RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "T2"}],
                    "]"}], ",", 
                  RowBox[{"Style", "[", 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "2"], ",", 
                    RowBox[{"FontColor", "\[Rule]", 
                    RowBox[{"Darker", "[", "Green", "]"}]}], ",", "Bold"}], 
                   "]"}], ",", 
                  RowBox[{"TrueQ", "[", 
                   RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "T3"}],
                    "]"}], ",", 
                  RowBox[{"Style", "[", 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "3"], ",", 
                    RowBox[{"FontColor", "\[Rule]", 
                    RowBox[{"Darker", "[", "Green", "]"}]}], ",", "Bold"}], 
                   "]"}]}], "]"}], ",", ",", "\"\<with highest weight  \>\"", 
                ",", ",", 
                RowBox[{"Manipulate", "[", 
                 RowBox[{
                  RowBox[{"Pane", "[", 
                   RowBox[{
                    RowBox[{"Grid", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<Matter:\>\"", ",", 
                    RowBox[{"Style", "[", 
                    RowBox[{"n", "  ", ",", 
                    RowBox[{"FontColor", "\[Rule]", 
                    RowBox[{"Darker", "[", "Magenta", "]"}]}], ",", "Bold"}], 
                    "]"}], ",", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\</\>\"", "  ", ",", 
                    RowBox[{"FontColor", "\[Rule]", 
                    RowBox[{"Darker", "[", "Magenta", "]"}]}], ",", "Bold"}], 
                    "]"}], ",", 
                    RowBox[{"Style", "[", " ", 
                    RowBox[{
                    RowBox[{"Length", "[", "Mat", "]"}], " ", ",", 
                    RowBox[{"FontColor", "\[Rule]", 
                    RowBox[{"Darker", "[", "Magenta", "]"}]}], ",", "Bold"}], 
                    "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"HighestWeight", "[", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "]"}], 
                    ",", ",", 
                    "\"\< and \!\(\*SubscriptBox[\(N\), \(f\)]\)= \>\"", ",", 
                    " ", 
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "\"\<:\>\"", ",", 
                    ",", 
                    RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"weight", "[", " ", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", " ", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], " ", 
                    "}"}], ",", "0"}], "}"}], "}"}], "   ", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], " ", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"weight", "[", " ", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", " ", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], " ", 
                    "}"}], ",", "0"}], "}"}], "}"}], "   ", "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/.", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", "}"}], "\[Rule]", "\"\< \>\""}], "}"}]}], "//",
                     "MatrixForm"}]}], "}"}], "]"}]}], " ", "}"}]}], "}"}], 
                    "]"}], ",", "Full", ",", 
                    RowBox[{"Scrollbars", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"True", ",", "True"}], "}"}]}], ",", 
                    RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], 
                   "]"}], " ", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", ",", "1", ",", "\"\<Matter\>\""}], "}"}], 
                    ",", "1", ",", 
                    RowBox[{"Length", "[", "Mat", "]"}], ",", "1"}], "}"}]}], 
                 "]"}]}], "}"}], "]"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{
                  SubscriptBox[
                   RowBox[{"s", "[", "j", "]"}], "i"], "\[Rule]", " ", "1"}], 
                 ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "1", ",", 
                   RowBox[{"Length", "[", 
                    RowBox[{"WS", "[", " ", 
                    RowBox[{
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], " ", "]"}], " ", 
                    "]"}]}], "      ", "}"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "1", ",", 
                 RowBox[{"Length", "[", "Mat", "]"}]}], "}"}]}], "]"}], ",", 
             RowBox[{"WindowSize", "\[Rule]", "Medium"}], ",", 
             RowBox[{"WindowClickSelect", "\[Rule]", "True"}], ",", 
             RowBox[{"WindowElements", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
               "\"\<VerticalScrollBar\>\"", ",", 
                "\"\<HorizontalScrollBar\>\""}], "}"}]}]}], "]"}]}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"TrueQ", "[", 
           RowBox[{"Y", "\[Equal]", "$Canceled"}], "]"}], ",", 
          RowBox[{"Return", "[", "\"\<Cancelled\>\"", "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"y", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], "]"}], 
            "\[Or]", 
            RowBox[{
             RowBox[{"Length", "[", "Mat", "]"}], "\[Equal]", "0"}]}], ",", 
           RowBox[{"0", "\[Rule]", "0"}], ",", 
           RowBox[{"Flatten", "[", "Y", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"m", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Length", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "0"}], 
               ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "}"}]}], "}"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"f", "[", "i_", "]"}], ":=", 
         RowBox[{"Graph2K", "[", 
          RowBox[{
           RowBox[{"6", 
            RowBox[{"Prepotential6d", "[", 
             RowBox[{"Flatten", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"i", ",", 
                 RowBox[{"{", "Mat", "}"}]}], "}"}], ",", "1"}], "]"}], 
             "]"}]}], "/.", "y"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Pr", "[", "i_", "]"}], ":=", 
         RowBox[{
          RowBox[{"Prepotential6d", "[", 
           RowBox[{"Flatten", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"i", ",", 
               RowBox[{"{", "Mat", "}"}]}], "}"}], ",", "1"}], "]"}], "]"}], "/.",
           "y"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Return", "[", "                    ", 
         RowBox[{"Grid", "[", 
          RowBox[{
           RowBox[{"DeleteCases", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Text", "[", "\"\<The Geometry:\>\"", "]"}], ",", 
                 RowBox[{"f", "[", "m", "]"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Length", "[", "Mat", "]"}], ">", "0"}], ",", 
                   RowBox[{
                   "Text", "[", "\"\<Your Choice of Signs:  \>\"", "]"}]}], 
                  "]"}], ",", "y"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Text", "[", "\"\<The Prepotential 6F:  \>\"", "]"}],
                  ",", 
                 RowBox[{
                  RowBox[{"6", 
                   RowBox[{"Pr", "[", "m", "]"}]}], "//", "Expand"}]}], 
                "}"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", "->", "0"}], "}"}]}], "]"}], ",", 
           RowBox[{"Frame", "\[Rule]", "True"}], ",", 
           RowBox[{"FrameStyle", "\[Rule]", 
            RowBox[{"Directive", "[", 
             RowBox[{
              RowBox[{"Thickness", "[", "2", "]"}], ",", 
              RowBox[{"Darker", "[", "Red", "]"}]}], "]"}]}], ",", 
           RowBox[{"Background", "\[Rule]", "White"}], ",", 
           RowBox[{"ItemStyle", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"Directive", "[", 
                RowBox[{
                 RowBox[{"Darker", "[", "Red", "]"}], ",", "18"}], "]"}], 
               "}"}], ",", "None"}], "}"}]}]}], " ", "]"}], "]"}]}], 
       "\[IndentingNewLine]", ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"x", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "==", "0"}], "]"}], ",", 
         RowBox[{"Prepotential6d", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"x", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", "0", ",", "0"}], "}"}], 
          "]"}], ",", 
         RowBox[{"Print", "[", "\"\<This Theory does not exist\>\"", "]"}]}], 
        "]"}]}], "]"}]}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"ExpetionalAllowed", "[", 
   RowBox[{
   "Alg1_", ",", "T1_", ",", "k1_", ",", "Alg2_", ",", "T_", ",", "k2_", ",", 
    "Lines_", ",", "\[CapitalOmega]_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
          "]"}], "&&", 
         RowBox[{
          RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "1"}]}], ")"}], 
       "\[Or]", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "C"}], 
        "]"}]}], ")"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "D"}], "]"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{"T", "\[Equal]", "T2"}], "]"}], "&&", 
     RowBox[{"2", "\[LessEqual]", "k2", "\[LessEqual]", "4"}], "&&", 
     RowBox[{"k1", "\[Equal]", "1"}]}], ",", 
    RowBox[{"Which", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"\[CapitalOmega]", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
       RowBox[{"-", "1"}]}], ",", "1", ",", 
      RowBox[{
       RowBox[{
        RowBox[{"\[CapitalOmega]", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
       RowBox[{"-", "2"}]}], ",", "2", ",", 
      RowBox[{
       RowBox[{
        RowBox[{"\[CapitalOmega]", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
       RowBox[{"-", "3"}]}], ",", 
      FractionBox[
       RowBox[{"-", "1"}], "2"]}], "]"}], ",", "0"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Inequalities", "[", 
   RowBox[{
   "Alg1_", ",", "T1_", ",", "k1_", ",", "Alg2_", ",", "T2_", ",", "k2_", ",",
     "Lines_", ",", "\[CapitalOmega]_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", 
       RowBox[{"TotalBi", "[", 
        RowBox[{"Alg1", ",", 
         RowBox[{"LB", "[", "T1", "]"}], ",", "k1", ",", "Alg2", ",", 
         RowBox[{"LB", "[", "T2", "]"}], ",", "k2", ",", "Lines"}], "]"}], 
       " ", "]"}], "\[NotEqual]", "0"}], "&&", 
     RowBox[{
      RowBox[{"Length", "[", 
       RowBox[{"TotalMatter", "[", 
        RowBox[{"k1", ",", "Alg1", ",", 
         RowBox[{"LM", "[", "T1", "]"}]}], "]"}], "]"}], "\[NotEqual]", "0"}],
      "&&", 
     RowBox[{
      RowBox[{"Length", "[", 
       RowBox[{"TotalMatter", "[", 
        RowBox[{"k2", ",", "Alg2", ",", 
         RowBox[{"LM", "[", "T2", "]"}]}], "]"}], "]"}], " ", "\[NotEqual]", 
      "0"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "!=", 
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ",", 
           RowBox[{
            RowBox[{"\[CapitalOmega]", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"-", "1"}]}], "]"}]}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"TotalBi", "[", 
             RowBox[{"Alg1", ",", 
              RowBox[{"LB", "[", "T1", "]"}], ",", "k1", ",", "Alg2", ",", 
              RowBox[{"LB", "[", "T2", "]"}], ",", "k2", ",", "Lines"}], 
             "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "[", 
           RowBox[{"[", "3", "]"}], "]"}], " ", 
          RowBox[{"Dim", "[", 
           RowBox[{"irrep2", "[", 
            RowBox[{
             RowBox[{"FundamentalRepDim", "[", "Alg2", "]"}], " ", ",", 
             "Alg2"}], "]"}], "]"}]}], ")"}]}], "\[LessEqual]", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"TotalMatter", "[", 
           RowBox[{"k1", ",", "Alg1", ",", 
            RowBox[{"LM", "[", "T1", "]"}]}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}], "-", 
        RowBox[{"ExpetionalAllowed", "[", 
         RowBox[{
         "Alg1", ",", "T1", ",", "k1", ",", "Alg2", ",", "T2", ",", "k2", ",",
           "Lines", ",", "\[CapitalOmega]"}], "]"}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "!=", 
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ",", 
           RowBox[{
            RowBox[{"\[CapitalOmega]", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], ",", 
           RowBox[{"-", "1"}]}], "]"}]}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"TotalBi", "[", 
             RowBox[{"Alg1", ",", 
              RowBox[{"LB", "[", "T1", "]"}], ",", "k1", ",", "Alg2", ",", 
              RowBox[{"LB", "[", "T2", "]"}], ",", "k2", ",", "Lines"}], 
             "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "[", 
           RowBox[{"[", "3", "]"}], "]"}], " ", 
          RowBox[{"Dim", "[", 
           RowBox[{"irrep2", "[", 
            RowBox[{
             RowBox[{"FundamentalRepDim", "[", "Alg1", "]"}], ",", "Alg1"}], 
            "]"}], "]"}]}], ")"}]}], " ", "\[LessEqual]", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"TotalMatter", "[", 
           RowBox[{"k2", ",", "Alg2", ",", 
            RowBox[{"LM", "[", "T2", "]"}]}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}], " ", "-", 
        RowBox[{"ExpetionalAllowed", "[", 
         RowBox[{
         "Alg2", ",", "T2", ",", "k2", ",", "Alg1", ",", "T1", ",", "k1", ",",
           "Lines", ",", "\[CapitalOmega]"}], "]"}]}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"2", "\[Equal]", "0"}], ",", 
      RowBox[{"2", "\[Equal]", "0"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Allowed6d2", "[", 
   RowBox[{
   "Alg1_", ",", "T1_", ",", "k1_", ",", "Alg2_", ",", "T2_", ",", "k2_", ",",
     "Lines_", ",", "\[CapitalOmega]_"}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "!=", "B"}], "]"}], 
     "\[Or]", 
     RowBox[{
      RowBox[{"Rank", "[", "Alg2", "]"}], "!=", "3"}], "\[Or]", " ", 
     RowBox[{
      RowBox[{"Length", "[", "T2", "]"}], "\[NotEqual]", "0"}], "\[Or]", 
     RowBox[{"k2", "\[NotEqual]", "3"}]}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"Allowed6d1", "[", 
          RowBox[{"Alg1", ",", 
           RowBox[{"LM", "[", "T1", "]"}], ",", "k1"}], "]"}], "]"}], 
        "\[Equal]", "1"}], "&&", 
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"Allowed6d1", "[", 
          RowBox[{"Alg2", ",", 
           RowBox[{"LM", "[", "T2", "]"}], ",", "k2"}], "]"}], "]"}], 
        "\[Equal]", "1"}], "&&", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"k1", "\[NotEqual]", "1"}], "\[Or]", " ", 
         RowBox[{"k2", "!=", "1"}]}], ")"}]}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Inequalities", "[", 
           RowBox[{
           "Alg1", ",", "T1", ",", "k1", ",", "Alg2", ",", "T2", ",", "k2", 
            ",", "Lines", ",", "\[CapitalOmega]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], "&&", 
         RowBox[{
          RowBox[{"Inequalities", "[", 
           RowBox[{
           "Alg1", ",", "T1", ",", "k1", ",", "Alg2", ",", "T2", ",", "k2", 
            ",", "Lines", ",", "\[CapitalOmega]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ",", 
        RowBox[{"{", "1", "}"}]}], "]"}]}], "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Allowed6dEmpty", "[", 
   RowBox[{"Alg_", ",", "k_", ",", "k1_"}], "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{"k1", "\[Equal]", "1"}], ",", 
    RowBox[{"Which", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "A"}], "]"}], 
       "&&", 
       RowBox[{"k", "\[Equal]", "2"}], "&&", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg", "]"}], "\[LessEqual]", "8"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "A"}], "]"}], 
       "&&", 
       RowBox[{"k", "\[Equal]", "3"}], "&&", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "2"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "D"}], "]"}], 
       "&&", 
       RowBox[{"2", "\[LessEqual]", "k", "\[LessEqual]", "4"}], "&&", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg", "]"}], "\[LessEqual]", "8"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "B"}], "]"}], 
       "&&", 
       RowBox[{"2", "\[LessEqual]", "k", "\[LessEqual]", "4"}], "&&", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg", "]"}], "\[LessEqual]", "7"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "G2"}], "]"}],
        "&&", 
       RowBox[{"2", "\[LessEqual]", "k", "\[LessEqual]", "3"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "F4"}], "]"}],
        "&&", 
       RowBox[{"2", "\[LessEqual]", "k", "\[LessEqual]", "5"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "E6"}], "]"}],
        "&&", 
       RowBox[{"2", "\[LessEqual]", "k", "\[LessEqual]", "6"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "E7"}], "]"}],
        "&&", 
       RowBox[{"2", "\[LessEqual]", "k", "\[LessEqual]", "8"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "E8"}], "]"}],
        "&&", 
       RowBox[{"k", "\[Equal]", "12"}]}], ",", 
      RowBox[{"{", "1", "}"}]}], "]"}], ",", 
    RowBox[{"k1", "\[Equal]", "2"}], ",", 
    RowBox[{"Which", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "A"}], "]"}], 
       "&&", 
       RowBox[{"k", "\[Equal]", "1"}], "&&", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "1"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", "Alg", "]"}], "\[Equal]", "A"}], "]"}], 
       "&&", 
       RowBox[{"k", "\[Equal]", "2"}], "&&", 
       RowBox[{
        RowBox[{"Rank", "[", "Alg", "]"}], "\[Equal]", "1"}]}], ",", 
      RowBox[{"{", "1", "}"}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Allowed6d2Base", "[", 
   RowBox[{
   "Alg1_", ",", "t1_", ",", "k1_", ",", "Alg2_", ",", "t_", ",", "k2_", ",", 
    "\[CapitalOmega]_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"f", ",", "T1", ",", "T"}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"f", "[", "1", "]"}], "=", "1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"T1", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "T1", "]"}], ">", "0"}], ",", 
        RowBox[{"t1", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", "t1"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"T", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "t", "]"}], ">", "0"}], ",", 
        RowBox[{"t", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", "t"}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
             "]"}], "&&", 
            RowBox[{
             RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "1"}]}], ")"}], 
          "\[Or]", 
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "C"}], 
           "]"}]}], ")"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "D"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"3", "\[LessEqual]", "k2", "\[LessEqual]", "4"}], "&&", 
        RowBox[{"k1", "\[Equal]", "1"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg1", "]"}], "\[LessEqual]", 
         RowBox[{
          RowBox[{"2", " ", 
           RowBox[{"Rank", "[", "Alg2", "]"}]}], "-", "4", "-", "k2"}]}], "&&", 
        RowBox[{
         RowBox[{"2", " ", 
          RowBox[{"Rank", "[", "Alg2", "]"}]}], "\[LessEqual]", 
         RowBox[{
          RowBox[{"2", " ", 
           RowBox[{"Rank", "[", "Alg1", "]"}]}], "+", "10", "-", 
          RowBox[{"2", " ", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"TrueQ", "[", 
              RowBox[{"T", "\[Equal]", "T2"}], "]"}], ",", "2", ",", "1"}], 
            "]"}]}]}]}], "&&", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"TrueQ", "[", 
           RowBox[{"t", "\[Equal]", "T2"}], "]"}], ",", 
          RowBox[{
           RowBox[{"2", " ", 
            RowBox[{"Rank", "[", "Alg2", "]"}]}], "\[NotEqual]", 
           RowBox[{
            RowBox[{"2", " ", 
             RowBox[{"Rank", "[", "Alg1", "]"}]}], "+", "8"}]}], ",", 
          RowBox[{"1", "\[Equal]", "1"}]}], "]"}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
             "]"}], "&&", 
            RowBox[{
             RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "1"}]}], ")"}], 
          "\[Or]", 
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "C"}], 
           "]"}]}], ")"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "D"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"3", "\[LessEqual]", "k2", "\[LessEqual]", "4"}], "&&", 
        RowBox[{"k1", "\[Equal]", "1"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg1", "]"}], "\[LessEqual]", 
         RowBox[{
          RowBox[{"2", " ", 
           RowBox[{"Rank", "[", "Alg2", "]"}]}], "-", "4", "-", "k2"}]}], "&&", 
        RowBox[{
         RowBox[{"2", " ", 
          RowBox[{"Rank", "[", "Alg2", "]"}]}], "\[LessEqual]", 
         RowBox[{
          RowBox[{"2", " ", 
           RowBox[{"Rank", "[", "Alg1", "]"}]}], "+", "10", "-", 
          RowBox[{"2", " ", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"TrueQ", "[", 
              RowBox[{"T", "\[Equal]", "T2"}], "]"}], ",", "2", ",", "1"}], 
            "]"}]}]}]}], "&&", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"TrueQ", "[", 
           RowBox[{"t", "\[Equal]", "T2"}], "]"}], ",", 
          RowBox[{
           RowBox[{"2", " ", 
            RowBox[{"Rank", "[", "Alg2", "]"}]}], "\[NotEqual]", 
           RowBox[{
            RowBox[{"2", " ", 
             RowBox[{"Rank", "[", "Alg1", "]"}]}], "+", "8"}]}], ",", 
          RowBox[{"1", "\[Equal]", "1"}]}], "]"}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
             "]"}], "&&", 
            RowBox[{
             RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "1"}]}], ")"}], 
          "\[Or]", 
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "C"}], 
           "]"}]}], ")"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "B"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"3", "\[LessEqual]", "k2", "\[LessEqual]", "4"}], "&&", 
        RowBox[{"k1", "\[Equal]", "1"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg1", "]"}], "\[LessEqual]", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             RowBox[{"Rank", "[", "Alg2", "]"}]}], "+", "1"}], ")"}], "-", 
          "4", "-", "k2"}]}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"2", " ", 
           RowBox[{"Rank", "[", "Alg2", "]"}]}], "+", "1"}], "\[LessEqual]", 
         RowBox[{
          RowBox[{"2", " ", 
           RowBox[{"Rank", "[", "Alg1", "]"}]}], "+", "10", "-", 
          RowBox[{"2", " ", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"TrueQ", "[", 
              RowBox[{"T", "\[Equal]", "T2"}], "]"}], ",", "2", ",", "1"}], 
            "]"}]}]}]}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
             "]"}], "&&", 
            RowBox[{
             RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "1"}]}], ")"}], 
          "\[Or]", 
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "C"}], 
           "]"}]}], ")"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "D"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "3"}]}], "&&", 
        RowBox[{"4", "\[LessEqual]", "k2", "\[LessEqual]", "4"}], "&&", 
        RowBox[{"k1", "\[Equal]", "1"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg1", "]"}], "\[LessEqual]", 
         RowBox[{
          RowBox[{"2", " ", 
           RowBox[{"Rank", "[", "Alg2", "]"}]}], "-", "4", "-", "k2"}]}], "&&", 
        RowBox[{
         RowBox[{"6", " ", 
          RowBox[{"Rank", "[", "Alg2", "]"}]}], "\[LessEqual]", 
         RowBox[{
          RowBox[{"4", " ", 
           RowBox[{"Rank", "[", "Alg1", "]"}]}], "+", "17", "-", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{"T", "\[Equal]", "T2"}], "]"}], ",", "2", ",", "1"}], 
           "]"}]}]}], "&&", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"TrueQ", "[", 
           RowBox[{"t", "\[Equal]", "T2"}], "]"}], ",", 
          RowBox[{
           RowBox[{"6", " ", 
            RowBox[{"Rank", "[", "Alg2", "]"}]}], "\[NotEqual]", 
           RowBox[{
            RowBox[{"4", 
             RowBox[{"Rank", "[", "Alg1", "]"}]}], "+", "16"}]}], ",", 
          RowBox[{"1", "\[Equal]", "1"}]}], "]"}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\n", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
             "]"}], "&&", 
            RowBox[{
             RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "1"}]}], ")"}], 
          "\[Or]", 
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "C"}], 
           "]"}]}], ")"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "B"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "3"}]}], "&&", 
        RowBox[{"4", "\[LessEqual]", "k2", "\[LessEqual]", "4"}], "&&", 
        RowBox[{"k1", "\[Equal]", "1"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg1", "]"}], "\[LessEqual]", 
         RowBox[{
          RowBox[{"2", " ", 
           RowBox[{"Rank", "[", "Alg2", "]"}]}], "+", "1", "-", "4", "-", 
          "k2"}]}], "&&", 
        RowBox[{
         RowBox[{"3", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             RowBox[{"Rank", "[", "Alg2", "]"}]}], "+", "1"}], ")"}]}], 
         "\[LessEqual]", 
         RowBox[{
          RowBox[{"4", " ", 
           RowBox[{"Rank", "[", "Alg1", "]"}]}], "+", "17", "-", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{"T", "\[Equal]", "T2"}], "]"}], ",", "2", ",", "1"}], 
           "]"}]}]}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\n", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
         "]"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "A"}], 
         "]"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{"T", "\[Equal]", "U"}], "]"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{"T1", "\[Equal]", "U"}], "]"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"k2", "\[Equal]", "2"}], "&&", 
        RowBox[{"k1", "\[Equal]", "2"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"Rank", "[", "Alg1", "]"}], "+", "1"}], "\[LessEqual]", 
         RowBox[{"2", 
          RowBox[{"(", " ", 
           RowBox[{
            RowBox[{"Rank", "[", "Alg2", "]"}], "+", "1"}], ")"}]}]}], "&&", 
        RowBox[{
         RowBox[{"2", 
          RowBox[{"(", " ", 
           RowBox[{
            RowBox[{"Rank", "[", "Alg2", "]"}], "+", "1"}], ")"}]}], 
         "\[LessEqual]", 
         RowBox[{"2", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Rank", "[", "Alg1", "]"}], "+", "1"}], ")"}]}]}]}], ",", 
       
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\n", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
         "]"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "A"}], 
         "]"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{"T", "\[Equal]", "U"}], "]"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{"T1", "\[Equal]", "U"}], "]"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "3"}]}], "&&", 
        RowBox[{"k2", "\[Equal]", "2"}], "&&", 
        RowBox[{"k1", "\[Equal]", "2"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"Rank", "[", "Alg1", "]"}], "+", "1"}], "\[LessEqual]", 
         RowBox[{"2", 
          RowBox[{"(", " ", 
           RowBox[{
            RowBox[{"Rank", "[", "Alg2", "]"}], "+", "1"}], ")"}]}]}], "&&", 
        RowBox[{
         RowBox[{"3", 
          RowBox[{"(", " ", 
           RowBox[{
            RowBox[{"Rank", "[", "Alg2", "]"}], "+", "1"}], ")"}]}], 
         "\[LessEqual]", 
         RowBox[{"2", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Rank", "[", "Alg1", "]"}], "+", "1"}], ")"}]}]}]}], ",", 
       
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
         "]"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "A"}], 
         "]"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{"T", "\[Equal]", "T2"}], "]"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{"T1", "\[Equal]", "U"}], "]"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"k2", "\[Equal]", "2"}], "&&", 
        RowBox[{"k1", "\[Equal]", "2"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"Rank", "[", "Alg1", "]"}], "+", "1"}], "\[LessEqual]", 
         RowBox[{"2", 
          RowBox[{"(", " ", 
           RowBox[{
            RowBox[{"Rank", "[", "Alg2", "]"}], "+", "1"}], ")"}]}]}], "&&", 
        RowBox[{
         RowBox[{"(", " ", 
          RowBox[{
           RowBox[{"Rank", "[", "Alg2", "]"}], "+", "1"}], ")"}], 
         "\[LessEqual]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Rank", "[", "Alg1", "]"}], "+", "1"}], ")"}]}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "A"}], 
             "]"}], "&&", 
            RowBox[{
             RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "1"}]}], ")"}], 
          "\[Or]", 
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "C"}], 
           "]"}]}], ")"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "D"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"3", "\[LessEqual]", "k1", "\[LessEqual]", "4"}], "&&", 
        RowBox[{"k2", "\[Equal]", "1"}], "&&", 
        RowBox[{
         RowBox[{"2", 
          RowBox[{"Rank", "[", "Alg2", "]"}]}], "\[LessEqual]", 
         RowBox[{
          RowBox[{"2", " ", 
           RowBox[{"Rank", "[", "Alg1", "]"}]}], "-", "4", "-", "k1"}]}], "&&", 
        RowBox[{
         RowBox[{"2", " ", 
          RowBox[{"Rank", "[", "Alg1", "]"}]}], "\[LessEqual]", 
         RowBox[{
          RowBox[{"4", "  ", 
           RowBox[{"Rank", "[", "Alg2", "]"}]}], "+", "16"}]}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "A"}], 
             "]"}], "&&", 
            RowBox[{
             RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "1"}]}], ")"}], 
          "\[Or]", 
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "C"}], 
           "]"}]}], ")"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "B"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"3", "\[LessEqual]", "k1", "\[LessEqual]", "4"}], "&&", 
        RowBox[{"k2", "\[Equal]", "1"}], "&&", 
        RowBox[{
         RowBox[{"2", 
          RowBox[{"Rank", "[", "Alg2", "]"}]}], "\[LessEqual]", 
         RowBox[{
          RowBox[{"2", " ", 
           RowBox[{"Rank", "[", "Alg1", "]"}]}], "+", "1", "-", "4", "-", 
          "k1"}]}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"2", " ", 
           RowBox[{"Rank", "[", "Alg1", "]"}]}], "+", "1"}], "\[LessEqual]", 
         RowBox[{
          RowBox[{"4", "  ", 
           RowBox[{"Rank", "[", "Alg2", "]"}]}], "+", "16"}]}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\n", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "A"}], 
             "]"}], "&&", 
            RowBox[{
             RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "1"}]}], ")"}], 
          "\[Or]", 
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "C"}], 
           "]"}]}], ")"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "D"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "3"}]}], "&&", 
        RowBox[{"4", "\[LessEqual]", "k1", "\[LessEqual]", "4"}], "&&", 
        RowBox[{"k2", "\[Equal]", "1"}], "&&", 
        RowBox[{
         RowBox[{"3", 
          RowBox[{"Rank", "[", "Alg2", "]"}]}], "\[LessEqual]", 
         RowBox[{
          RowBox[{"2", " ", 
           RowBox[{"Rank", "[", "Alg1", "]"}]}], "-", "8"}]}], "&&", 
        RowBox[{
         RowBox[{"2", " ", 
          RowBox[{"Rank", "[", "Alg1", "]"}]}], "\[LessEqual]", 
         RowBox[{
          RowBox[{"4", "  ", 
           RowBox[{"Rank", "[", "Alg2", "]"}]}], "+", "16"}]}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "A"}], 
             "]"}], "&&", 
            RowBox[{
             RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "1"}]}], ")"}], 
          "\[Or]", 
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "C"}], 
           "]"}]}], ")"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "B"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "3"}]}], "&&", 
        RowBox[{"4", "\[LessEqual]", "k1", "\[LessEqual]", "4"}], "&&", 
        RowBox[{"k2", "\[Equal]", "1"}], "&&", 
        RowBox[{
         RowBox[{"3", 
          RowBox[{"Rank", "[", "Alg2", "]"}]}], "\[LessEqual]", 
         RowBox[{
          RowBox[{"2", " ", 
           RowBox[{"Rank", "[", "Alg1", "]"}]}], "+", "1", "-", "8"}]}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"2", " ", 
           RowBox[{"Rank", "[", "Alg1", "]"}]}], "+", "1"}], "\[LessEqual]", 
         RowBox[{
          RowBox[{"4", "  ", 
           RowBox[{"Rank", "[", "Alg2", "]"}]}], "+", "16"}]}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\n", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
             "]"}], "&&", 
            RowBox[{
             RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "1"}]}], ")"}], 
          "\[Or]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "C"}], 
             "]"}], "&&", 
            RowBox[{
             RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "2"}]}], ")"}]}],
          ")"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "B"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "3"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"3", "\[LessEqual]", "k2", "\[LessEqual]", "3"}], "&&", 
        RowBox[{"k1", "\[Equal]", "1"}], "&&", 
        RowBox[{
         RowBox[{"Length", "[", "t", "]"}], "\[Equal]", "2"}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\n", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "1"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "G2"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"3", "\[LessEqual]", "k2", "\[LessEqual]", "3"}], "&&", 
        RowBox[{"k1", "\[Equal]", "1"}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\n", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "A"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "1"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "G2"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"k2", "\[Equal]", "2"}], "&&", 
        RowBox[{"k1", "\[Equal]", "2"}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "A"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "1"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "G2"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "3"}]}], "&&", 
        RowBox[{"k2", "\[Equal]", "2"}], "&&", 
        RowBox[{"k1", "\[Equal]", "2"}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "1"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "B"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Length", "[", "t", "]"}], "\[Equal]", "2"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "3"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"3", "\[LessEqual]", "k2", "\[LessEqual]", "3"}], "&&", 
        RowBox[{"k1", "\[Equal]", "2"}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "1"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "B"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Length", "[", "t", "]"}], "\[Equal]", "2"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "3"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"3", "\[LessEqual]", "k2", "\[LessEqual]", "3"}], "&&", 
        RowBox[{"k1", "\[Equal]", "2"}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "1"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "B"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "3"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"k2", "\[Equal]", "2"}], "&&", 
        RowBox[{"k1", "\[Equal]", "2"}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "1"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "B"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "3"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "3"}]}], "&&", 
        RowBox[{"k2", "\[Equal]", "2"}], "&&", 
        RowBox[{"k1", "\[Equal]", "2"}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "1"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "B"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "3"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"3", "\[LessEqual]", "k2", "\[LessEqual]", "3"}], "&&", 
        RowBox[{"k1", "\[Equal]", "1"}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "1"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "B"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "3"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"3", "\[LessEqual]", "k2", "\[LessEqual]", "3"}], "&&", 
        RowBox[{"k1", "\[Equal]", "1"}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg1", "]"}], "\[Equal]", "A"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg1", "]"}], "\[Equal]", "1"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"AlgebraClass", "[", "Alg2", "]"}], "\[Equal]", "D"}], 
         "]"}], "&&", 
        RowBox[{
         RowBox[{"Rank", "[", "Alg2", "]"}], "\[Equal]", "4"}], "&&", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
         RowBox[{"-", "2"}]}], "&&", 
        RowBox[{"3", "\[LessEqual]", "k2", "\[LessEqual]", "3"}], "&&", 
        RowBox[{"k1", "\[Equal]", "1"}], "&&", 
        RowBox[{"TrueQ", "[", 
         RowBox[{"T", "\[Equal]", "T2"}], "]"}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"{", "1", "}"}], "]"}]}], "]"}], ";"}]}], 
   "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Allowed6dEmptyBase", "[", 
   RowBox[{"Alg_", ",", "k_", ",", "k1_", ",", "\[CapitalOmega]_"}], "]"}], ":=", 
  RowBox[{"Which", "[", 
   RowBox[{
    RowBox[{"k1", "\[Equal]", "1"}], ",", 
    RowBox[{"Which", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", 
          RowBox[{"Alg", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "A"}], "]"}], "&&", 
       RowBox[{"k", "\[Equal]", "3"}], "&&", 
       RowBox[{
        RowBox[{"Rank", "[", 
         RowBox[{"Alg", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "2"}], "&&", 
       RowBox[{
        RowBox[{
         RowBox[{"\[CapitalOmega]", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
        RowBox[{"-", "2"}]}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", 
          RowBox[{"Alg", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], "]"}], "&&", 
       RowBox[{"3", "\[LessEqual]", "k", "\[LessEqual]", "4"}], "&&", 
       RowBox[{
        RowBox[{"Rank", "[", 
         RowBox[{"Alg", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "4"}], "&&", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"Alg", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "U"}], "]"}], "&&", 
       RowBox[{
        RowBox[{
         RowBox[{"\[CapitalOmega]", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
        RowBox[{"-", "2"}]}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", 
          RowBox[{"Alg", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "B"}], "]"}], "&&", 
       RowBox[{"k", "\[Equal]", "3"}], "&&", 
       RowBox[{
        RowBox[{"Rank", "[", 
         RowBox[{"Alg", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "3"}], "&&", 
       RowBox[{
        RowBox[{
         RowBox[{"\[CapitalOmega]", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
        RowBox[{"-", "2"}]}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", 
          RowBox[{"Alg", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "G2"}], "]"}], "&&", 
       RowBox[{"k", "==", "3"}], "&&", 
       RowBox[{
        RowBox[{
         RowBox[{"\[CapitalOmega]", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
        RowBox[{"-", "2"}]}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", 
          RowBox[{"Alg", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "A"}], "]"}], "&&", 
       RowBox[{
        RowBox[{"Rank", "[", 
         RowBox[{"Alg", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "2"}], "&&", 
       RowBox[{"k", "\[Equal]", "3"}], "&&", 
       RowBox[{
        RowBox[{
         RowBox[{"\[CapitalOmega]", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
        RowBox[{"-", "2"}]}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", 
          RowBox[{"Alg", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "B"}], "]"}], "&&", 
       RowBox[{
        RowBox[{
         RowBox[{"2", 
          RowBox[{"Rank", "[", 
           RowBox[{"Alg", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "+", "1"}], 
        "\[LessEqual]", "16"}], "&&", 
       RowBox[{"3", "\[LessEqual]", "k", "\[LessEqual]", "4"}], "&&", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "\[LessEqual]", 
        RowBox[{"k", "-", "1"}]}], "&&", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "\[GreaterEqual]", "2"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", 
          RowBox[{"Alg", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], "]"}], "&&", 
       RowBox[{
        RowBox[{"2", 
         RowBox[{"Rank", "[", 
          RowBox[{"Alg", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "\[LessEqual]", "16"}], "&&", 
       RowBox[{"3", "\[LessEqual]", "k", "\[LessEqual]", "4"}], "&&", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "\[LessEqual]", 
        RowBox[{"k", "-", "1"}]}], "&&", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "\[GreaterEqual]", "2"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", 
          RowBox[{"Alg", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "G2"}], "]"}], "&&", 
       RowBox[{"3", "\[LessEqual]", "k", "\[LessEqual]", "3"}], "&&", 
       RowBox[{
        RowBox[{
         RowBox[{"\[CapitalOmega]", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
        RowBox[{"-", "2"}]}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", 
          RowBox[{"Alg", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "F4"}], "]"}], "&&", 
       RowBox[{"3", "\[LessEqual]", "k", "\[LessEqual]", "5"}], "&&", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "\[LessEqual]", 
        RowBox[{"k", "-", "1"}]}], "&&", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "\[GreaterEqual]", "2"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", 
          RowBox[{"Alg", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "E6"}], "]"}], "&&", 
       RowBox[{"3", "\[LessEqual]", "k", "\[LessEqual]", "6"}], "&&", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "\[LessEqual]", 
        RowBox[{"k", "-", "1"}]}], "&&", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "\[GreaterEqual]", "2"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", 
          RowBox[{"Alg", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "E7"}], "]"}], "&&", 
       RowBox[{"3", "\[LessEqual]", "k", "\[LessEqual]", "8"}], "&&", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "\[LessEqual]", 
        RowBox[{"k", "-", "1"}]}], "&&", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "\[GreaterEqual]", "2"}]}], ",", 
      RowBox[{"{", "1", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"AlgebraClass", "[", 
          RowBox[{"Alg", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "E8"}], "]"}], "&&", 
       RowBox[{"k", "\[Equal]", "12"}], "&&", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "\[LessEqual]", "11"}], "&&", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{
          RowBox[{"\[CapitalOmega]", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "\[GreaterEqual]", "2"}]}], ",", 
      RowBox[{"{", "1", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"k1", "\[Equal]", "2"}], "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"AlgebraClass", "[", 
        RowBox[{"Alg", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "A"}], "]"}], "&&", 
     RowBox[{"k", "\[Equal]", "2"}], "&&", 
     RowBox[{
      RowBox[{"Rank", "[", 
       RowBox[{"Alg", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "1"}], "&&", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"\[CapitalOmega]", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "\[GreaterEqual]", "2"}], "&&", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{
        RowBox[{"\[CapitalOmega]", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "\[LessEqual]", "3"}]}], ",", 
    RowBox[{"{", "1", "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Geom2KK", "[", "l_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "f", ",", "x", ",", "\[CapitalOmega]", ",", "Mat", ",", "Mat2", ",", 
      "zeros1", ",", "zeros2", ",", "BiMat", ",", "Poscheck", ",", "Y1", ",", 
      "y1", ",", "Y2", ",", "y2", ",", "Y", ",", "y", ",", "m", ",", "Pr"}], 
     "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"f", "[", "1", "]"}], "=", 
      RowBox[{
       RowBox[{"f", "[", "2", "]"}], "=", "1"}]}], ";", "\[IndentingNewLine]",
      "\[IndentingNewLine]", 
     RowBox[{"x", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"l", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
         
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{
            RowBox[{"l", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], "  ", "]"}], ">", "0"}], "&&", 
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"l", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Loop"}], "]"}]}], 
        ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ReplacePart", "[", 
           RowBox[{
            RowBox[{"l", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "1"}]}], "]"}], ",", 
          
          RowBox[{"l", "[", 
           RowBox[{"[", "2", "]"}], "]"}], ",", 
          RowBox[{"l", "[", 
           RowBox[{"[", "3", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"l", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"l", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], " ", "]"}], ">", "0"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"l", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Loop"}], "]"}]}], 
          ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"ReplacePart", "[", 
             RowBox[{
              RowBox[{"l", "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "1"}]}], "]"}], 
            ",", 
            RowBox[{"l", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", 
            RowBox[{"l", "[", 
             RowBox[{"[", "3", "]"}], "]"}]}], "}"}], ",", "l"}], "]"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"\[CapitalOmega]", "=", 
      RowBox[{"x", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"x", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"x", "[", 
              RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"Allowed6d1", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Length", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "2"}], 
                ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
              RowBox[{
               RowBox[{"\[CapitalOmega]", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}], "\[Equal]", 
           "1"}], " ", "&&", 
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"Allowed6d1", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Length", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "2"}], 
                ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
              RowBox[{
               RowBox[{"\[CapitalOmega]", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}], "\[Equal]", 
           "1"}]}], ")"}], "\[Or]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"x", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"Allowed6d1", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Length", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "2"}], 
                ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
              RowBox[{
               RowBox[{"\[CapitalOmega]", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}], "\[Equal]", 
           "1"}]}], " ", ")"}], "\[Or]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"x", "[", 
              RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"Allowed6d1", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Length", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "2"}], 
                ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
              RowBox[{
               RowBox[{"\[CapitalOmega]", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}], "\[Equal]", 
           "1"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"AlgebraClass", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "A"}], 
              "]"}], "&&", 
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"AlgebraClass", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "G2"}], 
              "]"}], "&&", 
             RowBox[{
              RowBox[{"Rank", "[", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], ">=", "2"}], "&&", 
             RowBox[{
              RowBox[{
               RowBox[{"\[CapitalOmega]", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "1"}]}], ")"}]}], 
          ",", 
          RowBox[{"Return", "[", "\"\<There is no such Theory \>\"", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"AlgebraClass", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "A"}], 
              "]"}], "&&", 
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"AlgebraClass", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "G2"}], 
              "]"}], "&&", 
             RowBox[{
              RowBox[{"Rank", "[", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], ">=", "2"}], "&&", 
             RowBox[{
              RowBox[{
               RowBox[{"\[CapitalOmega]", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "1"}]}], ")"}]}], 
          ",", 
          RowBox[{"Return", "[", "\"\<There is no such Theory \>\"", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"x", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], "]"}], "&&", 
           
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"x", "[", 
              RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "0"}], "]"}]}], ",", 
          RowBox[{
          "Return", "[", 
           "\"\<This code does not do those, check the paper\>\"", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"x", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], "]"}], "&&", 
           
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"Allowed6dEmpty", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}], "\[Equal]", 
              "0"}], "\[Or]", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"Allowed6d1", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}], "\[Equal]", 
              "0"}]}], ")"}]}], ",", 
          RowBox[{"Return", "[", "\"\<There is no such Theory\>\"", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"x", "[", 
              RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "0"}], "]"}], "&&", 
           
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"Allowed6dEmpty", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}], "\[Equal]", 
              "0"}], "\[Or]", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"Allowed6d1", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}], "\[Equal]", 
              "0"}]}], ")"}]}], ",", 
          RowBox[{"Return", "[", "\"\<There is no such Theory \>\"", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "==", 
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"Allowed6d2", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "==", 
                    RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "&&", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"-", "2"}]}]}], ",", "2", ",", "1"}], "]"}], ",", 
                 "\[CapitalOmega]"}], "]"}], "]"}], "\[Equal]", "0"}], "&&", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"Allowed6d2", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "==", 
                    RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "&&", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"-", "2"}]}]}], ",", "2", ",", "1"}], "]"}], ",", 
                 "\[CapitalOmega]"}], "]"}], "]"}], "\[Equal]", "0"}]}], 
            ")"}]}], "\[IndentingNewLine]", ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "2"}], "&&", 
           
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "S"}], "]"}], "&&", 
           
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"UnsameQ", "[", 
                RowBox[{
                 RowBox[{"AlgebraClass", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "D"}], "]"}], 
               "\[Or]", " ", 
               RowBox[{
                RowBox[{"Rank", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[NotEqual]", 
                "4"}]}], ")"}], "&&", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"UnsameQ", "[", 
                RowBox[{
                 RowBox[{"AlgebraClass", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "B"}], "]"}], 
               "\[Or]", " ", 
               RowBox[{
                RowBox[{"Rank", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[NotEqual]", 
                "3"}]}], ")"}]}], ")"}]}], ",", 
          RowBox[{"Return", "[", "\"\<There is no such Theory a\>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "2"}], "&&", 
           
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "S"}], "]"}], "&&", 
           
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"UnsameQ", "[", 
                RowBox[{
                 RowBox[{"AlgebraClass", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "D"}], "]"}], 
               "\[Or]", " ", 
               RowBox[{
                RowBox[{"Rank", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}], "!=", "4"}]}], ")"}],
              "&&", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"UnsameQ", "[", 
                RowBox[{
                 RowBox[{"AlgebraClass", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "B"}], "]"}], 
               "\[Or]", " ", 
               RowBox[{
                RowBox[{"Rank", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[NotEqual]", 
                "3"}]}], ")"}]}], ")"}]}], ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "!=", 
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"TrueQ", "[", 
                RowBox[{
                 RowBox[{"AlgebraClass", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], "==", "D"}], "]"}], 
               "&&", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"\[CapitalOmega]", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "2"}]}], ")"}], 
             " ", "\[Or]", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"TrueQ", "[", 
                RowBox[{
                 RowBox[{"AlgebraClass", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], "==", "D"}], "]"}], 
               "&&", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"\[CapitalOmega]", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "2"}]}], ")"}]}],
             " ", ")"}]}], ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "0"}], "&&", 
           " ", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"AlgebraClass", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], "==", "B"}], "]"}], "&&",
            " ", 
           RowBox[{
            RowBox[{"Rank", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], "]"}], "==", "3"}], "&&", 
           RowBox[{
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "3"}]}], ",", 
          RowBox[{
          "Return", "[", 
           "\"\<There is no such Theory. Try replacing U->{U,S} for B3 to \
specify (F\[CircleTimes]S) \>\"", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "0"}], "&&", 
           " ", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"AlgebraClass", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], "==", "B"}], "]"}], "&&",
            " ", 
           RowBox[{
            RowBox[{"Rank", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], "]"}], "==", "3"}], "&&", 
           RowBox[{
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "3"}]}], ",", 
          RowBox[{
          "Return", "[", 
           "\"\<There is no such Theory. Try replacing U->{U,S} for B3 to \
specify (F\[CircleTimes]S) \>\"", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "2"}], "&&", 
           
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Loop"}], "]"}], "&&", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "2"}], "&&", 
           
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Loop"}], "]"}]}], 
          ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], "]"}], "&&", 
           RowBox[{"UnsameQ", "[", 
            RowBox[{
             RowBox[{"AlgebraClass", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "D"}], "]"}], "&&", 
           RowBox[{"UnsameQ", "[", 
            RowBox[{
             RowBox[{"AlgebraClass", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "B"}], "]"}]}], 
          ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], "]"}], "&&", 
           RowBox[{"UnsameQ", "[", 
            RowBox[{
             RowBox[{"AlgebraClass", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "D"}], "]"}], "&&", 
           RowBox[{"UnsameQ", "[", 
            RowBox[{
             RowBox[{"AlgebraClass", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "B"}], "]"}]}], 
          ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
            RowBox[{
             RowBox[{
              RowBox[{"\[CapitalOmega]", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
             RowBox[{"-", "2"}]}], "&&", 
            RowBox[{
             RowBox[{
              RowBox[{"\[CapitalOmega]", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
             RowBox[{"-", "2"}]}], "&&", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "\[NotEqual]", "2"}], " ", "&&",
               " ", 
              RowBox[{
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "\[NotEqual]", "4"}]}], ")"}],
             "&&", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], "\[NotEqual]", "2"}], " ", "&&",
               " ", 
              RowBox[{
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], "\[NotEqual]", "4"}]}], 
             ")"}]}], "\[Or]", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{"Length", "[", 
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{"Length", "[", 
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
              RowBox[{"UnsameQ", "[", 
               RowBox[{
                RowBox[{"AlgebraClass", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "A"}], "]"}], "&&", 
              RowBox[{"UnsameQ", "[", 
               RowBox[{
                RowBox[{"AlgebraClass", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "D"}], "]"}]}], 
             ")"}], "&&", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{"Length", "[", 
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{"Length", "[", 
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
              RowBox[{"UnsameQ", "[", 
               RowBox[{
                RowBox[{"AlgebraClass", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "A"}], "]"}], "&&", 
              RowBox[{"UnsameQ", "[", 
               RowBox[{
                RowBox[{"AlgebraClass", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "D"}], "]"}]}], 
             ")"}]}]}], ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "\[NotEqual]", 
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "&&", " ", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"Allowed6d2Base", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", "\[CapitalOmega]"}], 
              "]"}], "]"}], "==", "0"}], " ", "&&", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"Allowed6d2Base", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "}"}]}], "]"}],
              "]"}], "==", "0"}]}], ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "==", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "\[NotEqual]", 
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "&&", " ", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"Allowed6dEmptyBase", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", "\[CapitalOmega]"}], 
              "]"}], "]"}], "==", "0"}]}], " ", ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "==", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "\[NotEqual]", 
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "&&", " ", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"Allowed6dEmptyBase", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "}"}]}], "]"}],
              "]"}], "==", "0"}]}], " ", ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"Length", "[", 
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "0"}], 
              "]"}], "&&", 
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"AlgebraClass", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
              "]"}], "&&", 
             RowBox[{
              RowBox[{"Rank", "[", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "8"}]}], 
            ")"}], "\[Or]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"Length", "[", 
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "]"}], "\[Equal]", "0"}], 
              "]"}], "&&", 
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"AlgebraClass", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
              "]"}], "&&", 
             RowBox[{
              RowBox[{"Rank", "[", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "8"}]}], 
            ")"}]}], ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory\>\"", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Mat2", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"x", "[", 
              RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "0"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"TotalMatter", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", "0"}], "}"}], 
           ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"TotalMatter", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"MassGauging", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "==", 
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "&&", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
                   RowBox[{"-", "2"}]}]}], ",", "2", ",", "1"}], "]"}], ",", 
               "\[CapitalOmega]"}], "]"}]}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], "]"}]}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"zeros1", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"Mat2", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[NotEqual]", "0"}], 
           ",", 
           RowBox[{"DeleteCases", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"Mat2", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "n"}], "}"}], ",", "0"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", "1", ",", 
                 RowBox[{"Length", "[", 
                  RowBox[{"Mat2", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
             ",", "0"}], "]"}], ",", 
           RowBox[{"{", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"zeros2", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"Mat2", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[NotEqual]", "0"}], 
           ",", 
           RowBox[{"DeleteCases", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"Mat2", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"2", ",", "n"}], "}"}], ",", "0"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", "1", ",", 
                 RowBox[{"Length", "[", 
                  RowBox[{"Mat2", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
             ",", "0"}], "]"}], ",", 
           RowBox[{"{", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Mat", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"AlgebraClass", "[", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
             "]"}], "&&", 
            RowBox[{
             RowBox[{"Rank", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "4"}], "&&", 
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], "]"}], "&&", 
            RowBox[{
             RowBox[{
              RowBox[{"\[CapitalOmega]", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "<", 
             RowBox[{
              RowBox[{"\[CapitalOmega]", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}]}]}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"2", ",", "6"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", 
                 FractionBox["1", "2"]}], "}"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", "1"}], "}"}], 
              "}"}]}], "}"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{"Length", "[", 
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{"Length", "[", 
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{"AlgebraClass", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
               "]"}], "&&", 
              RowBox[{
               RowBox[{"Rank", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "4"}], "&&", 
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], "]"}], "&&", 
              RowBox[{
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ">", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}]}]}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", "1"}], 
                 "}"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"2", ",", "6"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"2", ",", 
                   FractionBox["1", "2"]}], "}"}]}], "}"}]}], "}"}], ",", 
             RowBox[{
              RowBox[{"Delete", "[", 
               RowBox[{"Mat2", ",", 
                RowBox[{"Flatten", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"zeros1", ",", "zeros2"}], "}"}], ",", "1"}], 
                 "]"}]}], "]"}], "/.", 
              RowBox[{
               RowBox[{"{", "}"}], "\[Rule]", "0"}]}]}], "]"}]}], "]"}]}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"BiMat", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], "]"}], 
            "\[Or]", 
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "0"}], "]"}]}], 
           ",", "0", ",", 
           RowBox[{"TotalBi", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"LB", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             RowBox[{
              RowBox[{"\[CapitalOmega]", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"LB", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             RowBox[{
              RowBox[{"\[CapitalOmega]", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "==", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], "&&", 
                RowBox[{
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
                 RowBox[{"-", "2"}]}]}], ",", "2", ",", "1"}], "]"}]}], 
            "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"Poscheck", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"Mat", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "i", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"Length", "[", 
                 RowBox[{"Mat", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
            ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"Mat", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "i", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"Length", "[", 
                 RowBox[{"Mat", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}], 
           "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", 
           RowBox[{"Length", "[", "Poscheck", "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Poscheck", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "<", "0"}], ",", 
            RowBox[{"Return", "[", 
             RowBox[{"Print", "[", "\"\<Theres is no such Theory \>\"", "]"}],
              "]"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"Y1", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], "]"}], 
            "\[Or]", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"Mat", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "0"}]}], 
           ",", "0", ",", 
           RowBox[{"Input", "[", 
            RowBox[{
             RowBox[{"Row", "[", 
              RowBox[{"{", 
               RowBox[{
               "\"\<Please Input the Signs for the weights of First the group\
\>\"", ",", ",", 
                RowBox[{"Which", "[", 
                 RowBox[{
                  RowBox[{"TrueQ", "[", 
                   RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "==", "U"}], "]"}],
                   ",", 
                  RowBox[{"Style", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"FontColor", "\[Rule]", 
                    RowBox[{"Darker", "[", "Green", "]"}]}], ",", "Bold"}], 
                   "]"}], ",", 
                  RowBox[{"TrueQ", "[", 
                   RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "T2"}],
                    "]"}], ",", 
                  RowBox[{"Style", "[", 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "2"], ",", 
                    RowBox[{"FontColor", "\[Rule]", 
                    RowBox[{"Darker", "[", "Green", "]"}]}], ",", "Bold"}], 
                   "]"}], ",", 
                  RowBox[{"TrueQ", "[", 
                   RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "T3"}],
                    "]"}], ",", 
                  RowBox[{"Style", "[", 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "3"], ",", 
                    RowBox[{"FontColor", "\[Rule]", 
                    RowBox[{"Darker", "[", "Green", "]"}]}], ",", "Bold"}], 
                   "]"}]}], "]"}], ",", ",", "\"\<with highest weight  \>\"", 
                ",", ",", 
                RowBox[{"Manipulate", "[", 
                 RowBox[{
                  RowBox[{"Grid", "[", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<Matter:\>\"", ",", 
                    RowBox[{"Style", "[", 
                    RowBox[{"n", "  ", ",", 
                    RowBox[{"FontColor", "\[Rule]", 
                    RowBox[{"Darker", "[", "Magenta", "]"}]}], ",", "Bold"}], 
                    "]"}], ",", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\</\>\"", "  ", ",", 
                    RowBox[{"FontColor", "\[Rule]", 
                    RowBox[{"Darker", "[", "Magenta", "]"}]}], ",", "Bold"}], 
                    "]"}], ",", 
                    RowBox[{"Style", "[", " ", 
                    RowBox[{
                    RowBox[{"Length", "[", 
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], " ", ",", 
                    RowBox[{"FontColor", "\[Rule]", 
                    RowBox[{"Darker", "[", "Magenta", "]"}]}], ",", "Bold"}], 
                    "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"HighestWeight", "[", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "]"}], 
                    ",", ",", 
                    "\"\< and \!\(\*SubscriptBox[\(N\), \(f\)]\)= \>\"", ",", 
                    " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "\"\<:\>\"", ",", 
                    ",", 
                    RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"weight", "[", " ", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", " ", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], " ", 
                    "}"}], ",", "0"}], "}"}], "}"}], "   ", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], " ", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"weight", "[", " ", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", " ", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], " ", 
                    "}"}], ",", "0"}], "}"}], "}"}], "   ", "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/.", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", "}"}], "\[Rule]", "\"\< \>\""}], "}"}]}], "//",
                     "MatrixForm"}]}], "}"}], "]"}]}], "  ", "}"}]}], "}"}], 
                   "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"n", ",", "1", ",", "\"\<Matter\>\""}], "}"}], 
                    ",", "1", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "1"}], 
                   "}"}]}], "]"}]}], "}"}], "]"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{
                  SubscriptBox[
                   RowBox[{"s", "[", "j", "]"}], 
                   RowBox[{"i", ",", "1"}]], "\[Rule]", " ", "1"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "1", ",", 
                   RowBox[{"Length", "[", 
                    RowBox[{"WS", "[", " ", 
                    RowBox[{
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], " ", "]"}], " ", 
                    "]"}]}], "      ", "}"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "1", ",", 
                 RowBox[{"Length", "[", 
                  RowBox[{"Mat", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
             ",", 
             RowBox[{"WindowSize", "\[Rule]", "Medium"}], ",", 
             RowBox[{"WindowClickSelect", "\[Rule]", "True"}], ",", 
             RowBox[{"WindowElements", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
               "\"\<VerticalScrollBar\>\"", ",", 
                "\"\<HorizontalScrollBar\>\""}], "}"}]}]}], "]"}]}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"TrueQ", "[", 
           RowBox[{"Y1", "\[Equal]", "$Canceled"}], "]"}], ",", 
          RowBox[{"Return", "[", "\"\<Cancelled\>\"", "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"y1", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], "]"}], 
            "\[Or]", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"Mat", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "0"}]}], 
           ",", "0", ",", 
           RowBox[{"Flatten", "[", "Y1", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Y2", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "0"}], "]"}], 
            "\[Or]", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"Mat", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "0"}]}], 
           ",", "0", ",", 
           RowBox[{"Input", "[", 
            RowBox[{
             RowBox[{"Row", "[", 
              RowBox[{"{", 
               RowBox[{
               "\"\<Please Input the Signs for the weights of the Second \
group\>\"", ",", ",", 
                RowBox[{"Which", "[", 
                 RowBox[{
                  RowBox[{"TrueQ", "[", 
                   RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "==", "U"}], "]"}],
                   ",", 
                  RowBox[{"Style", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"FontColor", "\[Rule]", "Red"}], ",", "Bold"}], 
                   "]"}], ",", 
                  RowBox[{"TrueQ", "[", 
                   RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "T2"}],
                    "]"}], ",", 
                  RowBox[{"Style", "[", 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "2"], ",", 
                    RowBox[{"FontColor", "\[Rule]", "Red"}], ",", "Bold"}], 
                   "]"}], ",", 
                  RowBox[{"TrueQ", "[", 
                   RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "T3"}],
                    "]"}], ",", 
                  RowBox[{"Style", "[", 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "3"], ",", 
                    RowBox[{"FontColor", "\[Rule]", "Red"}], ",", "Bold"}], 
                   "]"}]}], "]"}], ",", ",", "\"\<with highest weight  \>\"", 
                ",", ",", 
                RowBox[{"Manipulate", "[", 
                 RowBox[{
                  RowBox[{"Grid", "[", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<Matter:\>\"", ",", 
                    RowBox[{"Style", "[", 
                    RowBox[{"n", "  ", ",", 
                    RowBox[{"FontColor", "\[Rule]", 
                    RowBox[{"Darker", "[", "Magenta", "]"}]}], ",", "Bold"}], 
                    "]"}], ",", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\</\>\"", "  ", ",", 
                    RowBox[{"FontColor", "\[Rule]", 
                    RowBox[{"Darker", "[", "Magenta", "]"}]}], ",", "Bold"}], 
                    "]"}], ",", 
                    RowBox[{"Style", "[", " ", 
                    RowBox[{
                    RowBox[{"Length", "[", 
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], " ", ",", 
                    RowBox[{"FontColor", "\[Rule]", 
                    RowBox[{"Darker", "[", "Magenta", "]"}]}], ",", "Bold"}], 
                    "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"HighestWeight", "[", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "]"}], 
                    ",", ",", 
                    "\"\< and \!\(\*SubscriptBox[\(N\), \(f\)]\)= \>\"", ",", 
                    " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "\"\<:\>\"", ",", 
                    ",", 
                    RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"weight", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "   ", "]"}]}], " ", 
                    "]"}], "}"}], ",", "0"}], "   ", "}"}], "}"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"weight", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "   ", "]"}]}], " ", 
                    "]"}], "}"}], ",", "0"}], "   ", "}"}], "}"}], "]"}], 
                    "  ", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/.", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", "}"}], "\[Rule]", "\"\< \>\""}], "}"}]}], "//",
                     "MatrixForm"}]}], " ", "}"}], " ", "]"}]}], "   ", 
                    "}"}]}], "}"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"n", ",", "1", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", "1"}], 
                   "}"}]}], "]"}]}], "}"}], "]"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{
                  SubscriptBox[
                   RowBox[{"s", "[", "j", "]"}], 
                   RowBox[{"i", ",", "2"}]], "\[Rule]", " ", "1"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "1", ",", 
                   RowBox[{"Length", "[", 
                    RowBox[{"WS", "[", " ", 
                    RowBox[{
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], " ", "]"}], " ", 
                    "]"}]}], "      ", "}"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "1", ",", 
                 RowBox[{"Length", "[", 
                  RowBox[{"Mat", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
             ",", 
             RowBox[{"WindowSize", "\[Rule]", "Medium"}], ",", 
             RowBox[{"WindowClickSelect", "\[Rule]", "True"}], ",", 
             RowBox[{"WindowElements", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
               "\"\<VerticalScrollBar\>\"", ",", 
                "\"\<HorizontalScrollBar\>\""}], "}"}]}]}], "]"}]}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"TrueQ", "[", 
           RowBox[{"Y2", "\[Equal]", "$Canceled"}], "]"}], ",", 
          RowBox[{"Return", "[", "\"\<Cancelled\>\"", "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"y2", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "0"}], "]"}], 
            "\[Or]", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"Mat", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "0"}]}], 
           ",", "0", ",", 
           RowBox[{"Flatten", "[", "Y2", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Y", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], "]"}], 
            "\[Or]", 
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "0"}], "]"}]}], 
           ",", "0", ",", 
           RowBox[{"Input", "[", "      ", 
            RowBox[{
             RowBox[{"Row", "[", 
              RowBox[{"{", 
               RowBox[{
               "\"\<Please Input the Signs for the weights of the Tensor \
Representation with highest weight :    \>\"", ",", " ", ",", 
                RowBox[{"Manipulate", "[", 
                 RowBox[{
                  RowBox[{"Row", "[", 
                   RowBox[{
                    RowBox[{"{", " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"weight", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "  ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], " ", "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", " ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", " ", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}]}], "}"}],
                     ",", "0"}], " ", "}"}], "}"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "  ", ",", ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"weight", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "  ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], " ", "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", " ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", " ", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}]}], "}"}],
                     ",", "0"}], " ", "}"}], "}"}], "]"}], " ", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/.", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", "}"}], "\[Rule]", "\"\< \>\""}], "}"}]}], "//",
                     "MatrixForm"}]}], "}"}], ",", 
                    RowBox[{"Spacer", "[", "60", "]"}]}], "]"}], "    ", ",", 
                  
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"a", ",", 
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ",", 
                    "\"\< Tensor Representation\>\""}], "}"}], ",", "1"}], 
                   "}"}]}], "  ", "]"}]}], "  ", "}"}], "]"}], "     ", ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{
                    SubscriptBox[
                    RowBox[{"b", "[", "j", "]"}], 
                    RowBox[{"i", ",", "k"}]], "\[Rule]", " ", "1"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{"WS", "[", " ", 
                    RowBox[{
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], " ", "]"}], " ", 
                    "]"}]}], "      ", "}"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"k", ",", "1", ",", 
                   RowBox[{"Length", "[", 
                    RowBox[{"WS", "[", " ", 
                    RowBox[{
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], " ", "]"}], " ", 
                    "]"}]}], "     ", "}"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "1", ",", 
                 RowBox[{"Length", "[", "BiMat", "]"}]}], "}"}]}], "]"}], ",", 
             RowBox[{"WindowSize", "\[Rule]", "Medium"}], ",", 
             RowBox[{"WindowClickSelect", "\[Rule]", "True"}], "    ", ",", 
             RowBox[{"WindowElements", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
               "\"\<VerticalScrollBar\>\"", ",", 
                "\"\<HorizontalScrollBar\>\""}], "}"}]}]}], " ", "]"}]}], 
          "   ", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"TrueQ", "[", 
           RowBox[{"Y", "\[Equal]", "$Canceled"}], "]"}], ",", 
          RowBox[{"Return", "[", "\"\<Cancelled\>\"", "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"y", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], "]"}], 
            "\[Or]", 
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "0"}], "]"}]}], 
           ",", "0", ",", 
           RowBox[{"Flatten", "[", "Y", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"m", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], "]"}], ",",
              "0", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Length", "[", 
                   RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "0"}], 
                 ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "}"}]}], "]"}], 
           ",", 
           RowBox[{"Mat", "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "0"}], "]"}], ",",
              "0", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Length", "[", 
                   RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "0"}], 
                 ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "}"}]}], "]"}], 
           ",", 
           RowBox[{"Mat", "[", 
            RowBox[{"[", "2", "]"}], "]"}], ",", "BiMat"}], "}"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"f", "[", "i_", "]"}], ":=", 
         RowBox[{"Graph2K", "[", 
          RowBox[{
           RowBox[{"6", 
            RowBox[{"Prepotential6d", "[", "i", "]"}]}], "/.", 
           RowBox[{"DeleteCases", "[", 
            RowBox[{
             RowBox[{"Flatten", "[", 
              RowBox[{"{", 
               RowBox[{"y", ",", "y1", ",", "y2"}], "}"}], "]"}], ",", "0"}], 
            "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Pr", "[", "i_", "]"}], ":=", 
         RowBox[{
          RowBox[{
           RowBox[{"6", 
            RowBox[{"Prepotential6d", "[", "i", "]"}]}], "/.", 
           RowBox[{"DeleteCases", "[", 
            RowBox[{
             RowBox[{"Flatten", "[", 
              RowBox[{"{", 
               RowBox[{"y", ",", "y1", ",", "y2"}], "}"}], "]"}], ",", "0"}], 
            "]"}]}], "//", "Expand"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{
          RowBox[{"Grid", "[", 
           RowBox[{
            RowBox[{"DeleteCases", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Text", "[", "\"\<The Geometry:\>\"", "]"}], ",", 
                  RowBox[{"f", "[", "m", "]"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\"\<\>\"", ",", "y1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"UnsameQ", "[", 
                    RowBox[{"Mat", ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "]"}], ",", 
                    RowBox[{
                    "Text", "[", "\"\<Your Choice of Signs :  \>\"", "]"}], 
                    ",", "\"\<\>\""}], "]"}], ",", "y2"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\"\<\>\"", ",", "y"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\"\< \>\"", ",", "\"\< \>\"", ",", "\"\< \>\""}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Text", "[", "\"\<The Prepotential 6F=\>\"", "]"}], 
                  ",", 
                  RowBox[{
                   RowBox[{"6", 
                    RowBox[{"Pr", "[", "m", "]"}]}], "//", "Expand"}]}], 
                 "}"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"\"\<\>\"", ",", "0"}], "}"}]}], "]"}], ",", 
            RowBox[{"Frame", "\[Rule]", "True"}], ",", 
            RowBox[{"FrameStyle", "\[Rule]", 
             RowBox[{"Directive", "[", 
              RowBox[{
               RowBox[{"Thickness", "[", "2", "]"}], ",", 
               RowBox[{"Darker", "[", "Red", "]"}]}], "]"}]}], ",", 
            RowBox[{"Background", "\[Rule]", "White"}], ",", 
            RowBox[{"ItemStyle", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"Directive", "[", 
                 RowBox[{
                  RowBox[{"Darker", "[", "Red", "]"}], ",", "18"}], "]"}], 
                "}"}], ",", "None"}], "}"}]}]}], "]"}], "//", "MatrixForm"}], 
         "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
       RowBox[{"Return", "[", "\"\<There is no such Theory\>\"", "]"}]}], 
      "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Geometry5dKK", "[", "x_", "]"}], ":=", 
   RowBox[{"Which", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "x", "]"}], "\[Equal]", "2"}], ",", 
     RowBox[{"GeomKK", "[", "x", "]"}], ",", 
     RowBox[{
      RowBox[{"Length", "[", "x", "]"}], "\[Equal]", "3"}], ",", 
     RowBox[{"Geom2KK", "[", "x", "]"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"Length", "[", "x", "]"}], "\[NotEqual]", "2"}], "&&", 
      RowBox[{
       RowBox[{"Length", "[", "x", "]"}], "\[NotEqual]", "3"}]}], ",", 
     RowBox[{"Print", "[", "\"\<Wrong Input, Check Instructions\>\"", "]"}]}],
     "]"}]}], " ", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"signsgraph", "[", "representation___", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"irrep", "=", "representation"}], ",", "rank", ",", "W", ",", 
       "S", ",", "sgn", ",", "dired", ",", "zWind", ",", "refl", ",", "const",
        ",", "fsgns", ",", "vec3", ",", "sgnov", ",", "ineq", ",", "oversign",
        ",", "truth", ",", "candsign", ",", "truelist", ",", "i", ",", "j", 
       ",", "k", ",", "l", ",", "grpos", ",", "truesign", ",", "dummysign", 
       ",", "indsign", ",", "constsign", ",", "zindex", ",", "fullineq", ",", 
       "diff", ",", "defsign", ",", "pos", ",", "neg", ",", "zero", ",", 
       "zerorep", ",", "max", ",", "wtgrph", ",", "tenslabel", ",", 
       "newlabel"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "convert", " ", "a", " ", "list", " ", "to", " ", "a", " ", "vector"}], 
      " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"vec3", "[", "x_", "]"}], ":=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"x", "[", 
          RowBox[{"[", "i", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "x", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "convert", " ", "irreps", " ", "into", " ", "lists", " ", "of", " ", 
        "vectors"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"j", "=", "1"}], ",", 
        RowBox[{"j", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "convert", " ", "weights", " ", "to", " ", "alpha", " ", "basis"}], 
         " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"W", "[", "j", "]"}], "=", 
          RowBox[{"Map", "[", 
           RowBox[{"vec3", ",", 
            RowBox[{
             RowBox[{"Map", "[", 
              RowBox[{"WeightSystem", ",", 
               RowBox[{
                RowBox[{"irrep", "[", 
                 RowBox[{"[", "j", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "//", "AlphaBasis"}],
             ",", "2"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"W", "[", "j", "]"}], "=", 
          RowBox[{"Map", "[", 
           RowBox[{"Flatten", ",", 
            RowBox[{"Tuples", "[", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"W", "[", "j", "]"}], "[", 
                RowBox[{"[", "i", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"Length", "[", 
                  RowBox[{"W", "[", "j", "]"}], "]"}]}], "}"}]}], "]"}], 
             "]"}]}], "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"max", "=", 
       RowBox[{"Max", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{
            RowBox[{"W", "[", "j", "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "1", ",", 
            RowBox[{"Length", "[", "irrep", "]"}]}], "}"}]}], "]"}], "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"j", "=", "1"}], ",", 
        RowBox[{"j", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{
             RowBox[{"W", "[", "j", "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "]"}], "<", "max"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"W", "[", "j", "]"}], "=", 
           RowBox[{"Map", "[", 
            RowBox[{"Flatten", ",", 
             RowBox[{"Tuples", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"W", "[", "j", "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"ConstantArray", "[", 
                  RowBox[{"0", ",", 
                   RowBox[{"Length", "[", 
                    RowBox[{
                    RowBox[{"W", "[", "j", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], "}"}]}], 
               "}"}], "]"}]}], "]"}]}]}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "convert", " ", "weights", " ", "to", " ", "signs", " ", "of", " ", 
        "alpha", " ", "basis", " ", "coefficients"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", "=", "1"}], ",", 
        RowBox[{"i", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"i", "++"}], ",", 
        RowBox[{
         RowBox[{"S", "[", "i", "]"}], "=", 
         RowBox[{"Map", "[", 
          RowBox[{"Sign", ",", 
           RowBox[{"W", "[", "i", "]"}]}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"sgn", "[", "y_", "]"}], ":=", 
       RowBox[{
        RowBox[{"y", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", 
        RowBox[{"KroneckerDelta", "[", 
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"DeleteDuplicates", "[", 
            RowBox[{"DeleteCases", "[", 
             RowBox[{"y", ",", "0"}], "]"}], "]"}], "]"}], ",", "1"}], 
         "]"}]}]}], " ", ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"compute", " ", "sign", " ", "of", " ", "a", " ", "weight"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ineq", "[", "k", "]"}], "=", 
         RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", 
        RowBox[{
         RowBox[{"diff", "[", "k", "]"}], "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"W", "[", "k", "]"}], "[", 
              RowBox[{"[", "i", "]"}], "]"}], "-", 
             RowBox[{
              RowBox[{"W", "[", "k", "]"}], "[", 
              RowBox[{"[", "j", "]"}], "]"}]}], ")"}], " ", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "[", 
              RowBox[{"W", "[", "k", "]"}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "1", ",", 
             RowBox[{"Length", "[", 
              RowBox[{"W", "[", "k", "]"}], "]"}]}], "}"}]}], "]"}]}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "compute", " ", "a", " ", "list", " ", "of", " ", "inequalities", " ",
          "to", " ", "use", " ", "a", " ", "conditionns"}], ",", " ", 
        RowBox[{
         RowBox[{"sgn", "[", 
          RowBox[{
           RowBox[{"S", "[", "k", "]"}], "[", 
           RowBox[{"[", "j", "]"}], "]"}], "]"}], "===", "0"}], ","}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", 
           RowBox[{"Length", "[", 
            RowBox[{"W", "[", "k", "]"}], "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"j", "=", "1"}], ",", 
            RowBox[{"j", "\[LessEqual]", 
             RowBox[{"Length", "[", 
              RowBox[{"W", "[", "k", "]"}], "]"}]}], ",", 
            RowBox[{"j", "++"}], ",", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Sort", "[", 
                RowBox[{
                 RowBox[{"diff", "[", "k", "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "j"}], "]"}], "]"}], "]"}], "===", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"KroneckerDelta", "[", 
                  RowBox[{"i", ",", 
                   RowBox[{"Length", "[", 
                    RowBox[{
                    RowBox[{"W", "[", "k", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "1", ",", 
                   RowBox[{"Length", "[", 
                    RowBox[{
                    RowBox[{"W", "[", "k", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
               ",", 
              RowBox[{
               RowBox[{"ineq", "[", "k", "]"}], "=", 
               RowBox[{"Append", "[", 
                RowBox[{
                 RowBox[{"ineq", "[", "k", "]"}], ",", 
                 RowBox[{
                  SubscriptBox[
                   RowBox[{"s", "[", "k", "]"}], "i"], ">=", 
                  SubscriptBox[
                   RowBox[{"s", "[", "k", "]"}], "j"]}]}], "]"}]}]}], "]"}]}],
            "]"}]}], "]"}]}], "]"}], ";", " ", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"dired", "[", "k", "]"}], "=", 
          RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", 
            RowBox[{"Length", "[", 
             RowBox[{"W", "[", "k", "]"}], "]"}]}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{"For", "[", 
            RowBox[{
             RowBox[{"j", "=", "1"}], ",", 
             RowBox[{"j", "\[LessEqual]", 
              RowBox[{"Length", "[", 
               RowBox[{"W", "[", "k", "]"}], "]"}]}], ",", 
             RowBox[{"j", "++"}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Sort", "[", 
                 RowBox[{
                  RowBox[{"diff", "[", "k", "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"i", ",", "j"}], "]"}], "]"}], "]"}], "===", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"KroneckerDelta", "[", 
                   RowBox[{"i", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{
                    RowBox[{"W", "[", "k", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", "1", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{
                    RowBox[{"W", "[", "k", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
                ",", 
               RowBox[{
                RowBox[{"dired", "[", "k", "]"}], "=", 
                RowBox[{"Append", "[", 
                 RowBox[{
                  RowBox[{"dired", "[", "k", "]"}], ",", 
                  RowBox[{"DirectedEdge", "[", 
                   RowBox[{"i", ",", "j"}], "]"}]}], "]"}]}]}], "]"}]}], 
            "]"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ineq", "[", "k", "]"}], "=", 
         RowBox[{
          RowBox[{"ineq", "[", "k", "]"}], "/.", 
          RowBox[{"List", "\[Rule]", "And"}]}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"ineq", "[", "k", "]"}], "]"}], "===", "0"}], ",", 
          RowBox[{
           RowBox[{"ineq", "[", "k", "]"}], "=", "True"}]}], "]"}]}], "]"}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"zindex", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", "=", "1"}], ",", 
        RowBox[{"i", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"i", "++"}], ",", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"irrep", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], "===", "0"}], ",", 
          RowBox[{"zindex", "=", 
           RowBox[{"Append", "[", 
            RowBox[{"zindex", ",", "i"}], "]"}]}]}], "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"refl", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"constsign", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"const", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"pos", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"neg", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"zero", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"zerorep", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"l", "=", "1"}], ",", 
          RowBox[{"l", "\[LessEqual]", 
           RowBox[{"Length", "[", 
            RowBox[{"S", "[", 
             RowBox[{"zindex", "[", 
              RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], ",", 
          RowBox[{"l", "++"}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"Map", "[", 
               RowBox[{"sgn", ",", 
                RowBox[{"S", "[", 
                 RowBox[{"zindex", "[", 
                  RowBox[{"[", "k", "]"}], "]"}], "]"}]}], "]"}], "[", 
              RowBox[{"[", "l", "]"}], "]"}], "===", "1"}], ",", 
            RowBox[{"pos", "=", 
             RowBox[{"Append", "[", 
              RowBox[{"pos", ",", 
               RowBox[{
                SubscriptBox[
                 RowBox[{"s", "[", 
                  RowBox[{"zindex", "[", 
                   RowBox[{"[", "k", "]"}], "]"}], "]"}], "l"], ">", "0"}]}], 
              "]"}]}]}], "]"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"l", "=", "1"}], ",", 
          RowBox[{"l", "\[LessEqual]", 
           RowBox[{"Length", "[", 
            RowBox[{"S", "[", 
             RowBox[{"zindex", "[", 
              RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], ",", 
          RowBox[{"l", "++"}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"Map", "[", 
               RowBox[{"sgn", ",", 
                RowBox[{"S", "[", 
                 RowBox[{"zindex", "[", 
                  RowBox[{"[", "k", "]"}], "]"}], "]"}]}], "]"}], "[", 
              RowBox[{"[", "l", "]"}], "]"}], "===", 
             RowBox[{"-", "1"}]}], ",", 
            RowBox[{"neg", "=", 
             RowBox[{"Append", "[", 
              RowBox[{"neg", ",", 
               RowBox[{
                SubscriptBox[
                 RowBox[{"s", "[", 
                  RowBox[{"zindex", "[", 
                   RowBox[{"[", "k", "]"}], "]"}], "]"}], "l"], "<", "0"}]}], 
              "]"}]}]}], "]"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"l", "=", "1"}], ",", 
          RowBox[{"l", "\[LessEqual]", 
           RowBox[{"Length", "[", 
            RowBox[{"W", "[", 
             RowBox[{"zindex", "[", 
              RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], ",", 
          RowBox[{"l", "++"}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"W", "[", 
                RowBox[{"zindex", "[", 
                 RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
               RowBox[{"[", "l", "]"}], "]"}], ".", 
              RowBox[{
               RowBox[{"W", "[", 
                RowBox[{"zindex", "[", 
                 RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
               RowBox[{"[", "l", "]"}], "]"}]}], "===", "0"}], ",", 
            RowBox[{"zero", "=", 
             RowBox[{"Append", "[", 
              RowBox[{"zero", ",", 
               SubscriptBox[
                RowBox[{"s", "[", 
                 RowBox[{"zindex", "[", 
                  RowBox[{"[", "k", "]"}], "]"}], "]"}], "l"]}], "]"}]}]}], 
           "]"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"j", "=", "1"}], ",", 
        RowBox[{"j", "\[LessEqual]", 
         RowBox[{"Length", "[", "zero", "]"}]}], ",", 
        RowBox[{"j", "++"}], ",", 
        RowBox[{"zerorep", "=", 
         RowBox[{"Append", "[", 
          RowBox[{"zerorep", ",", 
           RowBox[{
            RowBox[{"zero", "[", 
             RowBox[{"[", "j", "]"}], "]"}], "\[Rule]", "0"}]}], "]"}]}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"defsign", "=", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{"pos", ",", "neg"}], "]"}], "/.", 
        RowBox[{"{", 
         RowBox[{"List", "\[Rule]", "And"}], "}"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"l", "=", "1"}], ",", 
          RowBox[{"l", "\[LessEqual]", 
           RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
          RowBox[{"l", "++"}], ",", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"i", "=", "1"}], ",", 
            RowBox[{"i", "\[LessEqual]", 
             RowBox[{"Length", "[", 
              RowBox[{"W", "[", 
               RowBox[{"zindex", "[", 
                RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], ",", 
            RowBox[{"i", "++"}], ",", 
            RowBox[{"For", "[", 
             RowBox[{
              RowBox[{"j", "=", "1"}], ",", 
              RowBox[{"j", "\[LessEqual]", 
               RowBox[{"Length", "[", 
                RowBox[{"W", "[", 
                 RowBox[{"zindex", "[", 
                  RowBox[{"[", "l", "]"}], "]"}], "]"}], "]"}]}], ",", 
              RowBox[{"j", "++"}], ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Map", "[", 
                    RowBox[{"Abs", ",", 
                    RowBox[{"Flatten", "[", 
                    RowBox[{"Minors", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}], "}"}], ",", "2"}], 
                    "]"}], "]"}]}], "]"}], "/.", 
                    RowBox[{"List", "\[Rule]", "Plus"}]}], ")"}], "===", 
                  "0"}], "&&", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "!=", 
                  RowBox[{
                   RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "j", "]"}], "]"}]}], "&&", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Map", "[", 
                    RowBox[{"Abs", ",", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], "/.", 
                    RowBox[{"List", "\[Rule]", "Plus"}]}], ")"}], "!=", "0"}],
                  "&&", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Map", "[", 
                    RowBox[{"Abs", ",", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}], "]"}], "/.", 
                    RowBox[{"List", "\[Rule]", "Plus"}]}], ")"}], "!=", 
                  "0"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"refl", "=", 
                   RowBox[{"Append", "[", 
                    RowBox[{"refl", ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"w", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "i"], "\[Equal]", 
                    RowBox[{"a", " ", 
                    SubscriptBox[
                    RowBox[{"w", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "j"]}]}], "}"}], "/.", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Solve", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}]}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}], "]"}]}], ",", 
                  RowBox[{"constsign", "=", 
                   RowBox[{"Append", "[", 
                    RowBox[{"constsign", ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"s", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "i"], "\[Equal]", 
                    RowBox[{
                    RowBox[{"Sign", "[", "a", "]"}], 
                    SubscriptBox[
                    RowBox[{"s", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "j"]}]}], "}"}], "/.", 
                    RowBox[{
                    RowBox[{"Solve", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}]}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}]}], "]"}]}]}], "}"}]}], 
               "]"}]}], "]"}]}], "]"}]}], "]"}]}], "]"}], ";", " ", 
      "\[IndentingNewLine]", 
      RowBox[{"const", "=", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Flatten", "[", "refl", "]"}], "//", "Reduce"}], ")"}], "/.", 
         RowBox[{"{", 
          RowBox[{"And", "\[Rule]", "List"}], "}"}]}], ")"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"constsign", "=", 
       RowBox[{
        RowBox[{"Flatten", "[", "constsign", "]"}], "/.", 
        RowBox[{"{", 
         RowBox[{"List", "\[Rule]", "And"}], "}"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "constsign", "]"}], "===", "0"}], ",", 
        RowBox[{"constsign", "=", "True"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"indsign", "=", 
       RowBox[{"DeleteCases", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             SubscriptBox[
              RowBox[{"s", "[", "k", "]"}], "i"], ",", 
             RowBox[{"{", 
              RowBox[{"k", ",", "1", ",", 
               RowBox[{"Length", "[", "irrep", "]"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", 
               RowBox[{"Length", "[", 
                RowBox[{"W", "[", "k", "]"}], "]"}]}], "}"}]}], "]"}], "//", 
           "Flatten"}], ")"}], ",", 
         RowBox[{"Apply", "[", 
          RowBox[{"Alternatives", ",", "zero"}], "]"}]}], "]"}]}], ";", " ", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"indsign", "=", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            SubscriptBox[
             RowBox[{"s", "[", "k", "]"}], "i"], ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", "1", ",", 
              RowBox[{"Length", "[", "irrep", "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "[", 
               RowBox[{"W", "[", "k", "]"}], "]"}]}], "}"}]}], "]"}], "//", 
          "Flatten"}]}], ";"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"oversign", "[", "x_", "]"}], ":=", 
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"Apply", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"indsign", "[", 
                  RowBox[{"[", "j", "]"}], "]"}], "\[Rule]", 
                 RowBox[{
                  RowBox[{"2", 
                   SubscriptBox["i", "j"]}], "-", "1"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"j", ",", "1", ",", 
                  RowBox[{"Length", "[", "indsign", "]"}]}], "}"}]}], "]"}], 
              ",", "##"}], "]"}], "&"}], ",", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               SubscriptBox["i", "m"], ",", "0", ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"m", ",", "1", ",", "x"}], "}"}]}], "]"}]}], "]"}], ",", 
         RowBox[{"x", "-", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"truth", "[", "x_", "]"}], ":=", 
       RowBox[{
        RowBox[{"Map", "[", 
         RowBox[{"Boole", ",", "x"}], "]"}], "/.", 
        RowBox[{"{", 
         RowBox[{"List", "\[Rule]", "Times"}], "}"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"dummysign", "=", 
       RowBox[{"oversign", "[", 
        RowBox[{"Length", "[", "indsign", "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"fullineq", "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"ineq", "[", "k", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", "1", ",", 
              RowBox[{"Length", "[", "irrep", "]"}]}], "}"}]}], "]"}], "//", 
          "Flatten"}], ")"}], "/.", 
        RowBox[{"{", 
         RowBox[{"List", "\[Rule]", "And"}], "}"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"candsign", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"defsign", "&&", "constsign", "&&", "fullineq"}], " ", "/.", 
         "zerorep"}], "/.", "dummysign"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"truelist", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", "=", "1"}], ",", 
        RowBox[{"i", "\[LessEqual]", 
         RowBox[{"Length", "[", "candsign", "]"}]}], ",", 
        RowBox[{"i", "++"}], ",", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"candsign", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"truelist", "=", 
            RowBox[{"Append", "[", 
             RowBox[{"truelist", ",", "i"}], "]"}]}], "}"}]}], "]"}]}], "]"}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"candsign", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"dummysign", "[", 
          RowBox[{"[", 
           RowBox[{"truelist", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "truelist", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"j", "=", "1"}], ",", 
        RowBox[{"j", "\[LessEqual]", 
         RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
        RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"k", "=", "1"}], ",", 
           RowBox[{"k", "\[LessEqual]", 
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"irrep", "[", 
               RowBox[{"[", "j", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ",", 
           RowBox[{"k", "++"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"tenslabel", "[", "j", "]"}], "[", "k", "]"}], "=", 
            RowBox[{"Table", "[", 
             RowBox[{"i", ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"Length", "[", 
                 RowBox[{"WeightSystem", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"irrep", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                   RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], "}"}]}], 
             "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"newlabel", "[", "j", "]"}], "=", 
          RowBox[{"Tuples", "[", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"tenslabel", "[", "j", "]"}], "[", "k", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"k", ",", "1", ",", 
               RowBox[{"Length", "[", 
                RowBox[{
                 RowBox[{"irrep", "[", 
                  RowBox[{"[", "j", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
           "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"truesign", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"k", "=", "1"}], ",", 
        RowBox[{"k", "\[LessEqual]", 
         RowBox[{"Length", "[", "truelist", "]"}]}], ",", 
        RowBox[{"k", "++"}], ",", 
        RowBox[{"truesign", "=", 
         RowBox[{"Append", "[", 
          RowBox[{"truesign", ",", 
           RowBox[{"dummysign", "[", 
            RowBox[{"[", 
             RowBox[{"truelist", "[", 
              RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], "]"}]}]}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"wtgrph", "[", "wtsgns___", "]"}], ":=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Graph", "[", 
          RowBox[{
           RowBox[{"dired", "[", "k", "]"}], ",", 
           RowBox[{"VertexSize", "\[Rule]", ".8"}], ",", 
           RowBox[{"VertexShape", "\[Rule]", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"i", "\[Rule]", 
               RowBox[{"Style", "[", 
                RowBox[{
                 SuperscriptBox[
                  SubscriptBox["w", 
                   RowBox[{
                    RowBox[{"newlabel", "[", "k", "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}]], 
                  RowBox[{
                   RowBox[{"Style", "[", 
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"s", "[", "k", "]"}], "i"], ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"s", "[", "k", "]"}], "i"], ">", "0"}], ",", 
                    RowBox[{"Darker", "[", "Cyan", "]"}], ",", "Red"}], "]"}],
                     ",", "Bold", ",", 
                    RowBox[{"FontSize", "\[Rule]", "14"}]}], "]"}], "/.", 
                   "wtsgns"}]], ",", "Blue", ",", "17", ",", "Bold"}], 
                "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"Length", "[", 
                 RowBox[{"W", "[", "k", "]"}], "]"}]}], "}"}]}], "]"}]}], ",", 
           RowBox[{"PerformanceGoal", "\[Rule]", "\"\<Quality\>\""}], ",", 
           RowBox[{"EdgeStyle", "\[Rule]", 
            RowBox[{"Darker", "[", "Green", "]"}]}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "Medium"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"k", ",", "1", ",", 
           RowBox[{"Length", "[", "irrep", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Return", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"wtgrph", "[", 
            RowBox[{"truesign", "[", 
             RowBox[{"[", "j", "]"}], "]"}], "]"}], ",", 
           RowBox[{"truesign", "[", 
            RowBox[{"[", "j", "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "1", ",", 
           RowBox[{"Length", "[", "truesign", "]"}]}], "}"}]}], "]"}], 
       "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Signs1KK", "[", "l_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "f", ",", "x", ",", "Mat2", ",", "Mat", ",", "zeros", ",", "c1"}], "}"}],
     ",", 
    RowBox[{
     RowBox[{
      RowBox[{"f", "[", "1", "]"}], "=", 
      RowBox[{
       RowBox[{"f", "[", "2", "]"}], "=", "1"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"x", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"l", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
         
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{
            RowBox[{"l", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], "]"}], ">", "0"}], "&&", 
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"l", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Loop"}], "]"}]}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"l", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"l", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "}"}], ",", "l"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"Allowed6d1", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"x", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{
            RowBox[{"x", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], ",", 
           RowBox[{"x", "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}], "\[Equal]", "1"}],
        ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Mat2", "=", 
         RowBox[{"TotalMatter", "[", 
          RowBox[{
           RowBox[{"x", "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{
            RowBox[{"x", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{
            RowBox[{"x", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], " ", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"zeros", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"Mat2", "[", 
                  RowBox[{"[", "n", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], ",", 
               RowBox[{"{", "n", "}"}], ",", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "1", ",", 
               RowBox[{"Length", "[", "Mat2", "]"}]}], "}"}]}], "]"}], ",", 
           "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Mat", "=", 
         RowBox[{"Delete", "[", 
          RowBox[{"Mat2", ",", "zeros"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "Mat", "]"}], "\[Equal]", "0"}], ",", 
          RowBox[{
          "Return", "[", "\"\<This theory does not have any matter\>\"", 
           "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{"\"\<Weights for Representation \>\"", ",", 
            RowBox[{"Style", "[", 
             RowBox[{"n", ",", 
              RowBox[{"FontColor", "\[Rule]", "Red"}], ",", "Bold"}], "]"}], 
            ",", "\"\< of Highest Weight: \>\"", ",", 
            RowBox[{"HighestWeight", "[", 
             RowBox[{"irrep2", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Mat", "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{"AT", "[", 
                RowBox[{
                 RowBox[{"TT", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "]"}], 
            ",", "\"\<     Hassee Diagram =\>\"", ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"weight", "[", 
                  RowBox[{"{", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], " ", "]"}]}], " ", 
                    "]"}], "}"}], ",", "0"}], "}"}], "}"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"weight", "[", 
                   RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], " ", "]"}]}], " ", 
                    "]"}], "}"}], ",", "0"}], "}"}], "}"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "/.", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", "}"}], "\[Rule]", "\"\< \>\""}], "}"}]}], "//",
                 "MatrixForm"}]}], "}"}], "//", "MatrixForm"}]}], "]"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"n", ",", "1", ",", 
            RowBox[{"Length", "[", "Mat", "]"}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"c1", "=", 
         RowBox[{"signsgraph", "[", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"irrep2", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Mat", "[", 
                   RowBox[{"[", "n", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{"AT", "[", 
                  RowBox[{
                   RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "}"}], 
              ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"Mat", "[", 
                   RowBox[{"[", "n", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
                 FractionBox["1", "2"]}], ",", "0", ",", "1"}], "]"}]}], 
             "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", "1", ",", 
              RowBox[{"Length", "[", "Mat", "]"}]}], "}"}]}], "]"}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{"Manipulate", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"c1", "[", 
                RowBox[{"[", "Phase", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{
               RowBox[{
                RowBox[{"c1", "[", 
                 RowBox[{"[", "Phase", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], "/.", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", "}"}], "\[Rule]", "\"\< \>\""}], "}"}]}]}], 
             "}"}], "//", "MatrixForm"}], ",", 
           RowBox[{"Pane", "[", 
            RowBox[{
             RowBox[{"Control", "@", 
              RowBox[{"{", 
               RowBox[{"Phase", ",", 
                RowBox[{"Table", "[", 
                 RowBox[{"j", ",", 
                  RowBox[{"{", 
                   RowBox[{"j", ",", "1", ",", 
                    RowBox[{"Length", "[", "c1", "]"}]}], "}"}]}], "]"}], ",", 
                RowBox[{"ControlType", "\[Rule]", "Setter"}], ",", 
                RowBox[{"BaselinePosition", "\[Rule]", "Center"}], ",", 
                RowBox[{"Method", "\[Rule]", "\"\<Active\>\""}], ",", 
                RowBox[{"Appearance", "\[Rule]", "\"\<Horizontal\>\""}]}], 
               "}"}]}], ",", "Full", ",", 
             RowBox[{"Scrollbars", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"True", ",", "False"}], "}"}]}], ",", 
             RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], ",", 
           
           RowBox[{
           "FrameLabel", "\[Rule]", 
            "\"\<Choose a Phase for this Theory\>\""}]}], "]"}], "]"}]}], ",", 
       RowBox[{"Return", "[", "\"\<This Theory does not exist\>\"", "]"}]}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"weight3", "[", "representation___", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"irrep", "=", "representation"}], ",", "rank", ",", "W", ",", 
      "S", ",", "sgn", ",", "dired", ",", "zWind", ",", "refl", ",", "const", 
      ",", "fsgns", ",", "vec3", ",", "sgnov", ",", "ineq", ",", "oversign", 
      ",", "truth", ",", "candsign", ",", "truelist", ",", "i", ",", "j", ",",
       "k", ",", "l", ",", "grpos", ",", "truesign", ",", "dummysign", ",", 
      "indsign", ",", "constsign", ",", "zindex", ",", "fullineq", ",", 
      "diff", ",", "defsign", ",", "pos", ",", "neg", ",", "zero", ",", 
      "zerorep", ",", "max", ",", "wtgrph", ",", "tenslabel", ",", 
      "newlabel"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
     "convert", " ", "a", " ", "list", " ", "to", " ", "a", " ", "vector"}], 
     " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"vec3", "[", "x_", "]"}], ":=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"x", "[", 
         RowBox[{"[", "i", "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "x", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "convert", " ", "irreps", " ", "into", " ", "lists", " ", "of", " ", 
       "vectors"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"j", "=", "1"}], ",", 
       RowBox[{"j", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "convert", " ", "weights", " ", "to", " ", "alpha", " ", "basis"}], 
        " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"W", "[", "j", "]"}], "=", 
         RowBox[{"Map", "[", 
          RowBox[{"vec3", ",", 
           RowBox[{
            RowBox[{"Map", "[", 
             RowBox[{"WeightSystem", ",", 
              RowBox[{
               RowBox[{"irrep", "[", 
                RowBox[{"[", "j", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "//", "AlphaBasis"}], 
           ",", "2"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"W", "[", "j", "]"}], "=", 
         RowBox[{"Map", "[", 
          RowBox[{"Flatten", ",", 
           RowBox[{"Tuples", "[", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"W", "[", "j", "]"}], "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"Length", "[", 
                 RowBox[{"W", "[", "j", "]"}], "]"}]}], "}"}]}], "]"}], 
            "]"}]}], "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"max", "=", 
      RowBox[{"Max", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Length", "[", 
          RowBox[{
           RowBox[{"W", "[", "j", "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "1", ",", 
           RowBox[{"Length", "[", "irrep", "]"}]}], "}"}]}], "]"}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"j", "=", "1"}], ",", 
       RowBox[{"j", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{
            RowBox[{"W", "[", "j", "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "]"}], "<", "max"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"W", "[", "j", "]"}], "=", 
          RowBox[{"Map", "[", 
           RowBox[{"Flatten", ",", 
            RowBox[{"Tuples", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"W", "[", "j", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"ConstantArray", "[", 
                 RowBox[{"0", ",", 
                  RowBox[{"Length", "[", 
                   RowBox[{
                    RowBox[{"W", "[", "j", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], "}"}]}], 
              "}"}], "]"}]}], "]"}]}]}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "convert", " ", "weights", " ", "to", " ", "signs", " ", "of", " ", 
       "alpha", " ", "basis", " ", "coefficients"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{
        RowBox[{"S", "[", "i", "]"}], "=", 
        RowBox[{"Map", "[", 
         RowBox[{"Sign", ",", 
          RowBox[{"W", "[", "i", "]"}]}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"sgn", "[", "y_", "]"}], ":=", 
      RowBox[{
       RowBox[{"y", "[", 
        RowBox[{"[", "1", "]"}], "]"}], " ", 
       RowBox[{"KroneckerDelta", "[", 
        RowBox[{
         RowBox[{"Length", "[", 
          RowBox[{"DeleteDuplicates", "[", 
           RowBox[{"DeleteCases", "[", 
            RowBox[{"y", ",", "0"}], "]"}], "]"}], "]"}], ",", "1"}], 
        "]"}]}]}], " ", ";", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"compute", " ", "sign", " ", "of", " ", "a", " ", "weight"}], 
      " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ineq", "[", "k", "]"}], "=", 
        RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", 
       RowBox[{
        RowBox[{"diff", "[", "k", "]"}], "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"W", "[", "k", "]"}], "[", 
             RowBox[{"[", "i", "]"}], "]"}], "-", 
            RowBox[{
             RowBox[{"W", "[", "k", "]"}], "[", 
             RowBox[{"[", "j", "]"}], "]"}]}], ")"}], " ", ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"W", "[", "k", "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "1", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"W", "[", "k", "]"}], "]"}]}], "}"}]}], "]"}]}]}], "]"}],
      ";", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{
       "compute", " ", "a", " ", "list", " ", "of", " ", "inequalities", " ", 
        "to", " ", "use", " ", "a", " ", "conditionns"}], ",", " ", 
       RowBox[{
        RowBox[{"sgn", "[", 
         RowBox[{
          RowBox[{"S", "[", "k", "]"}], "[", 
          RowBox[{"[", "j", "]"}], "]"}], "]"}], "===", "0"}], ","}], " ", 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"Length", "[", 
           RowBox[{"W", "[", "k", "]"}], "]"}]}], ",", 
         RowBox[{"i", "++"}], ",", 
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"j", "=", "1"}], ",", 
           RowBox[{"j", "\[LessEqual]", 
            RowBox[{"Length", "[", 
             RowBox[{"W", "[", "k", "]"}], "]"}]}], ",", 
           RowBox[{"j", "++"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Sort", "[", 
               RowBox[{
                RowBox[{"diff", "[", "k", "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "j"}], "]"}], "]"}], "]"}], "===", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"KroneckerDelta", "[", 
                 RowBox[{"i", ",", 
                  RowBox[{"Length", "[", 
                   RowBox[{
                    RowBox[{"W", "[", "k", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "1", ",", 
                  RowBox[{"Length", "[", 
                   RowBox[{
                    RowBox[{"W", "[", "k", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
              ",", 
             RowBox[{
              RowBox[{"ineq", "[", "k", "]"}], "=", 
              RowBox[{"Append", "[", 
               RowBox[{
                RowBox[{"ineq", "[", "k", "]"}], ",", 
                RowBox[{
                 SubscriptBox[
                  RowBox[{"s", "[", "k", "]"}], "i"], ">=", 
                 SubscriptBox[
                  RowBox[{"s", "[", "k", "]"}], "j"]}]}], "]"}]}]}], "]"}]}], 
          "]"}]}], "]"}]}], "]"}], ";", " ", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"dired", "[", "k", "]"}], "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", 
           RowBox[{"Length", "[", 
            RowBox[{"W", "[", "k", "]"}], "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"j", "=", "1"}], ",", 
            RowBox[{"j", "\[LessEqual]", 
             RowBox[{"Length", "[", 
              RowBox[{"W", "[", "k", "]"}], "]"}]}], ",", 
            RowBox[{"j", "++"}], ",", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Sort", "[", 
                RowBox[{
                 RowBox[{"diff", "[", "k", "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "j"}], "]"}], "]"}], "]"}], "===", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"KroneckerDelta", "[", 
                  RowBox[{"i", ",", 
                   RowBox[{"Length", "[", 
                    RowBox[{
                    RowBox[{"W", "[", "k", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "1", ",", 
                   RowBox[{"Length", "[", 
                    RowBox[{
                    RowBox[{"W", "[", "k", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
               ",", 
              RowBox[{
               RowBox[{"dired", "[", "k", "]"}], "=", 
               RowBox[{"Append", "[", 
                RowBox[{
                 RowBox[{"dired", "[", "k", "]"}], ",", 
                 RowBox[{"DirectedEdge", "[", 
                  RowBox[{"i", ",", "j"}], "]"}]}], "]"}]}]}], "]"}]}], 
           "]"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ineq", "[", "k", "]"}], "=", 
        RowBox[{
         RowBox[{"ineq", "[", "k", "]"}], "/.", 
         RowBox[{"List", "\[Rule]", "And"}]}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"ineq", "[", "k", "]"}], "]"}], "===", "0"}], ",", 
         RowBox[{
          RowBox[{"ineq", "[", "k", "]"}], "=", "True"}]}], "]"}]}], "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"zindex", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"irrep", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}], "===", "0"}], ",", 
         RowBox[{"zindex", "=", 
          RowBox[{"Append", "[", 
           RowBox[{"zindex", ",", "i"}], "]"}]}]}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"refl", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"constsign", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"const", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"pos", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"neg", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"zero", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"zerorep", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"l", "=", "1"}], ",", 
         RowBox[{"l", "\[LessEqual]", 
          RowBox[{"Length", "[", 
           RowBox[{"S", "[", 
            RowBox[{"zindex", "[", 
             RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], ",", 
         RowBox[{"l", "++"}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Map", "[", 
              RowBox[{"sgn", ",", 
               RowBox[{"S", "[", 
                RowBox[{"zindex", "[", 
                 RowBox[{"[", "k", "]"}], "]"}], "]"}]}], "]"}], "[", 
             RowBox[{"[", "l", "]"}], "]"}], "===", "1"}], ",", 
           RowBox[{"pos", "=", 
            RowBox[{"Append", "[", 
             RowBox[{"pos", ",", 
              RowBox[{
               SubscriptBox[
                RowBox[{"s", "[", 
                 RowBox[{"zindex", "[", 
                  RowBox[{"[", "k", "]"}], "]"}], "]"}], "l"], "\[Rule]", 
               RowBox[{"Style", "[", "\"\<+\>\"", "]"}]}]}], "]"}]}]}], 
          "]"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"l", "=", "1"}], ",", 
         RowBox[{"l", "\[LessEqual]", 
          RowBox[{"Length", "[", 
           RowBox[{"S", "[", 
            RowBox[{"zindex", "[", 
             RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], ",", 
         RowBox[{"l", "++"}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Map", "[", 
              RowBox[{"sgn", ",", 
               RowBox[{"S", "[", 
                RowBox[{"zindex", "[", 
                 RowBox[{"[", "k", "]"}], "]"}], "]"}]}], "]"}], "[", 
             RowBox[{"[", "l", "]"}], "]"}], "===", 
            RowBox[{"-", "1"}]}], ",", 
           RowBox[{"neg", "=", 
            RowBox[{"Append", "[", 
             RowBox[{"neg", ",", 
              RowBox[{
               SubscriptBox[
                RowBox[{"s", "[", 
                 RowBox[{"zindex", "[", 
                  RowBox[{"[", "k", "]"}], "]"}], "]"}], "l"], "\[Rule]", 
               RowBox[{"Style", "[", "\"\<-\>\"", "]"}]}]}], "]"}]}]}], 
          "]"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"l", "=", "1"}], ",", 
         RowBox[{"l", "\[LessEqual]", 
          RowBox[{"Length", "[", 
           RowBox[{"W", "[", 
            RowBox[{"zindex", "[", 
             RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], ",", 
         RowBox[{"l", "++"}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"W", "[", 
               RowBox[{"zindex", "[", 
                RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
              RowBox[{"[", "l", "]"}], "]"}], ".", 
             RowBox[{
              RowBox[{"W", "[", 
               RowBox[{"zindex", "[", 
                RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
              RowBox[{"[", "l", "]"}], "]"}]}], "===", "0"}], ",", 
           RowBox[{"zero", "=", 
            RowBox[{"Append", "[", 
             RowBox[{"zero", ",", 
              SubscriptBox[
               RowBox[{"s", "[", 
                RowBox[{"zindex", "[", 
                 RowBox[{"[", "k", "]"}], "]"}], "]"}], "l"]}], "]"}]}]}], 
          "]"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"j", "=", "1"}], ",", 
       RowBox[{"j", "\[LessEqual]", 
        RowBox[{"Length", "[", "zero", "]"}]}], ",", 
       RowBox[{"j", "++"}], ",", 
       RowBox[{"zerorep", "=", 
        RowBox[{"Append", "[", 
         RowBox[{"zerorep", ",", 
          RowBox[{
           RowBox[{"zero", "[", 
            RowBox[{"[", "j", "]"}], "]"}], "\[Rule]", "0"}]}], "]"}]}]}], 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"defsign", "=", 
      RowBox[{"Join", "[", 
       RowBox[{"pos", ",", "neg"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"const", "=", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Flatten", "[", "refl", "]"}], "//", "Reduce"}], ")"}], "/.", 
        RowBox[{"{", 
         RowBox[{"And", "\[Rule]", "List"}], "}"}]}], ")"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"fullineq", "=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ineq", "[", "k", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"k", ",", "1", ",", 
             RowBox[{"Length", "[", "irrep", "]"}]}], "}"}]}], "]"}], "//", 
         "Flatten"}], ")"}], "/.", 
       RowBox[{"{", 
        RowBox[{"List", "\[Rule]", "And"}], "}"}]}]}], ";", " ", 
     "\[IndentingNewLine]", 
     RowBox[{"candsign", "=", 
      RowBox[{"Join", "[", 
       RowBox[{"defsign", ",", "zerorep"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", 
         RowBox[{
          RowBox[{"irrep", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", 
       RowBox[{
        RowBox[{"tenslabel", "[", "k", "]"}], "=", 
        RowBox[{"Table", "[", 
         RowBox[{"i", ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"WeightSystem", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"irrep", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "[", 
               RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], "}"}]}], 
         "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"newlabel", "=", 
      RowBox[{"Tuples", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"tenslabel", "[", "k", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"k", ",", "1", ",", 
           RowBox[{"Length", "[", 
            RowBox[{
             RowBox[{"irrep", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], "]"}]}],
      ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"l", "=", "1"}], ",", 
         RowBox[{"l", "\[LessEqual]", 
          RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
         RowBox[{"l", "++"}], ",", 
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", 
            RowBox[{"Length", "[", 
             RowBox[{"W", "[", 
              RowBox[{"zindex", "[", 
               RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], ",", 
           RowBox[{"i", "++"}], ",", 
           RowBox[{"For", "[", 
            RowBox[{
             RowBox[{"j", "=", "1"}], ",", 
             RowBox[{"j", "\[LessEqual]", 
              RowBox[{"Length", "[", 
               RowBox[{"W", "[", 
                RowBox[{"zindex", "[", 
                 RowBox[{"[", "l", "]"}], "]"}], "]"}], "]"}]}], ",", 
             RowBox[{"j", "++"}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Map", "[", 
                    RowBox[{"Abs", ",", 
                    RowBox[{"Flatten", "[", 
                    RowBox[{"Minors", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}], "}"}], ",", "2"}], 
                    "]"}], "]"}]}], "]"}], "/.", 
                   RowBox[{"List", "\[Rule]", "Plus"}]}], ")"}], "===", "0"}],
                 "&&", 
                RowBox[{
                 RowBox[{
                  RowBox[{"W", "[", 
                   RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "!=", 
                 RowBox[{
                  RowBox[{"W", "[", 
                   RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "j", "]"}], "]"}]}], "&&", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Map", "[", 
                    RowBox[{"Abs", ",", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], "/.", 
                   RowBox[{"List", "\[Rule]", "Plus"}]}], ")"}], "!=", "0"}], 
                "&&", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Map", "[", 
                    RowBox[{"Abs", ",", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}], "]"}], "/.", 
                   RowBox[{"List", "\[Rule]", "Plus"}]}], ")"}], "!=", 
                 "0"}]}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"refl", "=", 
                  RowBox[{"Append", "[", 
                   RowBox[{"refl", ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    SubscriptBox["w", 
                    RowBox[{"newlabel", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]], "\[Equal]", 
                    RowBox[{"a", " ", 
                    SubscriptBox["w", 
                    RowBox[{"newlabel", "[", 
                    RowBox[{"[", "j", "]"}], "]"}]]}]}], "}"}], "/.", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Solve", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}]}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}], "]"}]}], ",", 
                 RowBox[{"constsign", "=", 
                  RowBox[{"Append", "[", 
                   RowBox[{"constsign", ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"s", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "i"], "\[Equal]", 
                    RowBox[{
                    RowBox[{"Sign", "[", "a", "]"}], 
                    SubscriptBox[
                    RowBox[{"s", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "j"]}]}], "}"}], "/.", 
                    RowBox[{
                    RowBox[{"Solve", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}]}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}]}], "]"}]}]}], "}"}]}], 
              "]"}]}], "]"}]}], "]"}]}], "]"}]}], "]"}], ";", " ", 
     "\[IndentingNewLine]", 
     RowBox[{"xx", "=", "representation"}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"wtgrph", "[", "wtsgns___", "]"}], ":=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"xx", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "3"}], "&&", 
         RowBox[{
          RowBox[{
           RowBox[{"xx", "[", 
            RowBox[{"[", "1", "]"}], "]"}], "[", 
           RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "1"}]}], ",", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Graph", "[", 
           RowBox[{
            RowBox[{"dired", "[", "k", "]"}], ",", 
            RowBox[{"VertexSize", "\[Rule]", ".8"}], ",", 
            RowBox[{"VertexShape", "\[Rule]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"i", "\[Rule]", 
                RowBox[{"Style", "[", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"newlabel", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
                    RowBox[{
                    RowBox[{
                    FractionBox["1", "2"], 
                    RowBox[{"Dim", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"xx", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "+", "1"}]}], 
                    ",", 
                    RowBox[{"Grid", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    SubscriptBox["v", 
                    RowBox[{
                    RowBox[{"newlabel", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}]], "}"}], "}"}], ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}], ",", 
                    SubscriptBox["w", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"newlabel", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ">", 
                    RowBox[{
                    RowBox[{
                    FractionBox["1", "2"], 
                    RowBox[{"Dim", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"xx", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "+", "1"}]}], 
                    ",", 
                    RowBox[{
                    RowBox[{"newlabel", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "-", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "0"}], "}"}]}], ",", 
                    RowBox[{"newlabel", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}]]}], "]"}], 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"s", "[", "k", "]"}], "i"], ",", "Red", ",", 
                    "Bold", ",", 
                    RowBox[{"FontSize", "\[Rule]", "14"}]}], "]"}], "/.", 
                    "wtsgns"}], "/.", 
                    RowBox[{"{", 
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"s", "[", "k", "]"}], "i_"], "\[Rule]", 
                    RowBox[{"Style", "[", "\"\<\>\"", "]"}]}], "}"}]}]], ",", 
                  "Blue", ",", "Bold", ",", "17"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"Length", "[", 
                  RowBox[{"W", "[", "k", "]"}], "]"}]}], "}"}]}], "]"}]}], 
            ",", 
            RowBox[{"PerformanceGoal", "\[Rule]", "\"\<Quality\>\""}], ",", 
            RowBox[{"EdgeStyle", "\[Rule]", 
             RowBox[{"Darker", "[", "Green", "]"}]}], ",", 
            RowBox[{"ImageSize", "\[Rule]", "Medium"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", "1", ",", 
            RowBox[{"Length", "[", "irrep", "]"}]}], "}"}]}], "]"}], ",", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Graph", "[", 
           RowBox[{
            RowBox[{"dired", "[", "k", "]"}], ",", 
            RowBox[{"VertexSize", "\[Rule]", ".8"}], ",", 
            RowBox[{"VertexShape", "\[Rule]", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"i", "\[Rule]", 
                RowBox[{"Style", "[", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"newlabel", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
                    RowBox[{
                    RowBox[{
                    FractionBox["1", "2"], 
                    RowBox[{"Dim", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"xx", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "+", "1"}]}], 
                    ",", 
                    RowBox[{"Grid", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    SubscriptBox["v", 
                    RowBox[{
                    RowBox[{"newlabel", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]], "}"}], "}"}], ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}], ",", 
                    SubscriptBox["w", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"newlabel", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ">", 
                    RowBox[{
                    RowBox[{
                    FractionBox["1", "2"], 
                    RowBox[{"Dim", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"xx", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "+", "1"}]}], 
                    ",", 
                    RowBox[{
                    RowBox[{"newlabel", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "-", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "1"}], "}"}]}], ",", 
                    RowBox[{"newlabel", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}]]}], "]"}], 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"s", "[", "k", "]"}], "i"], ",", "Red", ",", 
                    "Bold", ",", 
                    RowBox[{"FontSize", "\[Rule]", "14"}]}], "]"}], "/.", 
                    "wtsgns"}], "/.", 
                    RowBox[{"{", 
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"s", "[", "k", "]"}], "i_"], "\[Rule]", 
                    RowBox[{"Style", "[", "\"\<\>\"", "]"}]}], "}"}]}]], ",", 
                  "Blue", ",", "Bold", ",", "17"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"Length", "[", 
                  RowBox[{"W", "[", "k", "]"}], "]"}]}], "}"}]}], "]"}]}], 
            ",", 
            RowBox[{"PerformanceGoal", "\[Rule]", "\"\<Quality\>\""}], ",", 
            RowBox[{"EdgeStyle", "\[Rule]", 
             RowBox[{"Darker", "[", "Green", "]"}]}], ",", 
            RowBox[{"ImageSize", "\[Rule]", "Medium"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", "1", ",", 
            RowBox[{"Length", "[", "irrep", "]"}]}], "}"}]}], "]"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Return", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"wtgrph", "[", "candsign", "]"}], ",", "refl"}], "}"}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"signsgraph3", "[", "representation___", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"irrep", "=", "representation"}], ",", "rank", ",", "W", ",", 
      "S", ",", "sgn", ",", "dired", ",", "zWind", ",", "refl", ",", "const", 
      ",", "fsgns", ",", "vec3", ",", "sgnov", ",", "ineq", ",", "oversign", 
      ",", "truth", ",", "candsign", ",", "truelist", ",", "i", ",", "j", ",",
       "k", ",", "l", ",", "grpos", ",", "truesign", ",", "dummysign", ",", 
      "indsign", ",", "constsign", ",", "zindex", ",", "fullineq", ",", 
      "diff", ",", "defsign", ",", "pos", ",", "neg", ",", "zero", ",", 
      "zerorep", ",", "max", ",", "wtgrph", ",", "tenslabel", ",", 
      "newlabel"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
     "convert", " ", "a", " ", "list", " ", "to", " ", "a", " ", "vector"}], 
     " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"vec3", "[", "x_", "]"}], ":=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"x", "[", 
         RowBox[{"[", "i", "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "x", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "convert", " ", "irreps", " ", "into", " ", "lists", " ", "of", " ", 
       "vectors"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"j", "=", "1"}], ",", 
       RowBox[{"j", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "convert", " ", "weights", " ", "to", " ", "alpha", " ", "basis"}], 
        " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"W", "[", "j", "]"}], "=", 
         RowBox[{"Map", "[", 
          RowBox[{"vec3", ",", 
           RowBox[{
            RowBox[{"Map", "[", 
             RowBox[{"WeightSystem", ",", 
              RowBox[{
               RowBox[{"irrep", "[", 
                RowBox[{"[", "j", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "//", "AlphaBasis"}], 
           ",", "2"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"W", "[", "j", "]"}], "=", 
         RowBox[{"Map", "[", 
          RowBox[{"Flatten", ",", 
           RowBox[{"Tuples", "[", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"W", "[", "j", "]"}], "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"Length", "[", 
                 RowBox[{"W", "[", "j", "]"}], "]"}]}], "}"}]}], "]"}], 
            "]"}]}], "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"max", "=", 
      RowBox[{"Max", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Length", "[", 
          RowBox[{
           RowBox[{"W", "[", "j", "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "1", ",", 
           RowBox[{"Length", "[", "irrep", "]"}]}], "}"}]}], "]"}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"j", "=", "1"}], ",", 
       RowBox[{"j", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{
            RowBox[{"W", "[", "j", "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "]"}], "<", "max"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"W", "[", "j", "]"}], "=", 
          RowBox[{"Map", "[", 
           RowBox[{"Flatten", ",", 
            RowBox[{"Tuples", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"W", "[", "j", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"ConstantArray", "[", 
                 RowBox[{"0", ",", 
                  RowBox[{"Length", "[", 
                   RowBox[{
                    RowBox[{"W", "[", "j", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], "}"}]}], 
              "}"}], "]"}]}], "]"}]}]}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "convert", " ", "weights", " ", "to", " ", "signs", " ", "of", " ", 
       "alpha", " ", "basis", " ", "coefficients"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{
        RowBox[{"S", "[", "i", "]"}], "=", 
        RowBox[{"Map", "[", 
         RowBox[{"Sign", ",", 
          RowBox[{"W", "[", "i", "]"}]}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"sgn", "[", "y_", "]"}], ":=", 
      RowBox[{
       RowBox[{"y", "[", 
        RowBox[{"[", "1", "]"}], "]"}], " ", 
       RowBox[{"KroneckerDelta", "[", 
        RowBox[{
         RowBox[{"Length", "[", 
          RowBox[{"DeleteDuplicates", "[", 
           RowBox[{"DeleteCases", "[", 
            RowBox[{"y", ",", "0"}], "]"}], "]"}], "]"}], ",", "1"}], 
        "]"}]}]}], " ", ";", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"compute", " ", "sign", " ", "of", " ", "a", " ", "weight"}], 
      " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ineq", "[", "k", "]"}], "=", 
        RowBox[{"{", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", 
       RowBox[{
        RowBox[{"diff", "[", "k", "]"}], "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"W", "[", "k", "]"}], "[", 
             RowBox[{"[", "i", "]"}], "]"}], "-", 
            RowBox[{
             RowBox[{"W", "[", "k", "]"}], "[", 
             RowBox[{"[", "j", "]"}], "]"}]}], ")"}], " ", ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"W", "[", "k", "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "1", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"W", "[", "k", "]"}], "]"}]}], "}"}]}], "]"}]}]}], "]"}],
      ";", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{
       "compute", " ", "a", " ", "list", " ", "of", " ", "inequalities", " ", 
        "to", " ", "use", " ", "a", " ", "conditionns"}], ",", " ", 
       RowBox[{
        RowBox[{"sgn", "[", 
         RowBox[{
          RowBox[{"S", "[", "k", "]"}], "[", 
          RowBox[{"[", "j", "]"}], "]"}], "]"}], "===", "0"}], ","}], " ", 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"Length", "[", 
           RowBox[{"W", "[", "k", "]"}], "]"}]}], ",", 
         RowBox[{"i", "++"}], ",", 
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"j", "=", "1"}], ",", 
           RowBox[{"j", "\[LessEqual]", 
            RowBox[{"Length", "[", 
             RowBox[{"W", "[", "k", "]"}], "]"}]}], ",", 
           RowBox[{"j", "++"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Sort", "[", 
               RowBox[{
                RowBox[{"diff", "[", "k", "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "j"}], "]"}], "]"}], "]"}], "===", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"KroneckerDelta", "[", 
                 RowBox[{"i", ",", 
                  RowBox[{"Length", "[", 
                   RowBox[{
                    RowBox[{"W", "[", "k", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "1", ",", 
                  RowBox[{"Length", "[", 
                   RowBox[{
                    RowBox[{"W", "[", "k", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
              ",", 
             RowBox[{
              RowBox[{"ineq", "[", "k", "]"}], "=", 
              RowBox[{"Append", "[", 
               RowBox[{
                RowBox[{"ineq", "[", "k", "]"}], ",", 
                RowBox[{
                 SubscriptBox[
                  RowBox[{"s", "[", "k", "]"}], "i"], ">=", 
                 SubscriptBox[
                  RowBox[{"s", "[", "k", "]"}], "j"]}]}], "]"}]}]}], "]"}]}], 
          "]"}]}], "]"}]}], "]"}], ";", " ", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"dired", "[", "k", "]"}], "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", 
           RowBox[{"Length", "[", 
            RowBox[{"W", "[", "k", "]"}], "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"j", "=", "1"}], ",", 
            RowBox[{"j", "\[LessEqual]", 
             RowBox[{"Length", "[", 
              RowBox[{"W", "[", "k", "]"}], "]"}]}], ",", 
            RowBox[{"j", "++"}], ",", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Sort", "[", 
                RowBox[{
                 RowBox[{"diff", "[", "k", "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{"i", ",", "j"}], "]"}], "]"}], "]"}], "===", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"KroneckerDelta", "[", 
                  RowBox[{"i", ",", 
                   RowBox[{"Length", "[", 
                    RowBox[{
                    RowBox[{"W", "[", "k", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "1", ",", 
                   RowBox[{"Length", "[", 
                    RowBox[{
                    RowBox[{"W", "[", "k", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
               ",", 
              RowBox[{
               RowBox[{"dired", "[", "k", "]"}], "=", 
               RowBox[{"Append", "[", 
                RowBox[{
                 RowBox[{"dired", "[", "k", "]"}], ",", 
                 RowBox[{"DirectedEdge", "[", 
                  RowBox[{"i", ",", "j"}], "]"}]}], "]"}]}]}], "]"}]}], 
           "]"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ineq", "[", "k", "]"}], "=", 
        RowBox[{
         RowBox[{"ineq", "[", "k", "]"}], "/.", 
         RowBox[{"List", "\[Rule]", "And"}]}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"ineq", "[", "k", "]"}], "]"}], "===", "0"}], ",", 
         RowBox[{
          RowBox[{"ineq", "[", "k", "]"}], "=", "True"}]}], "]"}]}], "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"zindex", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"irrep", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}], "===", "0"}], ",", 
         RowBox[{"zindex", "=", 
          RowBox[{"Append", "[", 
           RowBox[{"zindex", ",", "i"}], "]"}]}]}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"refl", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"constsign", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"const", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"pos", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"neg", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"zero", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"zerorep", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"l", "=", "1"}], ",", 
         RowBox[{"l", "\[LessEqual]", 
          RowBox[{"Length", "[", 
           RowBox[{"S", "[", 
            RowBox[{"zindex", "[", 
             RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], ",", 
         RowBox[{"l", "++"}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Map", "[", 
              RowBox[{"sgn", ",", 
               RowBox[{"S", "[", 
                RowBox[{"zindex", "[", 
                 RowBox[{"[", "k", "]"}], "]"}], "]"}]}], "]"}], "[", 
             RowBox[{"[", "l", "]"}], "]"}], "===", "1"}], ",", 
           RowBox[{"pos", "=", 
            RowBox[{"Append", "[", 
             RowBox[{"pos", ",", 
              RowBox[{
               SubscriptBox[
                RowBox[{"s", "[", 
                 RowBox[{"zindex", "[", 
                  RowBox[{"[", "k", "]"}], "]"}], "]"}], "l"], ">", "0"}]}], 
             "]"}]}]}], "]"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"l", "=", "1"}], ",", 
         RowBox[{"l", "\[LessEqual]", 
          RowBox[{"Length", "[", 
           RowBox[{"S", "[", 
            RowBox[{"zindex", "[", 
             RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], ",", 
         RowBox[{"l", "++"}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Map", "[", 
              RowBox[{"sgn", ",", 
               RowBox[{"S", "[", 
                RowBox[{"zindex", "[", 
                 RowBox[{"[", "k", "]"}], "]"}], "]"}]}], "]"}], "[", 
             RowBox[{"[", "l", "]"}], "]"}], "===", 
            RowBox[{"-", "1"}]}], ",", 
           RowBox[{"neg", "=", 
            RowBox[{"Append", "[", 
             RowBox[{"neg", ",", 
              RowBox[{
               SubscriptBox[
                RowBox[{"s", "[", 
                 RowBox[{"zindex", "[", 
                  RowBox[{"[", "k", "]"}], "]"}], "]"}], "l"], "<", "0"}]}], 
             "]"}]}]}], "]"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"l", "=", "1"}], ",", 
         RowBox[{"l", "\[LessEqual]", 
          RowBox[{"Length", "[", 
           RowBox[{"W", "[", 
            RowBox[{"zindex", "[", 
             RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], ",", 
         RowBox[{"l", "++"}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"W", "[", 
               RowBox[{"zindex", "[", 
                RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
              RowBox[{"[", "l", "]"}], "]"}], ".", 
             RowBox[{
              RowBox[{"W", "[", 
               RowBox[{"zindex", "[", 
                RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
              RowBox[{"[", "l", "]"}], "]"}]}], "===", "0"}], ",", 
           RowBox[{"zero", "=", 
            RowBox[{"Append", "[", 
             RowBox[{"zero", ",", 
              SubscriptBox[
               RowBox[{"s", "[", 
                RowBox[{"zindex", "[", 
                 RowBox[{"[", "k", "]"}], "]"}], "]"}], "l"]}], "]"}]}]}], 
          "]"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"j", "=", "1"}], ",", 
       RowBox[{"j", "\[LessEqual]", 
        RowBox[{"Length", "[", "zero", "]"}]}], ",", 
       RowBox[{"j", "++"}], ",", 
       RowBox[{"zerorep", "=", 
        RowBox[{"Append", "[", 
         RowBox[{"zerorep", ",", 
          RowBox[{
           RowBox[{"zero", "[", 
            RowBox[{"[", "j", "]"}], "]"}], "\[Rule]", "0"}]}], "]"}]}]}], 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"defsign", "=", 
      RowBox[{
       RowBox[{"Join", "[", 
        RowBox[{"pos", ",", "neg"}], "]"}], "/.", 
       RowBox[{"{", 
        RowBox[{"List", "\[Rule]", "And"}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"l", "=", "1"}], ",", 
         RowBox[{"l", "\[LessEqual]", 
          RowBox[{"Length", "[", "zindex", "]"}]}], ",", 
         RowBox[{"l", "++"}], ",", 
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", 
            RowBox[{"Length", "[", 
             RowBox[{"W", "[", 
              RowBox[{"zindex", "[", 
               RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], ",", 
           RowBox[{"i", "++"}], ",", 
           RowBox[{"For", "[", 
            RowBox[{
             RowBox[{"j", "=", "1"}], ",", 
             RowBox[{"j", "\[LessEqual]", 
              RowBox[{"Length", "[", 
               RowBox[{"W", "[", 
                RowBox[{"zindex", "[", 
                 RowBox[{"[", "l", "]"}], "]"}], "]"}], "]"}]}], ",", 
             RowBox[{"j", "++"}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Map", "[", 
                    RowBox[{"Abs", ",", 
                    RowBox[{"Flatten", "[", 
                    RowBox[{"Minors", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}], "}"}], ",", "2"}], 
                    "]"}], "]"}]}], "]"}], "/.", 
                   RowBox[{"List", "\[Rule]", "Plus"}]}], ")"}], "===", "0"}],
                 "&&", 
                RowBox[{
                 RowBox[{
                  RowBox[{"W", "[", 
                   RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "!=", 
                 RowBox[{
                  RowBox[{"W", "[", 
                   RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "j", "]"}], "]"}]}], "&&", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Map", "[", 
                    RowBox[{"Abs", ",", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], "/.", 
                   RowBox[{"List", "\[Rule]", "Plus"}]}], ")"}], "!=", "0"}], 
                "&&", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Map", "[", 
                    RowBox[{"Abs", ",", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}], "]"}], "/.", 
                   RowBox[{"List", "\[Rule]", "Plus"}]}], ")"}], "!=", 
                 "0"}]}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"refl", "=", 
                  RowBox[{"Append", "[", 
                   RowBox[{"refl", ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"w", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "i"], "\[Equal]", 
                    RowBox[{"a", " ", 
                    SubscriptBox[
                    RowBox[{"w", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "j"]}]}], "}"}], "/.", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Solve", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}]}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}], "]"}]}], ",", 
                 RowBox[{"constsign", "=", 
                  RowBox[{"Append", "[", 
                   RowBox[{"constsign", ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"s", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "i"], "\[Equal]", 
                    RowBox[{
                    RowBox[{"Sign", "[", "a", "]"}], 
                    SubscriptBox[
                    RowBox[{"s", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "j"]}]}], "}"}], "/.", 
                    RowBox[{
                    RowBox[{"Solve", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"a", " ", 
                    RowBox[{
                    RowBox[{"W", "[", 
                    RowBox[{"zindex", "[", 
                    RowBox[{"[", "l", "]"}], "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}]}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}]}], "]"}]}]}], "}"}]}], 
              "]"}]}], "]"}]}], "]"}]}], "]"}]}], "]"}], ";", " ", 
     "\[IndentingNewLine]", 
     RowBox[{"const", "=", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Flatten", "[", "refl", "]"}], "//", "Reduce"}], ")"}], "/.", 
        RowBox[{"{", 
         RowBox[{"And", "\[Rule]", "List"}], "}"}]}], ")"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"constsign", "=", 
      RowBox[{
       RowBox[{"Flatten", "[", "constsign", "]"}], "/.", 
       RowBox[{"{", 
        RowBox[{"List", "\[Rule]", "And"}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "constsign", "]"}], "===", "0"}], ",", 
       RowBox[{"constsign", "=", "True"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"indsign", "=", 
      RowBox[{"DeleteCases", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            SubscriptBox[
             RowBox[{"s", "[", "k", "]"}], "i"], ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", "1", ",", 
              RowBox[{"Length", "[", "irrep", "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "[", 
               RowBox[{"W", "[", "k", "]"}], "]"}]}], "}"}]}], "]"}], "//", 
          "Flatten"}], ")"}], ",", 
        RowBox[{"Apply", "[", 
         RowBox[{"Alternatives", ",", "zero"}], "]"}]}], "]"}]}], ";", " ", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"indsign", "=", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           SubscriptBox[
            RowBox[{"s", "[", "k", "]"}], "i"], ",", 
           RowBox[{"{", 
            RowBox[{"k", ",", "1", ",", 
             RowBox[{"Length", "[", "irrep", "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "[", 
              RowBox[{"W", "[", "k", "]"}], "]"}]}], "}"}]}], "]"}], "//", 
         "Flatten"}]}], ";"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"oversign", "[", "x_", "]"}], ":=", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{"Apply", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"indsign", "[", 
                 RowBox[{"[", "j", "]"}], "]"}], "\[Rule]", 
                RowBox[{
                 RowBox[{"2", 
                  SubscriptBox["i", "j"]}], "-", "1"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "1", ",", 
                 RowBox[{"Length", "[", "indsign", "]"}]}], "}"}]}], "]"}], 
             ",", "##"}], "]"}], "&"}], ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              SubscriptBox["i", "m"], ",", "0", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"m", ",", "1", ",", "x"}], "}"}]}], "]"}]}], "]"}], ",", 
        
        RowBox[{"x", "-", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"truth", "[", "x_", "]"}], ":=", 
      RowBox[{
       RowBox[{"Map", "[", 
        RowBox[{"Boole", ",", "x"}], "]"}], "/.", 
       RowBox[{"{", 
        RowBox[{"List", "\[Rule]", "Times"}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"dummysign", "=", 
      RowBox[{"oversign", "[", 
       RowBox[{"Length", "[", "indsign", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"fullineq", "=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"ineq", "[", "k", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"k", ",", "1", ",", 
             RowBox[{"Length", "[", "irrep", "]"}]}], "}"}]}], "]"}], "//", 
         "Flatten"}], ")"}], "/.", 
       RowBox[{"{", 
        RowBox[{"List", "\[Rule]", "And"}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"candsign", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"defsign", "&&", "constsign", "&&", "fullineq"}], " ", "/.", 
        "zerorep"}], "/.", "dummysign"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"truelist", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"i", "=", "1"}], ",", 
       RowBox[{"i", "\[LessEqual]", 
        RowBox[{"Length", "[", "candsign", "]"}]}], ",", 
       RowBox[{"i", "++"}], ",", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"candsign", "[", 
          RowBox[{"[", "i", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"truelist", "=", 
           RowBox[{"Append", "[", 
            RowBox[{"truelist", ",", "i"}], "]"}]}], "}"}]}], "]"}]}], "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"candsign", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"dummysign", "[", 
         RowBox[{"[", 
          RowBox[{"truelist", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"Length", "[", "truelist", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"j", "=", "1"}], ",", 
       RowBox[{"j", "\[LessEqual]", 
        RowBox[{"Length", "[", "irrep", "]"}]}], ",", 
       RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"k", "=", "1"}], ",", 
          RowBox[{"k", "\[LessEqual]", 
           RowBox[{"Length", "[", 
            RowBox[{
             RowBox[{"irrep", "[", 
              RowBox[{"[", "j", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ",", 
          RowBox[{"k", "++"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"tenslabel", "[", "j", "]"}], "[", "k", "]"}], "=", 
           RowBox[{"Table", "[", 
            RowBox[{"i", ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", 
               RowBox[{"Length", "[", 
                RowBox[{"WeightSystem", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"irrep", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], "}"}]}], 
            "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"newlabel", "[", "j", "]"}], "=", 
         RowBox[{"Tuples", "[", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"tenslabel", "[", "j", "]"}], "[", "k", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", "1", ",", 
              RowBox[{"Length", "[", 
               RowBox[{
                RowBox[{"irrep", "[", 
                 RowBox[{"[", "j", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
          "]"}]}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"truesign", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"xx", "=", "representation"}], ";", "\[IndentingNewLine]", 
     RowBox[{"p", ":=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"xx", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "3", "]"}], "]"}], "<", "3"}], ",", 
        RowBox[{
         RowBox[{"xx", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "[", 
         RowBox[{"[", "3", "]"}], "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"xx", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "3", "]"}], "]"}], "-", "2"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"k", "=", "1"}], ",", 
       RowBox[{"k", "\[LessEqual]", 
        RowBox[{"Length", "[", "truelist", "]"}]}], ",", 
       RowBox[{"k", "++"}], ",", 
       RowBox[{"truesign", "=", 
        RowBox[{"Append", "[", 
         RowBox[{"truesign", ",", 
          RowBox[{"dummysign", "[", 
           RowBox[{"[", 
            RowBox[{"truelist", "[", 
             RowBox[{"[", "k", "]"}], "]"}], "]"}], "]"}]}], "]"}]}]}], "]"}],
      ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"wtgrph", "[", "wtsgns___", "]"}], ":=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Graph", "[", 
         RowBox[{
          RowBox[{"dired", "[", "k", "]"}], ",", 
          RowBox[{"VertexSize", "\[Rule]", ".8"}], ",", 
          RowBox[{"VertexShape", "\[Rule]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"i", "\[Rule]", 
              RowBox[{"Style", "[", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"newlabel", "[", "k", "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "p", "]"}], "]"}], "\[Equal]", 
                    RowBox[{
                    RowBox[{
                    FractionBox["1", "2"], 
                    RowBox[{"Dim", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"xx", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "p", "]"}], "]"}], "]"}]}], "+", "1"}]}], 
                   ",", 
                   RowBox[{"Grid", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    SubscriptBox["v", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"newlabel", "[", "k", "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "  ", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"p", "\[Equal]", "1"}], ",", "2", ",", "1"}], 
                    "]"}], "  ", "]"}], "]"}]], "}"}], "}"}], ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}], ",", 
                   SubscriptBox["w", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"newlabel", "[", "k", "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "p", "]"}], "]"}], ">", 
                    RowBox[{
                    RowBox[{
                    FractionBox["1", "2"], 
                    RowBox[{"Dim", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"xx", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "p", "]"}], "]"}], "]"}]}], "+", "1"}]}], 
                    ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"newlabel", "[", "k", "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "-", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"p", "\[Equal]", "1"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], ",", 
                    RowBox[{
                    RowBox[{"newlabel", "[", "k", "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}]]}], "]"}], 
                 RowBox[{
                  RowBox[{"Style", "[", 
                   RowBox[{
                    SubscriptBox[
                    RowBox[{"s", "[", "k", "]"}], "i"], ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    SubscriptBox[
                    RowBox[{"s", "[", "k", "]"}], "i"], ">", "0"}], ",", 
                    RowBox[{"Darker", "[", "Cyan", "]"}], ",", "Red"}], "]"}],
                     ",", "Bold", ",", 
                    RowBox[{"FontSize", "\[Rule]", "14"}]}], "]"}], "/.", 
                  "wtsgns"}]], ",", "Blue", ",", "17", ",", "Bold"}], "]"}]}],
              ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", 
               RowBox[{"Length", "[", 
                RowBox[{"W", "[", "k", "]"}], "]"}]}], "}"}]}], "]"}]}], ",", 
          
          RowBox[{"PerformanceGoal", "\[Rule]", "\"\<Quality\>\""}], ",", 
          RowBox[{"EdgeStyle", "\[Rule]", 
           RowBox[{"Darker", "[", "Green", "]"}]}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "Medium"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", "1", ",", 
          RowBox[{"Length", "[", "irrep", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"xx", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "3"}], "\[Or]", 
        RowBox[{
         RowBox[{
          RowBox[{"xx", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "[", 
          RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "4"}]}], ",", 
       RowBox[{"Return", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"wtgrph", "[", 
             RowBox[{"truesign", "[", 
              RowBox[{"[", "j", "]"}], "]"}], "]"}], ",", 
            RowBox[{"truesign", "[", 
             RowBox[{"[", "j", "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "1", ",", 
            RowBox[{"Length", "[", "truesign", "]"}]}], "}"}]}], "]"}], 
        "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"p1", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"p", "\[Equal]", "1"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             FractionBox["1", "2"], 
             RowBox[{"Dim", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"xx", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "[", 
               RowBox[{"[", "p", "]"}], "]"}], "]"}]}], "+", "1"}], ")"}], 
          RowBox[{"(", 
           RowBox[{"Dim", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"xx", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"p", "\[Equal]", "1"}], ",", "2", ",", "1"}], "]"}], 
              " ", "]"}], "]"}], "]"}], ")"}]}], "+", "1", "-", 
         RowBox[{"Dim", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"xx", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}], "[", 
           RowBox[{"[", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"p", "\[Equal]", "1"}], ",", "2", ",", "1"}], "]"}], 
            " ", "]"}], "]"}], "]"}]}], ",", 
        RowBox[{
         RowBox[{
          FractionBox["1", "2"], 
          RowBox[{"Dim", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"xx", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "[", 
            RowBox[{"[", "p", "]"}], "]"}], "]"}]}], "+", "1"}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"p2", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"p", "\[Equal]", "1"}], ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            FractionBox["1", "2"], 
            RowBox[{"Dim", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"xx", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "[", 
              RowBox[{"[", "p", "]"}], "]"}], "]"}]}], "+", "1"}], ")"}], 
         RowBox[{"(", 
          RowBox[{"Dim", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"xx", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"p", "\[Equal]", "1"}], ",", "2", ",", "1"}], "]"}], 
             " ", "]"}], "]"}], "]"}], ")"}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Dim", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"xx", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", "1"}], ")"}], 
          RowBox[{"Dim", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"xx", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "+", 
         RowBox[{
          FractionBox["1", "2"], 
          RowBox[{"Dim", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"xx", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "[", 
            RowBox[{"[", "p", "]"}], "]"}], "]"}]}], "+", "1"}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"truesigns2", "=", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         SubscriptBox[
          RowBox[{"s", "[", "1", "]"}], "i"], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", 
            RowBox[{"truesign", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], "/.", 
       "truesign"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"truesigns3", "=", 
      RowBox[{"DeleteCases", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"truesigns2", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"p", "\[Equal]", "1"}], ",", 
                 RowBox[{
                  FractionBox[
                   RowBox[{"p2", "-", "p1", "+", "1"}], "2"], "+", "1", "+", 
                  "p1", "-", "1"}], ",", 
                 RowBox[{
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    FractionBox["1", "2"], 
                    RowBox[{"Dim", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"xx", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "p", "]"}], "]"}], "]"}]}], "+", "1", "+", 
                    RowBox[{"k", " ", 
                    RowBox[{"Dim", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"xx", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}]}], " ", ",", 
                    RowBox[{"{", 
                    RowBox[{"k", ",", "0", ",", 
                    RowBox[{
                    RowBox[{"Dim", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"xx", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", "1"}]}], 
                    "}"}]}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{
                    FractionBox["1", "2"], 
                    RowBox[{"Dim", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"xx", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "+", "1"}], 
                   "]"}], "]"}]}], "]"}], "]"}], "]"}], "<", 
             RowBox[{
              RowBox[{"truesigns2", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"p", "\[Equal]", "1"}], ",", 
                 RowBox[{
                  FractionBox[
                   RowBox[{"p2", "-", "p1", "+", "1"}], "2"], "+", "p1", "-", 
                  "1"}], ",", 
                 RowBox[{
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    FractionBox["1", "2"], 
                    RowBox[{"Dim", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"xx", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "p", "]"}], "]"}], "]"}]}], "+", "1", "+", 
                    RowBox[{"k", " ", 
                    RowBox[{"Dim", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"xx", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}]}], " ", ",", 
                    RowBox[{"{", 
                    RowBox[{"k", ",", "0", ",", 
                    RowBox[{
                    RowBox[{"Dim", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"xx", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", "1"}]}], 
                    "}"}]}], "]"}], "[", 
                  RowBox[{"[", 
                   RowBox[{
                    FractionBox["1", "2"], 
                    RowBox[{"Dim", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"xx", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], "]"}]}], 
                "]"}], "]"}], "]"}]}], ",", 
            RowBox[{"truesigns2", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", "truesigns2", "]"}]}], "}"}]}], "]"}], ",",
         "Null"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"truesigns", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           SubscriptBox[
            RowBox[{"s", "[", "1", "]"}], "i"], "\[Rule]", 
           RowBox[{
            RowBox[{"truesigns3", "[", 
             RowBox[{"[", "j", "]"}], "]"}], "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"truesigns3", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "1", ",", 
          RowBox[{"Length", "[", "truesigns3", "]"}]}], "}"}]}], "]"}]}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"Return", "[", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"wtgrph", "[", 
           RowBox[{"truesigns", "[", 
            RowBox[{"[", "j", "]"}], "]"}], "]"}], ",", 
          RowBox[{"truesigns", "[", 
           RowBox[{"[", "j", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "1", ",", 
          RowBox[{"Length", "[", "truesigns", "]"}]}], "}"}]}], "]"}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Signs2KK", "[", "l_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "f", "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"f", "[", "1", "]"}], "=", 
      RowBox[{
       RowBox[{"f", "[", "2", "]"}], "=", "1"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"x", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"l", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
         
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{
            RowBox[{"l", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], "  ", "]"}], ">", "0"}], "&&", 
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"l", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Loop"}], "]"}]}], 
        ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ReplacePart", "[", 
           RowBox[{
            RowBox[{"l", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "1"}]}], "]"}], ",", 
          
          RowBox[{"l", "[", 
           RowBox[{"[", "2", "]"}], "]"}], ",", 
          RowBox[{"l", "[", 
           RowBox[{"[", "3", "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"l", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"l", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], " ", "]"}], ">", "0"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"l", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Loop"}], "]"}]}], 
          ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"ReplacePart", "[", 
             RowBox[{
              RowBox[{"l", "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "1"}]}], "]"}], 
            ",", 
            RowBox[{"l", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", 
            RowBox[{"l", "[", 
             RowBox[{"[", "3", "]"}], "]"}]}], "}"}], ",", "l"}], "]"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"\[CapitalOmega]", "=", 
      RowBox[{"x", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"x", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"x", "[", 
              RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"Allowed6d1", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Length", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "2"}], 
                ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
              RowBox[{
               RowBox[{"\[CapitalOmega]", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}], "\[Equal]", 
           "1"}], " ", "&&", 
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"Allowed6d1", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Length", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "2"}], 
                ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
              RowBox[{
               RowBox[{"\[CapitalOmega]", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}], "\[Equal]", 
           "1"}]}], ")"}], "\[Or]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"x", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"Allowed6d1", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Length", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "2"}], 
                ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
              RowBox[{
               RowBox[{"\[CapitalOmega]", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}], "\[Equal]", 
           "1"}]}], " ", ")"}], "\[Or]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"x", "[", 
              RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
          RowBox[{
           RowBox[{"Length", "[", 
            RowBox[{"Allowed6d1", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Length", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "2"}], 
                ",", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
              RowBox[{
               RowBox[{"\[CapitalOmega]", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}], "\[Equal]", 
           "1"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"AlgebraClass", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "A"}], 
              "]"}], "&&", 
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"AlgebraClass", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "G2"}], 
              "]"}], "&&", 
             RowBox[{
              RowBox[{"Rank", "[", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], ">=", "2"}], "&&", 
             RowBox[{
              RowBox[{
               RowBox[{"\[CapitalOmega]", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "1"}]}], ")"}]}], 
          ",", 
          RowBox[{"Return", "[", "\"\<There is no such Theory \>\"", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"AlgebraClass", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "A"}], 
              "]"}], "&&", 
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"AlgebraClass", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "G2"}], 
              "]"}], "&&", 
             RowBox[{
              RowBox[{"Rank", "[", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], ">=", "2"}], "&&", 
             RowBox[{
              RowBox[{
               RowBox[{"\[CapitalOmega]", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "1"}]}], ")"}]}], 
          ",", 
          RowBox[{"Return", "[", "\"\<There is no such Theory \>\"", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"x", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], "]"}], "&&", 
           
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"x", "[", 
              RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "0"}], "]"}]}], ",", 
          RowBox[{
          "Return", "[", 
           "\"\<This code does not do those, check the paper\>\"", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"x", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], "]"}], "&&", 
           
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"Allowed6dEmpty", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}], "\[Equal]", 
              "0"}], "\[Or]", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"Allowed6d1", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}], "\[Equal]", 
              "0"}]}], ")"}]}], ",", 
          RowBox[{"Return", "[", "\"\<There is no such Theory\>\"", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"x", "[", 
              RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "0"}], "]"}], "&&", 
           
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"Allowed6dEmpty", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}], "\[Equal]", 
              "0"}], "\[Or]", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"Allowed6d1", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}], "\[Equal]", 
              "0"}]}], ")"}]}], ",", 
          RowBox[{"Return", "[", "\"\<There is no such Theory \>\"", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "==", 
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"Allowed6d2", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "==", 
                    RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "&&", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"-", "2"}]}]}], ",", "2", ",", "1"}], "]"}], ",", 
                 "\[CapitalOmega]"}], "]"}], "]"}], "\[Equal]", "0"}], "&&", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"Allowed6d2", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "==", 
                    RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "&&", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
                    RowBox[{"-", "2"}]}]}], ",", "2", ",", "1"}], "]"}], ",", 
                 "\[CapitalOmega]"}], "]"}], "]"}], "\[Equal]", "0"}]}], 
            ")"}]}], "\[IndentingNewLine]", ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "2"}], "&&", 
           
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "S"}], "]"}], "&&", 
           
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"UnsameQ", "[", 
                RowBox[{
                 RowBox[{"AlgebraClass", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "D"}], "]"}], 
               "\[Or]", " ", 
               RowBox[{
                RowBox[{"Rank", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[NotEqual]", 
                "4"}]}], ")"}], "&&", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"UnsameQ", "[", 
                RowBox[{
                 RowBox[{"AlgebraClass", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "B"}], "]"}], 
               "\[Or]", " ", 
               RowBox[{
                RowBox[{"Rank", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[NotEqual]", 
                "3"}]}], ")"}]}], ")"}]}], ",", 
          RowBox[{"Return", "[", "\"\<There is no such Theory \>\"", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "2"}], "&&", 
           
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "S"}], "]"}], "&&", 
           
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"UnsameQ", "[", 
                RowBox[{
                 RowBox[{"AlgebraClass", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "D"}], "]"}], 
               "\[Or]", " ", 
               RowBox[{
                RowBox[{"Rank", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}], "!=", "4"}]}], ")"}],
              "&&", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"UnsameQ", "[", 
                RowBox[{
                 RowBox[{"AlgebraClass", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "B"}], "]"}], 
               "\[Or]", " ", 
               RowBox[{
                RowBox[{"Rank", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[NotEqual]", 
                "3"}]}], ")"}]}], ")"}]}], ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "!=", 
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"TrueQ", "[", 
                RowBox[{
                 RowBox[{"AlgebraClass", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], "==", "D"}], "]"}], 
               "&&", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"\[CapitalOmega]", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "2"}]}], ")"}], 
             " ", "\[Or]", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"TrueQ", "[", 
                RowBox[{
                 RowBox[{"AlgebraClass", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], "==", "D"}], "]"}], 
               "&&", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"\[CapitalOmega]", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "2"}]}], ")"}]}],
             " ", ")"}]}], ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "0"}], "&&", 
           " ", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"AlgebraClass", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], "==", "B"}], "]"}], "&&",
            " ", 
           RowBox[{
            RowBox[{"Rank", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], "]"}], "==", "3"}], "&&", 
           RowBox[{
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "3"}]}], ",", 
          RowBox[{
          "Return", "[", 
           "\"\<There is no such Theory. Try replacing U->{U,S} for B3 to \
specify (F\[CircleTimes]S) \>\"", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "0"}], "&&", 
           " ", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"AlgebraClass", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], "==", "B"}], "]"}], "&&",
            " ", 
           RowBox[{
            RowBox[{"Rank", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], "]"}], "==", "3"}], "&&", 
           RowBox[{
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "3"}]}], ",", 
          RowBox[{
          "Return", "[", 
           "\"\<There is no such Theory. Try replacing U->{U,S} for B3 to \
specify (F\[CircleTimes]S) \>\"", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "2"}], "&&", 
           
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Loop"}], "]"}], "&&", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "2"}], "&&", 
           
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Loop"}], "]"}]}], 
          ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], "]"}], "&&", 
           RowBox[{"UnsameQ", "[", 
            RowBox[{
             RowBox[{"AlgebraClass", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "D"}], "]"}], "&&", 
           RowBox[{"UnsameQ", "[", 
            RowBox[{
             RowBox[{"AlgebraClass", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "B"}], "]"}]}], 
          ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], "]"}], "&&", 
           RowBox[{"UnsameQ", "[", 
            RowBox[{
             RowBox[{"AlgebraClass", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "D"}], "]"}], "&&", 
           RowBox[{"UnsameQ", "[", 
            RowBox[{
             RowBox[{"AlgebraClass", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", "B"}], "]"}]}], 
          ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
            RowBox[{
             RowBox[{
              RowBox[{"\[CapitalOmega]", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
             RowBox[{"-", "2"}]}], "&&", 
            RowBox[{
             RowBox[{
              RowBox[{"\[CapitalOmega]", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
             RowBox[{"-", "2"}]}], "&&", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "\[NotEqual]", "2"}], " ", 
              "\[Or]", " ", 
              RowBox[{
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "\[NotEqual]", "4"}]}], ")"}],
             "&&", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], "\[NotEqual]", "2"}], " ", 
              "\[Or]", " ", 
              RowBox[{
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], "\[NotEqual]", "4"}]}], 
             ")"}]}], "\[Or]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"Length", "[", 
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"Length", "[", 
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"AlgebraClass", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "!=", "A"}], "]"}], "&&", 
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"AlgebraClass", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[NotEqual]", "D"}], 
              "]"}]}], ")"}], "\[Or]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"Length", "[", 
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"Length", "[", 
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"AlgebraClass", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[NotEqual]", "A"}], 
              "]"}], "&&", 
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"AlgebraClass", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[NotEqual]", "D"}], 
              "]"}]}], ")"}]}], ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "\[NotEqual]", 
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "&&", " ", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"Allowed6d2Base", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", "\[CapitalOmega]"}], 
              "]"}], "]"}], "==", "0"}], " ", "&&", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"Allowed6d2Base", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "}"}]}], "]"}],
              "]"}], "==", "0"}]}], ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "==", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "\[NotEqual]", 
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "&&", " ", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"Allowed6dEmptyBase", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", "\[CapitalOmega]"}], 
              "]"}], "]"}], "==", "0"}]}], " ", ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "]"}], "==", "0"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
           RowBox[{
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "\[NotEqual]", 
            RowBox[{
             RowBox[{"\[CapitalOmega]", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "&&", " ", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"Allowed6dEmptyBase", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], "}"}]}], "]"}],
              "]"}], "==", "0"}]}], " ", ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory \>\"", "]"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"Length", "[", 
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "0"}], 
              "]"}], "&&", 
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"AlgebraClass", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
              "]"}], "&&", 
             RowBox[{
              RowBox[{"Rank", "[", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "8"}]}], 
            ")"}], "\[Or]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"Length", "[", 
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "]"}], "\[Equal]", "0"}], 
              "]"}], "&&", 
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"AlgebraClass", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
              "]"}], "&&", 
             RowBox[{
              RowBox[{"Rank", "[", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "8"}]}], 
            ")"}]}], ",", 
          RowBox[{"Return", "[", "\"\<There is no such  Theory\>\"", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Mat2", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"TrueQ", "[", 
            RowBox[{
             RowBox[{"x", "[", 
              RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "0"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"TotalMatter", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", "0"}], "}"}], 
           ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"TrueQ", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"TotalMatter", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"MassGauging", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "==", 
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "&&", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
                   RowBox[{"-", "2"}]}]}], ",", "2", ",", "1"}], "]"}], ",", 
               "\[CapitalOmega]"}], "]"}]}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], "]"}]}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"zeros1", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"Mat2", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[NotEqual]", "0"}], 
           ",", 
           RowBox[{"DeleteCases", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"Mat2", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "n"}], "}"}], ",", "0"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", "1", ",", 
                 RowBox[{"Length", "[", 
                  RowBox[{"Mat2", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
             ",", "0"}], "]"}], ",", 
           RowBox[{"{", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"zeros2", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"Mat2", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[NotEqual]", "0"}], 
           ",", 
           RowBox[{"DeleteCases", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"Mat2", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"2", ",", "n"}], "}"}], ",", "0"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", "1", ",", 
                 RowBox[{"Length", "[", 
                  RowBox[{"Mat2", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
             ",", "0"}], "]"}], ",", 
           RowBox[{"{", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Mat", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"AlgebraClass", "[", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
             "]"}], "&&", 
            RowBox[{
             RowBox[{"Rank", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "4"}], "&&", 
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], "]"}], "&&", 
            RowBox[{
             RowBox[{
              RowBox[{"\[CapitalOmega]", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], "<", 
             RowBox[{
              RowBox[{"\[CapitalOmega]", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}]}]}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"2", ",", "6"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", 
                 FractionBox["1", "2"]}], "}"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", "1"}], "}"}], 
              "}"}]}], "}"}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{"Length", "[", 
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{"Length", "[", 
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "]"}], "!=", "0"}], "]"}], "&&", 
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{"AlgebraClass", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
               "]"}], "&&", 
              RowBox[{
               RowBox[{"Rank", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "4"}], "&&", 
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], "]"}], "&&", 
              RowBox[{
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ">", 
               RowBox[{
                RowBox[{"\[CapitalOmega]", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}]}]}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", "1"}], 
                 "}"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"2", ",", "6"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"2", ",", 
                   FractionBox["1", "2"]}], "}"}]}], "}"}]}], "}"}], ",", 
             RowBox[{
              RowBox[{"Delete", "[", 
               RowBox[{"Mat2", ",", 
                RowBox[{"Flatten", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"zeros1", ",", "zeros2"}], "}"}], ",", "1"}], 
                 "]"}]}], "]"}], "/.", 
              RowBox[{
               RowBox[{"{", "}"}], "\[Rule]", "0"}]}]}], "]"}]}], "]"}]}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"BiMat", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], "]"}], 
            "\[Or]", 
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", "0"}], "]"}]}], 
           ",", "0", ",", 
           RowBox[{"TotalBi", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"LB", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             RowBox[{
              RowBox[{"\[CapitalOmega]", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"[", "3", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", 
             RowBox[{"LB", "[", 
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
             RowBox[{
              RowBox[{"\[CapitalOmega]", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "2", "]"}], "]"}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "==", 
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], "&&", 
                RowBox[{
                 RowBox[{
                  RowBox[{"\[CapitalOmega]", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
                 RowBox[{"-", "2"}]}]}], ",", "2", ",", "1"}], "]"}]}], 
            "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"Poscheck", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"Mat", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "i", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"Length", "[", 
                 RowBox[{"Mat", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
            ",", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"Mat", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "[", 
                RowBox[{"[", "i", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"Length", "[", 
                 RowBox[{"Mat", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}], 
           "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", 
           RowBox[{"Length", "[", "Poscheck", "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Poscheck", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "<", "0"}], ",", 
            RowBox[{"Return", "[", 
             RowBox[{"Print", "[", "\"\<Theres is no such Theory \>\"", "]"}],
              "]"}]}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"tup", "=", 
         RowBox[{"Tuples", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{"i", ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"TrueQ", "[", 
                    RowBox[{
                    RowBox[{"AlgebraClass", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
                    "]"}], "&&", 
                   RowBox[{"TrueQ", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], 
                    "]"}]}], ",", 
                  RowBox[{
                   RowBox[{"Dim", "[", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "]"}], 
                   "+", "1"}], ",", 
                  RowBox[{"Dim", "[", 
                   RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "]"}]}],
                  "]"}]}], "}"}]}], "]"}], ",", 
            RowBox[{"Table", "[", 
             RowBox[{"i", ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"TrueQ", "[", 
                    RowBox[{
                    RowBox[{"AlgebraClass", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
                    "]"}], "&&", 
                   RowBox[{"TrueQ", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], 
                    "]"}]}], ",", 
                  RowBox[{
                   RowBox[{"Dim", "[", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "]"}], 
                   "+", "1"}], ",", 
                  RowBox[{"Dim", "[", 
                   RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "]"}]}],
                  "]"}]}], "}"}]}], "]"}]}], "}"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"tup2", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"AlgebraClass", "[", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
             "]"}], "&&", 
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], "]"}]}], 
           ",", 
           RowBox[{"ReplacePart", "[", 
            RowBox[{
             RowBox[{"ReplacePart", "[", 
              RowBox[{"tup", ",", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Rank", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "+", "1"}], ")"}], 
                   "+", 
                   RowBox[{"i", " ", "2", " ", 
                    RowBox[{"Rank", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}]}], "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"1", "+", "i"}], ",", "1"}], "}"}]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", "0", ",", " ", 
                   RowBox[{
                    RowBox[{"FundamentalRepDim", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", "1"}]}], " ", 
                  "}"}]}], "]"}]}], "]"}], ",", 
             RowBox[{"Flatten", "[", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"i", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"tup", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"tup", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", "1"}]}], "}"}]}], 
                  ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Rank", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "+", "1"}], ")"}], 
                    "+", 
                    RowBox[{"j", " ", "2", " ", 
                    RowBox[{"Rank", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "+", "1"}], ",", 
                    
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"j", "+", "1"}], ")"}], " ", "2", " ", 
                    RowBox[{"Rank", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}]}], "}"}]}], "]"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"j", ",", "0", ",", 
                  RowBox[{
                   RowBox[{"FundamentalRepDim", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", "1"}]}], " ", 
                 "}"}]}], "]"}], "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{"AlgebraClass", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
               "]"}], "&&", 
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], "]"}]}], 
             ",", 
             RowBox[{"ReplacePart", "[", 
              RowBox[{
               RowBox[{"ReplacePart", "[", 
                RowBox[{"tup", ",", 
                 RowBox[{"Table", "[", " ", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"FundamentalRepDim", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Rank", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "+", "1"}], 
                    ")"}]}], "+", "1", "+", "i", "-", " ", 
                    RowBox[{"FundamentalRepDim", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"i", "+", "1"}], ",", "2"}], "}"}]}], ",", 
                   RowBox[{"{", 
                    RowBox[{"i", ",", "0", ",", 
                    RowBox[{
                    RowBox[{"FundamentalRepDim", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", "1"}]}], 
                    "}"}]}], "]"}]}], "]"}], ",", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"i", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"tup", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", "1"}], ",", 
                    RowBox[{
                    RowBox[{"tup", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"FundamentalRepDim", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Rank", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "+", "1"}], 
                    ")"}]}], "+", "1"}], ",", 
                   RowBox[{"Length", "[", "tup", "]"}]}], "}"}]}], "]"}]}], 
              "]"}], ",", "tup"}], "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"x", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], "]"}], ",", 
          "0", ",", 
          RowBox[{"Do", "[", 
           RowBox[{
            RowBox[{"Print", "[", 
             RowBox[{"\"\<Algebra 1 is  \>\"", ",", 
              RowBox[{"Which", "[", 
               RowBox[{
                RowBox[{"TrueQ", "[", 
                 RowBox[{
                  RowBox[{"TT", "[", 
                   RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "==", "U"}], "]"}],
                 ",", 
                RowBox[{"Style", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{"FontColor", "\[Rule]", 
                   RowBox[{"Darker", "[", "Green", "]"}]}], ",", "Bold"}], 
                 "]"}], ",", 
                RowBox[{"TrueQ", "[", 
                 RowBox[{
                  RowBox[{"TT", "[", 
                   RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "T2"}],
                  "]"}], ",", 
                RowBox[{"Style", "[", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "2"], ",", 
                  RowBox[{"FontColor", "\[Rule]", 
                   RowBox[{"Darker", "[", "Green", "]"}]}], ",", "Bold"}], 
                 "]"}], ",", 
                RowBox[{"TrueQ", "[", 
                 RowBox[{
                  RowBox[{"TT", "[", 
                   RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "T3"}],
                  "]"}], ",", 
                RowBox[{"Style", "[", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "3"], ",", 
                  RowBox[{"FontColor", "\[Rule]", 
                   RowBox[{"Darker", "[", "Green", "]"}]}], ",", "Bold"}], 
                 "]"}]}], "]"}], ",", "\"\< with matter \>\"", ",", 
              RowBox[{"Style", "[", 
               RowBox[{"n", ",", 
                RowBox[{"FontColor", "\[Rule]", 
                 RowBox[{"Darker", "[", "Magenta", "]"}]}], ",", "Bold"}], 
               "]"}], ",", "\"\< of Highest Weight: \>\"", ",", 
              RowBox[{"HighestWeight", "[", 
               RowBox[{"irrep2", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"Mat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                   RowBox[{"[", "n", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{"AT", "[", 
                  RowBox[{
                   RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "]"}], 
              ",", "\"\<  and  N=\>\"", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"Mat", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "n", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", 
              "\"\<     Hasse Diagram =\>\"", ",", 
              RowBox[{"Row", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"weight", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "}"}], 
                    ",", "0"}], "}"}], "}"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"weight", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "}"}], 
                    ",", "0"}], "}"}], "}"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/.", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", "}"}], "\[Rule]", "\"\< \>\""}], "}"}]}], "//",
                   "MatrixForm"}]}], "}"}], "]"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", "1", ",", 
              RowBox[{"Length", "[", 
               RowBox[{"Mat", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"Do", "[", 
         RowBox[{
          RowBox[{"Print", "[", 
           RowBox[{"\"\<Algebra 2 is  \>\"", ",", 
            RowBox[{"Which", "[", 
             RowBox[{
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{"TT", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "]"}], "==", "U"}], "]"}], 
              ",", 
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"FontColor", "\[Rule]", "Red"}], ",", "Bold"}], "]"}],
               ",", 
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{"TT", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "T2"}], 
               "]"}], ",", 
              RowBox[{"Style", "[", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "2"], ",", 
                RowBox[{"FontColor", "\[Rule]", "Red"}], ",", "Bold"}], "]"}],
               ",", 
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{"TT", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", "T3"}], 
               "]"}], ",", 
              RowBox[{"Style", "[", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "3"], ",", 
                RowBox[{"FontColor", "\[Rule]", "Red"}], ",", "Bold"}], 
               "]"}]}], "]"}], ",", "\"\< with matter \>\"", ",", 
            RowBox[{"Style", "[", 
             RowBox[{"n", ",", 
              RowBox[{"FontColor", "\[Rule]", 
               RowBox[{"Darker", "[", "Magenta", "]"}]}], ",", "Bold"}], 
             "]"}], ",", "\"\< of Highest Weight: \>\"", ",", 
            RowBox[{"HighestWeight", "[", 
             RowBox[{"irrep2", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"Mat", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "n", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
               RowBox[{"AT", "[", 
                RowBox[{
                 RowBox[{"TT", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "]"}], 
            ",", "\"\<  and  N=\>\"", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"Mat", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "[", 
              RowBox[{"[", "n", "]"}], "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", 
            "\"\<     Hasse Diagram =\>\"", ",", 
            RowBox[{"Row", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"weight", "[", 
                  RowBox[{"{", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "  ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "}"}], 
                    ",", "0"}], "}"}], "}"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"weight", "[", 
                   RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "  ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "}"}], 
                    ",", "0"}], "}"}], "}"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "/.", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", "}"}], "\[Rule]", "\"\< \>\""}], "}"}]}], "//",
                 "MatrixForm"}]}], "}"}], "]"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "1", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"Mat", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"x", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "0"}], "]"}], ",", 
          "0", ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<\!\(\*SubscriptBox[\(R\), \(1\)]\)\!\(\(TraditionalForm\`\
\[TensorProduct]\)\)\!\(\*SubscriptBox[\(R\), \(2\)]\) Tensor Representation \
\>\"", ",", 
            RowBox[{"HighestWeight", "[", 
             RowBox[{"irrep2", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"BiMat", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
               RowBox[{"AT", "[", 
                RowBox[{
                 RowBox[{"TT", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "]"}], 
            ",", "\"\<\[TensorProduct]\>\"", ",", 
            RowBox[{"HighestWeight", "[", 
             RowBox[{"irrep2", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"BiMat", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", " ", 
               RowBox[{"AT", "[", 
                RowBox[{
                 RowBox[{"TT", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "]"}], 
            ",", "\"\<with Hasse Diagrams\>\"", ",", 
            RowBox[{"Row", "[", 
             RowBox[{"{", " ", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"TrueQ", "[", 
                   RowBox[{
                    RowBox[{"AlgebraClass", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
                   "]"}], "&&", 
                  RowBox[{"TrueQ", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], 
                   "]"}]}], ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"weight3", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", " ", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{"Flatten", "[", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{
                    RowBox[{"Rank", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", "1"}]}], 
                    "}"}]}], "]"}]}], "}"}], "]"}], ",", 
                    RowBox[{"AlgebraClass", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}]}], "}"}], 
                    ",", "0", ",", "2"}], "}"}], "}"}], " ", "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "\[IndentingNewLine]", 
                 "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"TrueQ", "[", 
                    RowBox[{
                    RowBox[{"AlgebraClass", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
                    "]"}], "&&", 
                    RowBox[{"TrueQ", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], 
                    "]"}]}], ",", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"weight3", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{"Flatten", "[", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{
                    RowBox[{"Rank", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", "1"}]}], 
                    "}"}]}], "]"}]}], "}"}], "]"}], ",", 
                    RowBox[{"AlgebraClass", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", " ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", " ", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}]}], "}"}],
                     ",", "0", ",", "1"}], "}"}], "}"}], " ", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"weight", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "  ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], " ", "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", " ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", " ", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}]}], "}"}],
                     ",", "0"}], "}"}], "}"}], " ", "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "     ", "]"}],
                ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"TrueQ", "[", 
                    RowBox[{
                    RowBox[{"AlgebraClass", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
                    "]"}], "&&", 
                    RowBox[{"TrueQ", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], 
                    "]"}]}], ",", 
                   RowBox[{
                    RowBox[{"weight3", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", " ", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{"Flatten", "[", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{
                    RowBox[{"Rank", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", "1"}]}], 
                    "}"}]}], "]"}]}], "}"}], "]"}], ",", 
                    RowBox[{"AlgebraClass", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}]}], "}"}], 
                    ",", "0", ",", "2"}], "}"}], "}"}], " ", "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"TrueQ", "[", 
                    RowBox[{
                    RowBox[{"AlgebraClass", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
                    "]"}], "&&", 
                    RowBox[{"TrueQ", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], 
                    "]"}]}], ",", 
                    RowBox[{
                    RowBox[{"weight3", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{"Flatten", "[", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{
                    RowBox[{"Rank", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", "1"}]}], 
                    "}"}]}], "]"}]}], "}"}], "]"}], ",", 
                    RowBox[{"AlgebraClass", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", " ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", " ", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}]}], "}"}],
                     ",", "0", ",", "1"}], "}"}], "}"}], " ", "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"weight", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "  ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], " ", "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", " ", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", " ", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}]}], "}"}],
                     ",", "0"}], "}"}], "}"}], " ", "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], "]"}], "/.", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", "}"}], "\[Rule]", "\"\< \>\""}], "}"}]}], "//",
                 "MatrixForm"}]}], "}"}], "     ", "]"}]}], " ", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"posi", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"AlgebraClass", "[", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
             "]"}], "&&", 
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], "]"}]}], 
           ",", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Rank", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}], "+", "1"}], ")"}], 
              "+", 
              RowBox[{"i", " ", "2", " ", 
               RowBox[{"Rank", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}]}]}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "0", ",", 
               RowBox[{
                RowBox[{"2", " ", 
                 RowBox[{"Rank", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "-", "1"}]}], " ",
               "}"}]}], "]"}], ",", 
           RowBox[{"Table", "[", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"2", 
               RowBox[{"Rank", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Rank", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], "+", "1"}], ")"}]}],
               "+", "1", "+", "i", "-", " ", 
              RowBox[{"2", 
               RowBox[{"Rank", "[", 
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}]}]}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "0", ",", 
               RowBox[{
                RowBox[{"2", 
                 RowBox[{"Rank", "[", 
                  RowBox[{
                   RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "-", "1"}]}], 
              "}"}]}], "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"s1", "=", 
         RowBox[{
          RowBox[{"signsgraph", "[", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"irrep2", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{"AT", "[", 
                   RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "}"}], 
               ",", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
                  FractionBox["1", "2"]}], ",", "0", ",", "1"}], "]"}]}], 
              "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "1", ",", 
               RowBox[{"Length", "[", 
                RowBox[{"Mat", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
           "]"}], "/.", 
          RowBox[{"Flatten", "[", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{
                SubscriptBox[
                 RowBox[{"s", "[", "n", "]"}], "i"], "->", 
                SubscriptBox[
                 RowBox[{"s", "[", "n", "]"}], 
                 RowBox[{"i", ",", "1"}]]}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"Dim", "[", 
                  RowBox[{"irrep2", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "]"}]}],
                 "}"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "1", ",", 
               RowBox[{"Length", "[", 
                RowBox[{"Mat", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
           "]"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"s2", "=", 
         RowBox[{
          RowBox[{"signsgraph", "[", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"irrep2", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{"AT", "[", 
                   RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "}"}], 
               ",", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
                  FractionBox["1", "2"]}], ",", "0", ",", "1"}], "]"}]}], 
              "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "1", ",", 
               RowBox[{"Length", "[", 
                RowBox[{"Mat", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
           "]"}], "/.", 
          RowBox[{"Flatten", "[", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{
                SubscriptBox[
                 RowBox[{"s", "[", "n", "]"}], "i"], "->", 
                SubscriptBox[
                 RowBox[{"s", "[", "n", "]"}], 
                 RowBox[{"i", ",", "2"}]]}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"Dim", "[", 
                  RowBox[{"irrep2", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"Mat", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "n", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], "]"}]}],
                 "}"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "1", ",", 
               RowBox[{"Length", "[", 
                RowBox[{"Mat", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
           "]"}]}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"s3", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"AlgebraClass", "[", 
               RowBox[{
                RowBox[{"x", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
             "]"}], "&&", 
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"x", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], "]"}]}], 
           ",", 
           RowBox[{
            RowBox[{"signsgraph3", "[", 
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"irrep2", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
                  RowBox[{"irrep2", "[", 
                   RowBox[{
                    RowBox[{"Flatten", "[", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{
                    RowBox[{"Rank", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", "1"}]}], 
                    "}"}]}], "]"}]}], "}"}], "]"}], ",", 
                    RowBox[{"AlgebraClass", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}]}], "}"}], 
                ",", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", 
                   FractionBox["1", "2"]}], ",", "0", ",", "0"}], "]"}], ",", 
                " ", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "2"}], ",", 
                  "4", ",", "2"}], "]"}]}], "}"}], "}"}], "]"}], "/.", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               SubscriptBox[
                RowBox[{"s", "[", "1", "]"}], "i"], "\[Rule]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"MemberQ", "[", 
                  RowBox[{"posi", ",", "i"}], "]"}], ",", 
                 SubscriptBox[
                  RowBox[{"s", "[", "1", "]"}], 
                  RowBox[{
                   RowBox[{
                    RowBox[{"tup2", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"tup2", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}]], ",", 
                 SubscriptBox[
                  RowBox[{"b", "[", "1", "]"}], 
                  RowBox[{
                   RowBox[{
                    RowBox[{"tup2", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"tup2", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}]]}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"Length", "[", "tup2", "]"}]}], "}"}]}], "]"}]}], ",", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{"AlgebraClass", "[", 
                 RowBox[{
                  RowBox[{"x", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", "D"}], 
               "]"}], "&&", 
              RowBox[{"TrueQ", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"x", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "T2"}], "]"}]}], 
             ",", 
             RowBox[{
              RowBox[{"signsgraph3", "[", 
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{"Flatten", "[", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{
                    RowBox[{"Rank", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], "-", "1"}]}], 
                    "}"}]}], "]"}]}], "}"}], "]"}], ",", 
                    RowBox[{"AlgebraClass", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}]}], "}"}],
                   ",", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", 
                    FractionBox["1", "2"]}], ",", "0", ",", "0"}], "]"}], ",",
                   " ", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"\[CapitalOmega]", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "2"}], ",", 
                    "3", ",", "1"}], "]"}]}], "}"}], "}"}], "]"}], "/.", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 SubscriptBox[
                  RowBox[{"s", "[", "1", "]"}], "i"], "\[Rule]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"MemberQ", "[", 
                    RowBox[{"posi", ",", "i"}], "]"}], ",", 
                   SubscriptBox[
                    RowBox[{"s", "[", "1", "]"}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"tup2", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"tup2", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}]], ",", 
                   SubscriptBox[
                    RowBox[{"b", "[", "1", "]"}], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"tup2", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"tup2", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}]]}], "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "1", ",", 
                  RowBox[{"Length", "[", "tup2", "]"}]}], "}"}]}], "]"}]}], 
             ",", 
             RowBox[{
              RowBox[{"signsgraph", "[", 
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
                    RowBox[{"irrep2", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{"AT", "[", 
                    RowBox[{
                    RowBox[{"TT", "[", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"x", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}]}], "}"}],
                   ",", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"BiMat", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "\[Equal]", 
                    FractionBox["1", "2"]}], ",", "0", ",", "1"}], "]"}]}], 
                 "}"}], "}"}], "]"}], "/.", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 SubscriptBox[
                  RowBox[{"s", "[", "1", "]"}], "i"], "\[Rule]", 
                 SubscriptBox[
                  RowBox[{"b", "[", "1", "]"}], 
                  RowBox[{
                   RowBox[{
                    RowBox[{"tup", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"tup", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}]]}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "1", ",", 
                  RowBox[{"Length", "[", "tup", "]"}]}], "}"}]}], "]"}]}]}], 
            "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Manipulate", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"s1", "[", 
                    RowBox[{"[", "Phase", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"s1", "[", 
                   RowBox[{"[", "Phase", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "//", 
               "MatrixForm"}], ",", 
              RowBox[{"Pane", "[", 
               RowBox[{
                RowBox[{"Control", "@", 
                 RowBox[{"{", 
                  RowBox[{"Phase", ",", 
                   RowBox[{"Table", "[", 
                    RowBox[{"j", ",", 
                    RowBox[{"{", 
                    RowBox[{"j", ",", "1", ",", 
                    RowBox[{"Length", "[", "s1", "]"}]}], "}"}]}], "]"}], ",", 
                   RowBox[{"ControlType", "\[Rule]", "Setter"}], ",", 
                   RowBox[{"BaselinePosition", "\[Rule]", "Center"}], ",", 
                   RowBox[{"Method", "\[Rule]", "\"\<Active\>\""}], ",", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<Horizontal\>\""}]}], 
                  "}"}]}], ",", "Full", ",", 
                RowBox[{"Scrollbars", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"True", ",", "False"}], "}"}]}], ",", 
                RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], 
              ",", 
              RowBox[{
              "FrameLabel", "\[Rule]", 
               "\"\<Choose a Phase for the Matter of the first group\>\""}], 
              ",", 
              RowBox[{"LabelStyle", "\[Rule]", "Medium"}]}], "]"}], ",", 
            RowBox[{"Manipulate", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"s2", "[", 
                    RowBox[{"[", "Phase", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"s2", "[", 
                   RowBox[{"[", "Phase", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "//", 
               "MatrixForm"}], ",", 
              RowBox[{"Pane", "[", 
               RowBox[{
                RowBox[{"Control", "@", 
                 RowBox[{"{", 
                  RowBox[{"Phase", ",", 
                   RowBox[{"Table", "[", 
                    RowBox[{"j", ",", 
                    RowBox[{"{", 
                    RowBox[{"j", ",", "1", ",", 
                    RowBox[{"Length", "[", "s2", "]"}]}], "}"}]}], "]"}], ",", 
                   RowBox[{"ControlType", "\[Rule]", "Setter"}], ",", 
                   RowBox[{"BaselinePosition", "\[Rule]", "Center"}], ",", 
                   RowBox[{"Method", "\[Rule]", "\"\<Active\>\""}], ",", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<Horizontal\>\""}]}], 
                  "}"}]}], ",", "Full", ",", 
                RowBox[{"Scrollbars", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"True", ",", "False"}], "}"}]}], ",", 
                RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], 
              ",", 
              RowBox[{
              "FrameLabel", "\[Rule]", 
               "\"\<Choose a Phase for the Matter of the second group\>\""}], 
              ",", 
              RowBox[{"LabelStyle", "\[Rule]", "Medium"}]}], "]"}], ",", 
            RowBox[{"Manipulate", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"s3", "[", 
                    RowBox[{"[", "Phase", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"s3", "[", 
                   RowBox[{"[", "Phase", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "//", 
               "MatrixForm"}], ",", 
              RowBox[{"Pane", "[", 
               RowBox[{
                RowBox[{"Control", "@", 
                 RowBox[{"{", 
                  RowBox[{"Phase", ",", 
                   RowBox[{"Table", "[", 
                    RowBox[{"j", ",", 
                    RowBox[{"{", 
                    RowBox[{"j", ",", "1", ",", 
                    RowBox[{"Length", "[", "s3", "]"}]}], "}"}]}], "]"}], ",", 
                   RowBox[{"ControlType", "\[Rule]", "Setter"}], ",", 
                   RowBox[{"BaselinePosition", "\[Rule]", "Center"}], ",", 
                   RowBox[{"Method", "\[Rule]", "\"\<Active\>\""}], ",", 
                   RowBox[{"Appearance", "\[Rule]", "\"\<Horizontal\>\""}]}], 
                  "}"}]}], ",", "Full", ",", 
                RowBox[{"Scrollbars", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"True", ",", "False"}], "}"}]}], ",", 
                RowBox[{"AppearanceElements", "\[Rule]", "None"}]}], "]"}], 
              ",", 
              RowBox[{
              "FrameLabel", "\[Rule]", 
               "\"\<Choose a Phase for the Matter of the second group\>\""}], 
              ",", 
              RowBox[{"LabelStyle", "\[Rule]", "Medium"}]}], "]"}]}], "}"}], "//",
           "MatrixForm"}], "]"}]}], "\[IndentingNewLine]", 
       "\[IndentingNewLine]", ",", 
       RowBox[{"Return", "[", "\"\<This Theory does not exist\>\"", "]"}]}], 
      "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SignsKK", "[", "x_", "]"}], ":=", 
   RowBox[{"Which", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "x", "]"}], "\[Equal]", "3"}], ",", 
     RowBox[{"Signs2KK", "[", "x", "]"}], ",", 
     RowBox[{
      RowBox[{"Length", "[", "x", "]"}], "\[Equal]", "2"}], ",", 
     RowBox[{"Signs1KK", "[", "x", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.7780905645415697`*^9, 3.7780906993912487`*^9}, {
   3.778090819100149*^9, 3.7780908343316097`*^9}, {3.778090915460251*^9, 
   3.778091026093217*^9}, {3.7780910567688723`*^9, 3.77809117147759*^9}, {
   3.7780912533957148`*^9, 3.778091358272625*^9}, {3.778091396160912*^9, 
   3.778091442697212*^9}, {3.778091591476791*^9, 3.778091614120253*^9}, {
   3.778091682468945*^9, 3.7780916921631927`*^9}, {3.778091735397447*^9, 
   3.7780917356717157`*^9}, {3.778091852640189*^9, 3.778091898915882*^9}, {
   3.7780920679973087`*^9, 3.7780920688926773`*^9}, {3.7780922754018*^9, 
   3.778092275929473*^9}, {3.778092334199054*^9, 3.778092385417337*^9}, {
   3.778092516063575*^9, 3.778092577512805*^9}, {3.778092635074189*^9, 
   3.778092635491939*^9}, {3.778092695977371*^9, 3.778092887815349*^9}, {
   3.7780929442481327`*^9, 3.778092944476219*^9}, {3.7780942603044233`*^9, 
   3.778094260532607*^9}, {3.778094292166274*^9, 3.7780942996150227`*^9}, {
   3.778094347642363*^9, 3.778094358940658*^9}, {3.778094708349597*^9, 
   3.778094736203933*^9}, {3.778095042521262*^9, 3.778095047151989*^9}, {
   3.778095144259137*^9, 3.778095165297817*^9}, {3.778099470462008*^9, 
   3.7780994709110527`*^9}, {3.778099503522193*^9, 3.778099527383793*^9}, {
   3.7781004857923603`*^9, 3.778100547083417*^9}, 3.778101878535158*^9, {
   3.778108359909004*^9, 3.7781083611752996`*^9}, {3.778108396018849*^9, 
   3.778108407481598*^9}, {3.778108438856488*^9, 3.778108509189033*^9}, {
   3.778109985072998*^9, 3.778109993051429*^9}, {3.778110033008605*^9, 
   3.7781100455022707`*^9}, {3.7781101283576097`*^9, 3.778110142187914*^9}, {
   3.778110198687002*^9, 3.778110293069386*^9}, {3.7781107691222563`*^9, 
   3.778110778716941*^9}, {3.7781111643643913`*^9, 3.778111173813545*^9}, {
   3.7781741510760717`*^9, 3.778174239314249*^9}, 3.7781743197187*^9, {
   3.778175133441359*^9, 3.7781751811687193`*^9}, {3.778175218974246*^9, 
   3.778175258846588*^9}, 3.7781753734125338`*^9, {3.778175454796061*^9, 
   3.778175560980391*^9}, {3.778175639959402*^9, 3.7781756582672853`*^9}, {
   3.778175712100018*^9, 3.778175802456068*^9}, 
   3.778175888270924*^9},ExpressionUUID->"223577c9-613b-4c41-a9e3-\
d493a574fd76"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.778094745785748*^9, 3.7780947468658113`*^9}, 
   3.7780948655091057`*^9},ExpressionUUID->"322ab4b5-53cd-4ff9-ab4f-\
c628482f511b"]
}, Open  ]]
},
WindowSize->{Full, Full},
WindowMargins->{{-1920, Automatic}, {Automatic, -23}},
CommonDefaultFormatTypes->{"Output"->TraditionalForm},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 175, 2, 30, "Input",ExpressionUUID->"6d29c30a-8e23-49f2-89fa-23b59cb62cdf"],
Cell[CellGroupData[{
Cell[758, 26, 129, 2, 30, "Input",ExpressionUUID->"03d160bc-e790-44fd-9405-ff4c8bdf35a3"],
Cell[CellGroupData[{
Cell[912, 32, 368, 8, 20, "Print",ExpressionUUID->"d4c2939d-01fd-4da2-9615-817f73f9e859"],
Cell[1283, 42, 381, 8, 20, "Print",ExpressionUUID->"15bb44f9-b9f7-4e39-9f53-2a5edd4d067e"]
}, Open  ]]
}, Open  ]],
Cell[1691, 54, 395, 6, 94, "Input",ExpressionUUID->"3f21a487-5bb4-4d94-92a1-88347adf60c6"],
Cell[CellGroupData[{
Cell[2111, 64, 311, 5, 54, "Subsection",ExpressionUUID->"67e42ef8-af73-4eff-96a3-3ca683b0c331"],
Cell[2425, 71, 690451, 17550, 24074, "Input",ExpressionUUID->"223577c9-613b-4c41-a9e3-d493a574fd76"],
Cell[692879, 17623, 179, 3, 30, "Input",ExpressionUUID->"322ab4b5-53cd-4ff9-ab4f-c628482f511b"]
}, Open  ]]
}
]
*)

